using System;
using System.Runtime.InteropServices;

namespace Vha.Vss.Security
{
  /// <summary>
  /// .NET wrapper around select Win32 APIs.  Mostly having to do with Impersonation.
  /// See MSDN Win32 SDK for documentation on each of the APIs.
  /// </summary>
  /* WIN32 class used for impersonation.  */
  public class Win32Wrapper 
  {
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
    public static extern bool LogonUser(string userName, string domain, string password,int logonType, int logonProvider, out System.IntPtr hToken);
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
    public static extern bool RevertToSelf();
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
    public static extern bool ImpersonateLoggedOnUser(System.IntPtr hToken);
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
    public static extern bool ImpersonateSelf(int securityImpersonationLevel);
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
    public static extern bool DuplicateToken(System.IntPtr tokenToDup, int securityImpersonationLevel, System.IntPtr hToken);
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("Kernel32.dll", CharSet=CharSet.Auto)]
    public static extern bool CloseHandle(System.IntPtr hToken);


    // **********  NT Security Stuff *************
    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("netapi32.dll", CharSet=CharSet.Auto)]
    public static extern int NetUserChangePassword(string domain, string userName, string oldpassword, string newpassword);
    //    NET_API_STATUS NetUserChangePassword(
    //      LPCWSTR domainname,  
    //      LPCWSTR username,    
    //      LPCWSTR oldpassword, 
    //      LPCWSTR newpassword  
    //      );

    /// <summary>
    /// See MSDN Win32 SDK for documentation on each of the APIs.
    /// </summary>
    [DllImport("netapi32.dll", CharSet=CharSet.Auto)]
    public static extern int NetGetDCName(string serverName, string domainName, out System.IntPtr ptrToMachine);
    //    NET_API_STATUS NetGetDCName(
    //      LPCWSTR servername,  
    //      LPCWSTR domainname,  
    //      LPBYTE *bufptr       
    //      );

  }
}
