﻿
/*

			Class:              Award

			Date Produced:      11/6/2001 9:51:21 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
			
using System;
using System.Collections;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.AwardMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerAwards
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Award : AwardBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerAwards entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Award(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}

		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Award(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Award that will be used to add a record to the VtkVolunteerAwards database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static Award AddRecord(ApplicationConnection appCon)
		{
			Award awardObj = new Award(appCon);
			awardObj.FillDataNew();
			return awardObj;
		}
		
		
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters

		// TODO: There has been no analysis on business rule needs for Awards. FM DD shows very little for this static table file.

		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAwardName(AwardName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAwardCode(AwardCode);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRequiredHours(RequiredHours);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAwardHours(AwardHours);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAwardType(AwardType);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(AwardName, AwardCode, ID);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AwardName property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AwardBase.ValidateAwardName.
		/// </remarks>
		/// <param name="value">Current instance value of AwardName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAwardName(string value)
		{
			ReturnStatus ret = AwardBase.ValidateAwardName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AwardCode property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AwardBase.ValidateAwardCode.
		/// </remarks>
		/// <param name="value">Current instance value of AwardCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAwardCode(string value)
		{
			ReturnStatus ret = AwardBase.ValidateAwardCode(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for RequiredHours property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AwardBase.ValidateRequiredHours.
		/// </remarks>
		/// <param name="value">Current instance value of RequiredHours</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRequiredHours(Int32 value)
		{
			ReturnStatus ret = AwardBase.ValidateRequiredHours(value);
			return ret;
		}

				 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AwardHours property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AwardBase.ValidateAwardHours.
		/// </remarks>
		/// <param name="value">Current instance value of AwardHours</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAwardHours(Int32 value)
		{
			ReturnStatus ret = AwardBase.ValidateAwardHours(value);
			return ret;
		}
 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AwardType property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AwardBase.ValidateAwardType.
		/// </remarks>
		/// <param name="value">Current instance value of AwardType</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAwardType(string value)
		{
			ReturnStatus ret = AwardBase.ValidateAwardType(value);
			return ret;
		}
		 
		private static ReturnStatus CheckForDuplicates(string AwardName, string AwardCode, int ID)
		{			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkAwardExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@AwardName", SqlDbType.VarChar, 45);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= AwardName;

			//These are all Return Parameters and Return Value
			sqlParam							= sqlCmd.Parameters.Add("@AwardCode", SqlDbType.VarChar, 2);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= AwardCode;			

			//These are all Return Parameters and Return Value
			sqlParam							= sqlCmd.Parameters.Add("@AwardId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;

			sqlParam							= sqlCmd.Parameters.Add("@IsAwardNameExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("@IsAwardCodeExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;	

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISAWARDNAMEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsAwardNameExisting"].Value);
			bool RETURN_ISAWARDCODEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsAwardCodeExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Award";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the Awards Code.";		
			}
			else if(RETURN_ISAWARDNAMEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "AwardName";
				ret.ErrorText = "'AwardName'(" + AwardName + ")  already exists, please enter another value.";
			}
			else if(RETURN_ISAWARDCODEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "AwardCode";
				ret.ErrorText = "'AwardCode'(" + AwardCode + ")  already exists, please enter another value.";
			}
			return ret;
		}
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		/// Returns a list of all awards
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <ul><li><b>AwardList</b></li></ul></li>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>Id</b> [int]</li>
		/// <li><b>AwardName</b> [string (45)]</li>
		/// <li><b>AwardCode</b> [string (2)]</li>
		/// <li><b>DisplayName</b> combination of AwardName and AwardCode (i.e. 'AwardName (code)')</li>
		/// <li><b>RequiredHours</b> [int]</li>
		/// <li><b>AwardHours</b> [int]</li>
		/// <li><b>AwardType</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By: None Specified</li>
		///	</ul>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select Id ID, " +
				sqlDrv.awardNameField + " AwardName, " +
				sqlDrv.awardCodeField + " AwardCode, " +
				sqlDrv.awardNameField + " + ' (' + " + sqlDrv.awardCodeField + " + ')' AS DisplayName, " +
				sqlDrv.requiredHoursField + " RequiredHours, " +
				sqlDrv.awardHoursField + " AwardHours, " +
				sqlDrv.awardTypeField     + " AwardType " +
				" FROM " + sqlDrv.tableName;

			return ApplicationConnection.ExecuteQuery(sCommand, "AwardList");
		}
		
		public static DataSet GetQuickListExclude(string sAwardCodeList)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select Id ID, " +
				sqlDrv.awardNameField + " AwardName, " +
				sqlDrv.awardCodeField + " AwardCode, " +
				sqlDrv.awardNameField + " + ' (' + " + sqlDrv.awardCodeField + " + ')' AS DisplayName, " +
				sqlDrv.requiredHoursField + " RequiredHours, " +
				sqlDrv.awardHoursField + " AwardHours, " +
				sqlDrv.awardTypeField     + " AwardType " +
				" FROM " + sqlDrv.tableName ;
			if (sAwardCodeList != string.Empty)
			{
				sCommand = sCommand + " WHERE AwardCode Not In(" + sAwardCodeList + ")";
			}

			return ApplicationConnection.ExecuteQuery(sCommand, "AwardList");
		}

		/// <summary>
		///  Returns a dataset containing the Key Column and External column of
		///  AwardTypes.  The External Column is to display to Users, the Key column
		///  is set to the Award.AwardType property
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns a list of valid Award.AwardType internal and external values
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> AwardTypeList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>Key</b> [string (1)]</li>
		/// <li><b>External</b> [string]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>External</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetAwardTypeList()
		{
			DataSet ds = new DataSet("AwardTypeList");

			DataTable dt = new DataTable("AwardTypeList");
			DataColumn[] keys = new DataColumn[1];
			DataColumn keyCol = new DataColumn("Key",System.Type.GetType("System.String"));
			dt.Columns.Add(keyCol);
			keys[0] = keyCol;
			dt.PrimaryKey = keys;

			DataColumn externalCol = new DataColumn("External",System.Type.GetType("System.String"));
			dt.Columns.Add(externalCol);

			DataRow dr;
			dr = dt.NewRow(); dr["Key"] = "A"; dr["External"] = "Adult"; dt.Rows.Add(dr);
			dr = dt.NewRow(); dr["Key"] = "Y"; dr["External"] = "Youth"; dt.Rows.Add(dr);
			dr = dt.NewRow(); dr["Key"] = "O"; dr["External"] = "Other"; dt.Rows.Add(dr); //not used??

			ds.Tables.Add(dt);
			return ds;
		}

		public static DataSet GetQuickListBy_StationId(int StationId, string AdultYouthBoth, int includeTerminated, DateTime inputEndDate)
		{
			StringBuilder sCommand = new StringBuilder("spQ_VtkPotentialAwardsListingEdit " + StationId.ToString() + ", " + AdultYouthBoth + ", " + includeTerminated.ToString() + ", '" + inputEndDate.ToShortDateString() + "'");
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId", out Success);			
		}

		public static NameObjectCollection GetHoursDRForAwardId(int awardId)
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "Select " +
				 " AwardHours " +
				" FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.idField + " = '" + awardId + "' "; 

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities

		/// <summary>
		/// Test method returning a two dimension object array of award Types
		/// to see if this can be put into a listbox or comboBox using the AddRange method.
		/// </summary>
		/// <param name="appCon"></param>
		/// <returns>
		/// Returns a two dimension object array in the format of
		/// object[internalValue, externalValue]
		/// </returns>
		public static Object[,] GetAwardTypeObjectArray()
		{
			Object [,] awardType = new Object[3,2] {{"Y", "Youth"}, {"A", "Adult"}, {"O", "Other"}};
			return awardType;
		}
	
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
				
		#endregion
		
	}
}
