﻿
/*

			Class:              Organization

			Date Produced:      1/23/2003 1:38:53 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        1/22/2003 8:08:01 AM
			Revision:           656

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM2
			Database:           [VSS_Beta]
			Code generated in:  C:\Olymars Test\1.0.1070.23427\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1070.23427

*/

#define msSql
		
#region Section: Using Declarations
				
using System;
using System.Collections;
using System.Data;
using System.Text.RegularExpressions;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.OrganizationMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerOrganizations
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Organization : OrganizationBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerOrganizations entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Organization(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Organization(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Organization that will be used to add a record to the VtkVolunteerOrganizations database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Organization" /></returns>
		public static Organization AddRecord(ApplicationConnection appCon)
		{
			Organization orgObj = new Organization(appCon);
			orgObj.FillDataNew();
			return orgObj;
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCode(Code);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationName(OrganizationName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAbbreviation(Abbreviation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsInactive(IsInactive);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateScope(Scope);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsOnNationalAdvisoryCommittee(IsOnNationalAdvisoryCommittee);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsNACExecutiveMember(IsNACExecutiveMember);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNACMembershipStatusId(NACMembershipStatusId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAnnualJointReviewMonth(AnnualJointReviewMonth);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(OrganizationName, Code, Abbreviation, Scope, StationId, ID);
			return returnStatus;
		}
		
		private static ReturnStatus CheckForDuplicates(string OrganizationName, string Code, string Abbreviation, string Scope, int StationId, int ID)
		{			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkOrganizationExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@OrganizationName", SqlDbType.VarChar, 35);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= OrganizationName;

			sqlParam							= sqlCmd.Parameters.Add("@Code", SqlDbType.VarChar, 3);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= Code;

			sqlParam							= sqlCmd.Parameters.Add("@Abbreviation", SqlDbType.VarChar, 6);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= Abbreviation;

			sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= "N";
			
			sqlParam							= sqlCmd.Parameters.Add("@StationFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= StationId;
			
			sqlParam							= sqlCmd.Parameters.Add("@OrganizationId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;
			
			//These are all Return Parameters and Return Value
			sqlParam							= sqlCmd.Parameters.Add("@IsOrganizationNameExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("@IsAbbreviationExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISORGANIZATIONNAMEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsOrganizationNameExisting"].Value);
			bool RETURN_ISABBREVIATIONEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsAbbreviationExisting"].Value);
			bool RETURN_ISCODEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsCodeExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Organization";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the Organization table.";		
			}
			else if(RETURN_ISORGANIZATIONNAMEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "OrganizationName";
				if(Scope == "N")
					ret.ErrorText = "'OrganizationName'(" + OrganizationName + ")  already exists Nationally, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate an 'OrganizationName'(" + OrganizationName + ")  which already exists Nationally, please enter another value.";
			}
			else if(RETURN_ISCODEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "Code";
				if(Scope == "N")
                    ret.ErrorText = "'Code'(" + Code + ")  already exists, please enter another value.";
				else if(Scope == "L")
					ret.ErrorText = "This code (" + Code + ")  is outside of the acceptable range for Local Organization Codes, please enter another value.";
			}
			else if(RETURN_ISABBREVIATIONEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "Abbreviation";
				if(Scope == "N")
					ret.ErrorText = "'Abbreviation'(" + Abbreviation + ")  already exists, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate an 'Abbreviation'(" + Abbreviation + ")  which already exists Nationally, please enter another value.";
			}


			if(ret.Status == si.Pass && Scope == "L")
			{
				//Run a DB Check to see if another Volunteer exists with this SSN
				sqlConn					= new SqlConnection(ApplicationConnection.GetConnectionString());

				sqlCmd					= new SqlCommand("VtkOrganizationExistsQuery", sqlConn);
				sqlCmd.CommandType		= CommandType.StoredProcedure;

				sqlParam				= sqlCmd.Parameters.Add("@OrganizationName", SqlDbType.VarChar, 35);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= OrganizationName;

				sqlParam							= sqlCmd.Parameters.Add("@Code", SqlDbType.VarChar, 3);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= Code;

				sqlParam							= sqlCmd.Parameters.Add("@Abbreviation", SqlDbType.VarChar, 6);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= Abbreviation;

				sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= Scope;
			
				sqlParam							= sqlCmd.Parameters.Add("@StationFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= StationId;
			
				sqlParam							= sqlCmd.Parameters.Add("@OrganizationId", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= ID;
			
				//These are all Return Parameters and Return Value
				sqlParam							= sqlCmd.Parameters.Add("@IsOrganizationNameExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam							= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam							= sqlCmd.Parameters.Add("@IsAbbreviationExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.ReturnValue;

				sqlConn.Open();
				sqlCmd.ExecuteNonQuery();

				RETURN_ISORGANIZATIONNAMEEXISTING	= Convert.ToBoolean(sqlCmd.Parameters["@IsOrganizationNameExisting"].Value);
				RETURN_ISABBREVIATIONEXISTING		= Convert.ToBoolean(sqlCmd.Parameters["@IsAbbreviationExisting"].Value);
				RETURN_ISCODEEXISTING				= Convert.ToBoolean(sqlCmd.Parameters["@IsCodeExisting"].Value);
				RETURN_STATUS						= Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
				sqlConn.Close();

				ret						= new ReturnStatus();
				ret.ClassName			= "Organization";

				if(RETURN_STATUS)
				{
					ret.Status = si.Fail;
					ret.ErrorText = "An error accured while checking for duplicates in the Organization table.";		
				}
				else if(RETURN_ISORGANIZATIONNAMEEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "OrganizationName";
					ret.ErrorText = "'OrganizationName'(" + OrganizationName + ")  already exists, please enter another value.";
				}
				else if(RETURN_ISCODEEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "Code";
					ret.ErrorText = "'Code'(" + Code + ")  already exists, please enter another value.";
				}
				else if(RETURN_ISABBREVIATIONEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "Abbreviation";
					ret.ErrorText = "'Abbreviation'(" + Abbreviation + ")  already exists, please enter another value.";
				}
			}
			return ret;
		}

		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Locally scoped code must be associated with a station</description></item>
		/// <item><description>Station can only be associated with locally scoped code</description></item>
		/// <item><description>Local code must be in the 900-999 range</description></item>
		/// <item><description>Code must be unique with scope.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Organization";
			ret.PropertyName = "[Relations Check]";

			if ((this.scope == "L") && (this.stationId <= 0))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Local codes must be associated with a station.";
				return ret;
			}		 

			if ((this.stationId > 0) && (this.scope != "L"))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Organization entries must be have a scope of 'L' (Local) in order to be associated with a station.";
				return ret;
			}		 

			// is it a valid local code
			bool localCode = ((this.scope == "L") && (this.stationId > 0));
			if ((localCode) && (!Regex.IsMatch(this.Code, @"\b9[0-9][0-9]\b")))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Local organization codes must be between 900-999. The code entered is not valid. (Code: " + this.code + ")";
				return ret;
			}
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Code property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns> 
		public static new ReturnStatus ValidateCode(string value, string Scope)
		{
			ReturnStatus ret = OrganizationBase.ValidateCode(value);
			if (ret.Status == si.Fail) return ret;

			if (!Regex.IsMatch(value, @"\b[0-9][0-9][0-9]\b"))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Organization codes must be three digits. The code entered is not valid. (Code: " + value + ")";
				return ret;
			}
			
			if(Scope == "N")
			{
				if(!(Convert.ToInt32(value) > 100) && !(Convert.ToInt32(value) < 900))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "National 'Code'(" + value + ") must be between 100 and 899.";
					return ret;
				}
			}
			else if(Scope == "L")
			{
				if(!(Convert.ToInt32(value) < 1000) && !(Convert.ToInt32(value) > 899))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Local 'Code' (" + value + ") must be between 900 and 999.";
				}
			}
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationName property values.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling OrganizationBase.ValidateOrganizationName.
		/// </remarks>
		/// <param name="value">Current instance value of OrganizationName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateOrganizationName(string value)
		{
			ReturnStatus ret = OrganizationBase.ValidateOrganizationName(value);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for Abbreviation property values.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling OrganizationBase.ValidateAbbreviation.
		/// </remarks>
		/// <param name="value">Current instance value of Abbreviation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAbbreviation(string value)
		{
			ReturnStatus ret = OrganizationBase.ValidateAbbreviation(value);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsInactive property values.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling OrganizationBase.ValidateIsInactive.
		/// </remarks>
		/// <param name="value">Current instance value of IsInactive</param>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		public static new ReturnStatus ValidateIsInactive(bool value)
		{
			ReturnStatus ret = OrganizationBase.ValidateIsInactive(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Scope property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateScope.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = OrganizationBase.ValidateScope(value);
			if (ret.Status == si.Fail) return ret;

			// is it a valid scope value ['L'ocal | 'N'ational]
			if (!Regex.IsMatch(value, @"\b[L|N]\b"))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Scope can be either 'N'ational or 'L'ocal. The value entered is not valid. (Scope: " + value + ")";
				return ret;
			}
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateStationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns> 
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = OrganizationBase.ValidateStationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsOnNationalAdvisoryCommittee property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateIsOnNationalAdvisoryCommittee.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsOnNationalAdvisoryCommittee</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsOnNationalAdvisoryCommittee(bool value)
		{
			ReturnStatus ret = OrganizationBase.ValidateIsOnNationalAdvisoryCommittee(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsNACExecutiveMember property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateIsNACExecutiveMember.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsNACExecutiveMember</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsNACExecutiveMember(bool value)
		{
			ReturnStatus ret = OrganizationBase.ValidateIsNACExecutiveMember(value);
		 
			// TODO: Add property specific validation logic for 'IsNACExecutiveMember'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NACMembershipStatusId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateNACMembershipStatusId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NACMembershipStatusId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNACMembershipStatusId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = OrganizationBase.ValidateNACMembershipStatusId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'NACMembershipStatusId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AnnualJointReviewMonth property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OrganizationBase.ValidateAnnualJointReviewMonth.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AnnualJointReviewMonth</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAnnualJointReviewMonth(Int32 value)
		{
			ReturnStatus ret = OrganizationBase.ValidateAnnualJointReviewMonth(value);
		 
			// TODO: Add property specific validation logic for 'AnnualJointReviewMonth'.
		 
			return ret;
		}
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
				
		#if msSql
		/// <summary>
		/// Returns a list of active orgranizations for a station sorted by name
		/// </summary>
		/// <param name="StationId">Station ID</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Name</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of Name and Code (i.e. 'Name (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>IsInactive</br>
		/// <br>Scope</br>
		/// <br>StationId [int]</br>
		/// <br></br>
		///	<br>Sorted By: OrganizationName</br>
		/// </returns>
		public static DataSet GetSiteActiveQuickListByName(int StationId)
		{
			string sCommand = "Select id ID, " + 
				sqlDrv.organizationNameField   + " Name, " +
				sqlDrv.codeField               + " Code, " +
				sqlDrv.organizationNameField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.abbreviationField       + " Abbreviation, " +
				sqlDrv.isInactiveField         + " IsInactive, " +
				sqlDrv.scopeField              + " Scope, " +
				sqlDrv.stationIdField          + " StationId, " +
				sqlDrv.isOnNationalAdvisoryCommitteeField + " IsOnNationalAdvisoryCommitte, " +
				sqlDrv.isNACExecutiveMemberField + " IsNACExecutiveMember, " +
				sqlDrv.nACMembershipStatusIdField + " NACMembershipStatusId, " +
				sqlDrv.annualJointReviewMonthField + " AnnualJointReviewMonth " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE (" + sqlDrv.isInactiveField + " != '1') " +
				"AND ((" + sqlDrv.scopeField + " = 'N') OR (" 	+ sqlDrv.stationIdField + " = '" + StationId.ToString() + "')) " +
				"ORDER BY " + sqlDrv.organizationNameField;

			return ApplicationConnection.ExecuteQuery(sCommand, "OrganizationList");
		}

		/// <summary>
		/// Returns a list of active orgranizations for a station sorted by code
		/// </summary>
		/// <param name="StationId"></param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Name</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of Name and Code (i.e. 'Name (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>IsInactive</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: Code</br>
		/// </returns>
		public static DataSet GetSiteActiveQuickListByCode(int StationId)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.organizationNameField   + " Name, " +
				sqlDrv.codeField               + " Code, " +
				sqlDrv.organizationNameField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.abbreviationField       + " Abbreviation, " +
				sqlDrv.isInactiveField         + " IsInactive, " +
				sqlDrv.scopeField              + " Scope, " +
				sqlDrv.stationIdField          + " StationId, " +
				sqlDrv.isOnNationalAdvisoryCommitteeField + " IsOnNationalAdvisoryCommitte, " +
				sqlDrv.isNACExecutiveMemberField + " IsNACExecutiveMember, " +
				sqlDrv.nACMembershipStatusIdField + " NACMembershipStatusId, " +
				sqlDrv.annualJointReviewMonthField + " AnnualJointReviewMonth " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE (" + sqlDrv.isInactiveField + " != '1') " +
				"AND ((" + sqlDrv.scopeField + " = 'N') OR (" 	+ sqlDrv.stationIdField + " = '" + StationId.ToString() + "')) " +
				"ORDER BY " + sqlDrv.codeField;

			return ApplicationConnection.ExecuteQuery(sCommand, "OrganizationList");
		}

		/// <summary>
		/// Returns a list of active national orgranizations for a station sorted by code
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Name</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of Name and Code (i.e. 'Name (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>IsInactive</br>
		/// <br>Scope</br>
		/// <br>StationId [int]</br>
		/// <br></br>
		///	<br>Sorted By: Code</br>
		/// </returns>
		public static DataSet GetNationalQuickListByCode()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.organizationNameField   + " Name, " +
				sqlDrv.codeField               + " Code, " +
				sqlDrv.organizationNameField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.abbreviationField       + " Abbreviation, " +
				sqlDrv.isInactiveField         + " IsInactive, " +
				sqlDrv.scopeField              + " Scope, " +
				sqlDrv.stationIdField          + " StationId, " +
				sqlDrv.isOnNationalAdvisoryCommitteeField + " IsOnNationalAdvisoryCommitte, " +
				sqlDrv.isNACExecutiveMemberField + " IsNACExecutiveMember, " +
				sqlDrv.nACMembershipStatusIdField + " NACMembershipStatusId, " +
				sqlDrv.annualJointReviewMonthField + " AnnualJointReviewMonth " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE " + sqlDrv.scopeField + " = 'N' " +
				"ORDER BY " + sqlDrv.codeField;

			return ApplicationConnection.ExecuteQuery(sCommand, "OrganizationList");
		}

		/// <summary>
		/// Returns a list of active orgranizations sorted by name
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Name</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of Name and Code (i.e. 'Name (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>IsInactive</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: Name</br>
		/// </returns>
		public static DataSet GetActiveQuickList()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.organizationNameField   + " Name, " +
				sqlDrv.codeField               + " Code, " +
				sqlDrv.organizationNameField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.abbreviationField       + " Abbreviation, " +
				sqlDrv.isInactiveField         + " IsInactive, " +
				sqlDrv.scopeField              + " Scope, " +
				sqlDrv.stationIdField          + " StationId, " +
				sqlDrv.isOnNationalAdvisoryCommitteeField + " IsOnNationalAdvisoryCommitte, " +
				sqlDrv.isNACExecutiveMemberField + " IsNACExecutiveMember, " +
				sqlDrv.nACMembershipStatusIdField + " NACMembershipStatusId, " +
				sqlDrv.annualJointReviewMonthField + " AnnualJointReviewMonth " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE " + sqlDrv.isInactiveField + " != '1' " +
				"ORDER BY Name";

			return ApplicationConnection.ExecuteQuery(sCommand, "OrganizationList");
		}

		/// <summary>
		/// Returns a list of all orgranizations sorted by name
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Name</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of Name and Code (i.e. 'Name (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>IsInactive</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: Name</br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.organizationNameField   + " Name, " +
				sqlDrv.codeField               + " Code, " +
				sqlDrv.organizationNameField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.abbreviationField       + " Abbreviation, " +
				sqlDrv.isInactiveField         + " IsInactive, " +
				sqlDrv.scopeField              + " Scope, " +
				sqlDrv.stationIdField          + " StationId, " +
				sqlDrv.isOnNationalAdvisoryCommitteeField + " IsOnNationalAdvisoryCommitte, " +
				sqlDrv.isNACExecutiveMemberField + " IsNACExecutiveMember, " +
				sqlDrv.nACMembershipStatusIdField + " NACMembershipStatusId, " +
				sqlDrv.annualJointReviewMonthField + " AnnualJointReviewMonth " +
				"FROM " + sqlDrv.tableName + " " +
				"ORDER BY Name";

			return ApplicationConnection.ExecuteQuery(sCommand, "OrganizationList");
		}
		public static DataSet GetOrganizationsQuickList(int StationId)
		{
			int Success = 0;
			return ApplicationConnection.ExecuteQuery("VtkAllOrganizationsForSiteQuery " + StationId, "AllOrganizations", out Success);
		}
		#endif
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		#endregion
		
	}
}
