﻿/*
	This C# source code was automatically generated using:

		SQL Server Centric .NET Code Generator
			Olymars Library v 1.0.717.34890
			Olymars Utility v 1.0.717.34893

			Generation Date: 1/4/2002 12:48:35 PM
			Generator name: Pascal Belaud
			Template last update: 1/4/2002 12:47:29 PM
			Template revision: 862

			SQL Server version: 08.00.0194
			Server: zzzzzzmul34
			Database: [bizlayer_vha_Vol]
			Code generated in: C:\vm\vss\vtk\businessLayer\GeneratedClasses

	This source is provided "AS IS" without warranty of any kind.
	The author disclaims all warranties, either express or implied, including
	the warranties of merchantability and fitness for a particular purpose.
	In no event shall the author or its suppliers be liable for any damages
	whatsoever including direct, indirect, incidental, consequential, loss of
	business profits or special damages, even if the author or its suppliers
	have been advised of the possibility of such damages.
*/

using System;
using System.Text;
using System.Reflection;
using System.Configuration;

namespace Vha.Vtk.DataClasses {

	/// <summary>	
	/// Constants that describe at which level the exception has occured if one has occured.
	/// </summary>	
	public enum ErrorSourceEnum {
		/// <value>No error has occured during the call</value>
		Err0_NoError = 0,
		/// <value>An error has occured while initializing a SQLConnection object.</value>
		Err1_ConnectionInitialization = 1,
		/// <value>An error has occured while setting some parameters to the SQLCommand object.</value>
		Err2_ParametersSetting = 2,
		/// <value>An error has occured while opening the SQLConnection object.</value>
		Err3_ConnectionOpening = 3,
		/// <value>An error has occured while executing the SQLCommand object.</value>
		Err4_QueryExecution = 4,
		/// <value>An error has occured while retrieving some parameters from the SQLCommand object.</value>
		Err5_ParametersRetrieval = 5,
		/// <value>An unhandled error has occured during the call.</value>
		Err6_Other = 6
	};

	/// <summary>
	/// [To be supplied.]
	/// </summary>
	public interface IErrorInformation
	{
		/// <summary>
		/// [To be supplied.]
		/// </summary>
		System.Exception OtherException { get; }
		/// <summary>
		/// [To be supplied.]
		/// </summary>
		System.Data.SqlClient.SqlException SqlException { get; }
		/// <summary>
		/// [To be supplied.]
		/// </summary>
		ErrorSourceEnum ErrorSource { get; }
		/// <summary>
		/// [To be supplied.]
		/// </summary>
		string StoredProcedureName { get; }
	}

	/// <summary>
	/// [To be supplied.]
	/// </summary>
	[Serializable()]
	public class Information
	{
		private static string ConnectionString = "";

		/// <summary>
		/// [To be supplied.]
		/// </summary>
		static public string GetConnectionStringFromRegistry()
		{
			if (ConnectionString != "")
				return(ConnectionString);

			Microsoft.Win32.RegistryKey RK = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\\ConnectionStrings\\bizlayer_vha_Vol", false);
			ConnectionString = RK.GetValue("ConnectionString").ToString();
			RK.Close();

			if (ConnectionString == null)
				return("");
			else
				return(ConnectionString);
		}

		/// <summary>
		/// [To be supplied.]
		/// </summary>
		static public System.Version Version
		{
			get
			{
				return (System.Reflection.Assembly.GetExecutingAssembly().GetName().Version);
			}
		}

		/// <summary>
		/// Build an connection string using a SQL Server account. The connection time-out is set to 15 seconds. The connections pooling is not set.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="UserID">SQL Server user account.</param>
		/// <param name="Password">Password for the SQL Server account.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, string UserID, string Password)
		{
			return(InternalBuildConnectionString(Server, Database, false, UserID, Password, 15, false));
		}

		/// <summary>
		/// Build an connection string using a SQL Server account. The connection time-out is set to 15 seconds.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="UserID">SQL Server user account.</param>
		/// <param name="Password">Password for the SQL Server account.</param>
		/// <param name="Pooling">True if connections pooling is desired.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, string UserID, string Password, bool Pooling)
		{
			return(InternalBuildConnectionString(Server, Database, false, UserID, Password, 15, Pooling));
		}

		/// <summary>
		/// Build an connection string using the current Windows logged on user (Integrated Security). The connection time-out is set to 15 seconds. The connections pooling is not set.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database)
		{
			return(InternalBuildConnectionString(Server, Database, true, "", "", 15, false));
		}

		/// <summary>
		/// Build an connection string using the current Windows logged on user (Integrated Security). The connection time-out is set to 15 seconds.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="Pooling">True if connections pooling is desired.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, bool Pooling)
		{
			return(InternalBuildConnectionString(Server, Database, true, "", "", 15, Pooling));
		}

		/// <summary>
		/// Build an connection string using a SQL Server account. The connections pooling is not set.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="UserID">SQL Server user account.</param>
		/// <param name="Password">Password for the SQL Server account.</param>
		/// <param name="ConnectionTimeOut">The connection time-out in seconds.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, string UserID, string Password, short ConnectionTimeOut)
		{
			return(InternalBuildConnectionString(Server, Database, false, UserID, Password, ConnectionTimeOut, false));
		}

		/// <summary>
		/// Build an connection string using a SQL Server account.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="UserID">SQL Server user account.</param>
		/// <param name="Password">Password for the SQL Server account.</param>
		/// <param name="ConnectionTimeOut">The connection time-out in seconds.</param>
		/// <param name="Pooling">True if connections pooling is desired.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, string UserID, string Password, short ConnectionTimeOut, bool Pooling)
		{
			return(InternalBuildConnectionString(Server, Database, false, UserID, Password, ConnectionTimeOut, Pooling));
		}

		/// <summary>
		/// Build an connection string using the current Windows logged on user (Integrated Security). The connections pooling is not set.
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="ConnectionTimeOut">The connection time-out in seconds.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, short ConnectionTimeOut)
		{
			return(InternalBuildConnectionString(Server, Database, true, "", "", ConnectionTimeOut, false));
		}

		/// <summary>
		/// Build an connection string using the current Windows logged on user (Integrated Security).
		/// </summary>
		/// <param name="Server">SQL Server name (can be an named instance, i.e. SERVER\INSTANCE).</param>
		/// <param name="Database">SQL Server Database name.</param>
		/// <param name="ConnectionTimeOut">The connection time-out in seconds.</param>
		/// <param name="Pooling">True if connections pooling is desired.</param>
		/// <returns>The connection string.</returns>
		static public string BuildConnectionString(string Server, string Database, short ConnectionTimeOut, bool Pooling)
		{
			return(InternalBuildConnectionString(Server, Database, true, "", "", ConnectionTimeOut, Pooling));
		}

		private static string InternalBuildConnectionString(string Server, string Database, bool IntegratedSecurity, string UserID, string Password, short TimeOut, bool Pooling)
		{
			StringBuilder connectionString = new StringBuilder();

			connectionString.Append("Data Source=");
			connectionString.Append(Server);
			connectionString.Append(";");

			connectionString.Append("Initial Catalog=");
			connectionString.Append(Database);
			connectionString.Append(";");

			if (IntegratedSecurity) {
				connectionString.Append("Integrated Security=SSPI;");
			}
			else {
				connectionString.Append("User ID=");
				connectionString.Append(UserID);
				connectionString.Append(";");

				connectionString.Append("Password=");
				connectionString.Append(Password);
				connectionString.Append(";");
			}
			connectionString.Append("Pooling=");
			connectionString.Append(Pooling.ToString());
			connectionString.Append(";");

			connectionString.Append("Connect Timeout=");
			connectionString.Append(TimeOut.ToString());
			connectionString.Append(";");

			return (connectionString.ToString());
		}
	}

}
