﻿
/*

			Class:              AwardBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVolunteerAwards
	/// </summary>
	public abstract class AwardBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardName database field
		/// </summary>
		protected internal string  awardName;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardCode database field
		/// </summary>
		protected internal string  awardCode;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.RequiredHours database field
		/// </summary>
		protected internal Int32  requiredHours;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardHours database field
		/// </summary>
		protected internal Int32  awardHours;

		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardType database field
		/// </summary>
		protected internal string  awardType;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to awardName class field
		/// </summary>
		public string  AwardName
		{
			get { return awardName;}    set {isChanged = true; awardName = value;}
		}
		
		/// <summary>
		/// Property that maps to awardCode class field
		/// </summary>
		public string  AwardCode
		{
			get { return awardCode;}    set {isChanged = true; awardCode = value;}
		}
		
		/// <summary>
		/// Property that maps to requiredHours class field
		/// </summary>
		public Int32  RequiredHours
		{
			get { return requiredHours;}    set {isChanged = true; requiredHours = value;}
		}
		
		/// <summary>
		/// Property that maps to awardHours class field
		/// </summary>
		public Int32  AwardHours
		{
			get { return awardHours;}    set {isChanged = true; awardHours = value;}
		}

		/// <summary>
		/// Property that maps to awardType class field
		/// </summary>
		public string  AwardType
		{
			get { return awardType;}    set {isChanged = true; awardType = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor used by [Vha.Vtk.Common.Award.AddRecord].
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		/// <References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// </References>
		protected AwardBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <Params>
		/// <param name="id" type="System.Int">Primary key value for VtkVolunteerAwards entry</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection">See Refs.</param>
		/// </Params>
		/// <References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// </References>
		protected AwardBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <Params>
		/// <param name="dr" type="DataRow">DataRow for entry in VtkVolunteerAwards</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		/// <remarks>
		/// Column names in DataRow are the same as those in VtkVolunteerAwards definition.
		///
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </remarks>
		/// <References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// </References>
		protected AwardBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[AwardMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		/// <returns type="void"/>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			awardName = string.Empty;
			awardCode = string.Empty;
			requiredHours = Int32.MinValue;
			awardHours = Int32.MinValue;
			awardType = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new AwardMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of Award.
		/// </summary>
		/// <returns type="void"/>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for AwardName property values
		/// </summary>
		/// <Params>
		/// <param name="value" type="System.String">Current instance value of AwardName</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		/// <Errors>
		///		<Error Code="TX_AwardName_Empty" Description="'AwardName' is a required. No value is entered."/>
		///		<Error Code="TX_AwardName_Length" Description="'AwardName' length ([Value Length]) is greater than 45 characters."/>
		/// </Errors>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		protected static ReturnStatus ValidateAwardName(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Award";
			ret.PropertyName = "AwardName";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardName' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 45))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardName' length (" + value.Length +  ") is greater than 45 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for AwardCode property values
		/// </summary>
		/// <Params>
		/// <param name="value" type="System.String">Current instance value of AwardCode</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		/// <Errors>
		///		<Error Code="TX_AwardCode_Empty" Description="'AwardCode' is a required. No value is entered."/>
		///		<Error Code="TX_AwardLength_Length" Description="'AwardCode' length ([Value Length]) is greater than 2 characters."/>
		/// </Errors>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		protected static ReturnStatus ValidateAwardCode(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Award";
			ret.PropertyName = "AwardCode";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardCode' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 2))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardCode' length (" + value.Length +  ") is greater than 2 characters.";
			}
			

			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for RequiredHours property values
		/// </summary>
		/// <Params>
		/// <param name="value">Current instance value of RequiredHours</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		/// <Errors>
		///		<Error Code="TX_RequiredHours_MinValue" Description="'RequiredHours' is a required. No value is entered."/>
		/// </Errors>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		protected static ReturnStatus ValidateRequiredHours(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Award";
			ret.PropertyName = "RequiredHours";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'RequiredHours' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for AwardHours property values
		/// </summary>
		/// <Params>
		/// <param name="value">Current instance value of AwardHours</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		/// <Errors>
		///		<Error Code="TX_AwardHours_MinValue" Description="'AwardHours' is a required. No value is entered."/>
		/// </Errors>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		protected static ReturnStatus ValidateAwardHours(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Award";
			ret.PropertyName = "AwardHours";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardHours' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for AwardType property values
		/// </summary>
		/// <Params>
		/// <param name="value" type="System.String">Current instance value of AwardType</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		/// <Errors>
		///		<Error Code="TX_AwardType_Length" Description="'AwardType' length ([Value Length]) is greater than 1 character."/>
		/// </Errors>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		protected static ReturnStatus ValidateAwardType(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Award";
			ret.PropertyName = "AwardType";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AwardType' length (" + value.Length +  ") is greater than 1 character.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <OrderedList type="bullet">
		///		<ListItem>This method saves inserts, updates and deletes to VtkVolunteerAwards.</ListItem>
		///		<ListItem>For inserts, updates field validation is performed.</ListItem>
		/// </OrderedList>
		///<Exceptions>
		///<Table col1="Exception" col2="Description">
		///<Row col1="VhaValidationException" col2="The Exception depends on what Class and Property set the Exception. See Individual Class Properties for details."/>
		///</Table>
		///</Exceptions>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.VhaValidationException(System.String, System.String, System.String)"/>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		/// </References>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVolunteerAwards table for the specified idValue
		/// </summary>
		/// <Params>
		/// <param name="idValue" type="System.Int">Primary key value for VtkVolunteerAwards entry</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection">See Refs.</param>
		/// </Params>
		/// <returns type="Bool">
		///		<OrderedList type="bullet">
		///			<ListItem> true : entry exists in database</ListItem>
		///			<ListItem> false : entry does not exists in database</ListItem>
		///		</OrderedList>
		/// </returns>
		/// <References>
		///		<seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// </References>
		public static bool DoesExist(int idValue)
		{
			return AwardMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <Params>
		/// <param name="prop">Name of the property</param>
		/// </Params>
		/// <returns type="System.String"/>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "AwardName")  {return awardName.ToString();}
			if (prop == "AwardCode")  {return awardCode.ToString();}
			if (prop == "RequiredHours")  {return requiredHours.ToString();}
			if (prop == "AwardHours")  {return awardHours.ToString();}
			if (prop == "AwardType")  {return awardType.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
