﻿
/*

			Class:              AwardMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerAwards
	/// </summary>
	public class AwardMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private AwardBase awardObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerAwards)
		/// </summary>
		public static string tableName = "VtkVolunteerAwards";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardName database field
		/// </summary>
		public const string awardNameField = "AwardName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardCode database field
		/// </summary>
		public const string awardCodeField = "AwardCode";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.RequiredHours database field
		/// </summary>
		public const string requiredHoursField = "RequiredHours";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardHours database field
		/// </summary>
		public const string awardHoursField = "AwardHours";

		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.AwardType database field
		/// </summary>
		public const string awardTypeField = "AwardType";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAwards.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "awardObj"></param>
		public AwardMsSqlSrv(AwardBase awardObj)
		{
			Initialize(awardObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "awardObj"></param>
		private void Initialize(AwardBase awardObj)
		{
			this.awardObj = awardObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = awardObj.AppCon;
			this.databaseTableName = AwardMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = AwardMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(awardObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Award instance. Invalid ID: " + awardObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				awardObj.id = (Int32)dr[idField];
			}
			else
			{
				awardObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(awardNameField))
			{
				awardObj.awardName = (string)dr[awardNameField];
			}
			else
			{
				awardObj.awardName = string.Empty;
			}
		
			if (!dr.IsNull(awardCodeField))
			{
				awardObj.awardCode = (string)dr[awardCodeField];
			}
			else
			{
				awardObj.awardCode = string.Empty;
			}
		
			if (!dr.IsNull(requiredHoursField))
			{
				awardObj.requiredHours = (Int32)dr[requiredHoursField];
			}
			else
			{
				awardObj.requiredHours = Int32.MinValue;
			}
		
			if (!dr.IsNull(awardHoursField))
			{
				awardObj.awardHours = (Int32)dr[awardHoursField];
			}
			else
			{
				awardObj.awardHours = Int32.MinValue;
			}

			if (!dr.IsNull(awardTypeField))
			{
				awardObj.awardType = (string)dr[awardTypeField];
			}
			else
			{
				awardObj.awardType = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				awardObj.version = (Int32)dr[versionField];
			}
			else
			{
				awardObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerAwards spParam = new spParams.spI_VtkVolunteerAwards ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._AwardName = awardObj.awardName;
			spParam._AwardCode = awardObj.awardCode;
			spParam._RequiredHours = awardObj.requiredHours;
			spParam._AwardHours = awardObj.awardHours;
			spParam._Ver = awardObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (awardObj.awardType != string.Empty) {spParam._AwardType = awardObj.awardType;}
	
			spSProcs.spI_VtkVolunteerAwards spSProc = new spSProcs.spI_VtkVolunteerAwards();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {awardObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Award", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return awardObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[AwardMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerAwards spParam = new spParams.spU_VtkVolunteerAwards();
 
			if (awardObj.IsChanged && (!awardObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerAwards spSProc = new spSProcs.spU_VtkVolunteerAwards(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Award", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (awardObj.awardName == string.Empty && !dr.IsNull(awardNameField))  {return true;} 
			else
			if (awardObj.awardCode == string.Empty && !dr.IsNull(awardCodeField))  {return true;} 
			else
			if (awardObj.requiredHours == Int32.MinValue && !dr.IsNull(requiredHoursField))  {return true;} 
			else
			if (awardObj.awardHours == Int32.MinValue && !dr.IsNull(awardHoursField))  {return true;} 
			else
			if (awardObj.awardType == string.Empty && !dr.IsNull(awardTypeField))  {return true;} 
			else
			if (awardObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerAwards spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  awardObj.id; 
			spParam._AwardName =  awardObj.awardName; 
			spParam._AwardCode =  awardObj.awardCode; 
			spParam._RequiredHours =  awardObj.requiredHours; 
			spParam._AwardHours =  awardObj.awardHours; 
			spParam._Ver =  awardObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (awardObj.awardType != string.Empty)  {spParam._AwardType = awardObj.awardType;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerAwards spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = awardObj.id; 
			spParam._AwardName = awardObj.awardName; 
			spParam._AwardCode = awardObj.awardCode; 
			spParam._RequiredHours = awardObj.requiredHours; 
			spParam._AwardHours = awardObj.awardHours; 
			spParam._Ver =  awardObj.version; 
	
			//awardType property
			if (!dr.IsNull(awardTypeField))
			{ 
				if (awardObj.awardType != (string)dr[awardTypeField]) 
				{ 
					spParam._AwardType = awardObj.awardType; 
				} 
			} 
			else if (awardObj.awardType != string.Empty)
			{ 
				spParam._AwardType = awardObj.awardType; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (awardObj.id > 0)
			{
				spParams.spD_VtkVolunteerAwards spParam = new spParams.spD_VtkVolunteerAwards ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = awardObj.id;
				spParam._Ver = awardObj.version; 
				spSProcs.spD_VtkVolunteerAwards spSProc = new spSProcs.spD_VtkVolunteerAwards();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Award", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + AwardMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, AwardMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
