﻿
/*

			Class:              CombinationAssignmentBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVolunteerCombinationAssignments
	/// </summary>
	[Serializable()]
	public abstract class CombinationAssignmentBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.VolunteerStationProfilesFK database field
		/// </summary>
		protected internal Int32  stationProfileId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.OrganizationFK database field
		/// </summary>
		protected internal Int32  organizationId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.WorkdayScheduleFK database field
		/// </summary>
		protected internal Int32  workdayScheduleId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.BenefitingServiceFK database field
		/// </summary>
		protected internal Int32  benefitingServiceId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.CombinationCode database field
		/// </summary>
		protected internal string  combinationCode;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.IsInactive database field
		/// </summary>
		protected internal bool  isInactive;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to stationProfileId class field
		/// </summary>
		public Int32  StationProfileId
		{
			get { return stationProfileId;}    set {isChanged = true; stationProfileId = value;}
		}
		
		/// <summary>
		/// Property that maps to organizationId class field
		/// </summary>
		public Int32  OrganizationId
		{
			get { return organizationId;}    set {isChanged = true; organizationId = value;}
		}
		
		/// <summary>
		/// Property that maps to workdayScheduleId class field
		/// </summary>
		public Int32  WorkdayScheduleId
		{
			get { return workdayScheduleId;}    set {isChanged = true; workdayScheduleId = value;}
		}
		
		/// <summary>
		/// Property that maps to benefitingServiceId class field
		/// </summary>
		public Int32  BenefitingServiceId
		{
			get { return benefitingServiceId;}    set {isChanged = true; benefitingServiceId = value;}
		}
		
		/// <summary>
		/// Property that maps to combinationCode class field
		/// </summary>
		public string  CombinationCode
		{
			get { return combinationCode;}    set {isChanged = true; combinationCode = value;}
		}
		
		/// <summary>
		/// Property that maps to isInactive class field
		/// </summary>
		public bool  IsInactive
		{
			get { return isInactive;}    set {isChanged = true; isInactive = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected CombinationAssignmentBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerCombinationAssignments entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected CombinationAssignmentBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVolunteerCombinationAssignments</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVolunteerCombinationAssignments definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected CombinationAssignmentBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[CombinationAssignmentMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			stationProfileId = Int32.MinValue;
			organizationId = Int32.MinValue;
			workdayScheduleId = Int32.MinValue;
			benefitingServiceId = Int32.MinValue;
			combinationCode = string.Empty;
			isInactive = false;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new CombinationAssignmentMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of CombinationAssignment.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for StationProfileId property values
		/// </summary>
		/// <param name="value">Current instance value of StationProfileId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStationProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "StationProfileId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationProfileId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationProfileBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationProfileId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for OrganizationId property values
		/// </summary>
		/// <param name="value">Current instance value of OrganizationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "OrganizationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'OrganizationId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!OrganizationBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'OrganizationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for WorkdayScheduleId property values
		/// </summary>
		/// <param name="value">Current instance value of WorkdayScheduleId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateWorkdayScheduleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "WorkdayScheduleId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'WorkdayScheduleId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ScheduleWorkdayBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'WorkdayScheduleId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for BenefitingServiceId property values
		/// </summary>
		/// <param name="value">Current instance value of BenefitingServiceId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateBenefitingServiceId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "BenefitingServiceId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'BenefitingServiceId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ServiceBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'BenefitingServiceId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for CombinationCode property values
		/// </summary>
		/// <param name="value">Current instance value of CombinationCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateCombinationCode(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "CombinationCode";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'CombinationCode' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 8))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'CombinationCode' length (" + value.Length +  ") is greater than 8 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsInactive property values
		/// </summary>
		/// <param name="value">Current instance value of IsInactive</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateIsInactive(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "CombinationAssignment";
			ret.PropertyName = "IsInactive";
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVolunteerCombinationAssignments.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			// Refresh not done on Save() for collection data to prevent deadly embrace (locking problems)
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVolunteerCombinationAssignments table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVolunteerCombinationAssignments entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return CombinationAssignmentMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "StationProfileId")  {return stationProfileId.ToString();}
			if (prop == "OrganizationId")  {return organizationId.ToString();}
			if (prop == "WorkdayScheduleId")  {return workdayScheduleId.ToString();}
			if (prop == "BenefitingServiceId")  {return benefitingServiceId.ToString();}
			if (prop == "CombinationCode")  {return combinationCode.ToString();}
			if (prop == "IsInactive")  {return isInactive.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
