﻿
/*

			Class:              GamesRegistrationMsSqlSrv

			Date Produced:      02/27/2003 12:37:57 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        02/27/2003 9:10:36 AM
			Revision:           673

			SQL Server Version: 08.00.0760
			Server:             ISF-LANGLEYM
			Database:           [VSS_Games_Test]
			Code generated in:  D:\Olymars_test\1.0.1070.23427\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1070.23427

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkGamesRegistration
	/// </summary>
	public class GamesRegistrationMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private GamesRegistrationBase gamesObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkGamesRegistration)
		/// </summary>
		public static string tableName = "VtkGamesRegistration";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.VolunteerStationProfilesFK database field
		/// </summary>
		public const string stationProfilesIdField = "VolunteerStationProfilesFK";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.VAEmployeeStatusFK database field
		/// </summary>
		public const string vaEmployeeStatusIdField = "VAEmployeeStatusFK";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.GameScheduleFK database field
		/// </summary>
		public const string gameScheduleIdField = "GameScheduleFK";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.ShirtSizeFK database field
		/// </summary>
		public const string shirtSizeIdField = "ShirtSizeFK";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.TransportationStatus database field
		/// </summary>
		public const string transportationStatusField = "TransportationStatus";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.TransportationStation database field
		/// </summary>
		public const string transportationStationField = "TransportationStation";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.LodgingCode database field
		/// </summary>
		public const string lodgingCodeField = "LodgingCode";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.FirstTimeParticipant database field
		/// </summary>
		public const string firstTimeParticipantField = "FirstTimeParticipant";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.StartDate database field
		/// </summary>
		public const string startDateField = "StartDate";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.EndDate database field
		/// </summary>
		public const string endDateField = "EndDate";
		
		/// <summary>
		/// Class field that maps to VtkGamesRegistration.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "gamesObj"></param>
		public GamesRegistrationMsSqlSrv(GamesRegistrationBase gamesObj)
		{
			Initialize(gamesObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "gamesObj"></param>
		private void Initialize(GamesRegistrationBase gamesObj)
		{
			this.gamesObj = gamesObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = gamesObj.AppCon;
			this.databaseTableName = GamesRegistrationMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = GamesRegistrationMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(gamesObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create GamesRegistration instance. Invalid ID: " + gamesObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				gamesObj.id = (Int32)dr[idField];
			}
			else
			{
				gamesObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationProfilesIdField))
			{
				gamesObj.stationProfilesId = (Int32)dr[stationProfilesIdField];
			}
			else
			{
				gamesObj.stationProfilesId = Int32.MinValue;
			}
		
			if (!dr.IsNull(vaEmployeeStatusIdField))
			{
				gamesObj.vaEmployeeStatusId = (Int32)dr[vaEmployeeStatusIdField];
			}
			else
			{
				gamesObj.vaEmployeeStatusId = Int32.MinValue;
			}
		
			if (!dr.IsNull(gameScheduleIdField))
			{
				gamesObj.gameScheduleId = (Int32)dr[gameScheduleIdField];
			}
			else
			{
				gamesObj.gameScheduleId = Int32.MinValue;
			}
		
			if (!dr.IsNull(shirtSizeIdField))
			{
				gamesObj.shirtSizeId = (Int32)dr[shirtSizeIdField];
			}
			else
			{
				gamesObj.shirtSizeId = Int32.MinValue;
			}
		
			if (!dr.IsNull(transportationStatusField))
			{
				gamesObj.transportationStatus = (bool)dr[transportationStatusField];
			}
			else
			{
				gamesObj.transportationStatus = false;
			}
		
			if (!dr.IsNull(transportationStationField))
			{
				gamesObj.transportationStation = (string)dr[transportationStationField];
			}
			else
			{
				gamesObj.transportationStation = string.Empty;
			}
		
			if (!dr.IsNull(lodgingCodeField))
			{
				gamesObj.lodgingCode = (string)dr[lodgingCodeField];
			}
			else
			{
				gamesObj.lodgingCode = string.Empty;
			}
		
			if (!dr.IsNull(firstTimeParticipantField))
			{
				gamesObj.firstTimeParticipant = (bool)dr[firstTimeParticipantField];
			}
			else
			{
				gamesObj.firstTimeParticipant = false;
			}
		
			if (!dr.IsNull(startDateField))
			{
				gamesObj.startDate = (DateTime)dr[startDateField];
			}
			else
			{
				gamesObj.startDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(endDateField))
			{
				gamesObj.endDate = (DateTime)dr[endDateField];
			}
			else
			{
				gamesObj.endDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				gamesObj.version = (Int32)dr[versionField];
			}
			else
			{
				gamesObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkGamesRegistration spParam = new spParams.spI_VtkGamesRegistration ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._GameScheduleFK = gamesObj.gameScheduleId;
			spParam._TransportationStatus = gamesObj.transportationStatus;
			spParam._LodgingCode = gamesObj.lodgingCode;
			spParam._FirstTimeParticipant = gamesObj.firstTimeParticipant;
			spParam._Ver = gamesObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (gamesObj.stationProfilesId != Int32.MinValue) {spParam._VolunteerStationProfilesFK = gamesObj.stationProfilesId;}
			if (gamesObj.vaEmployeeStatusId != Int32.MinValue) {spParam._VAEmployeeStatusFK = gamesObj.vaEmployeeStatusId;}
			if (gamesObj.shirtSizeId != Int32.MinValue) {spParam._ShirtSizeFK = gamesObj.shirtSizeId;}
			if (gamesObj.transportationStation != string.Empty) {spParam._TransportationStation = gamesObj.transportationStation;}
			if (gamesObj.startDate != DateTime.MinValue) {spParam._StartDate = gamesObj.startDate;}
			if (gamesObj.endDate != DateTime.MinValue) {spParam._EndDate = gamesObj.endDate;}
	
			spSProcs.spI_VtkGamesRegistration spSProc = new spSProcs.spI_VtkGamesRegistration();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {gamesObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("GamesRegistration", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return gamesObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[GamesRegistrationMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkGamesRegistration spParam = new spParams.spU_VtkGamesRegistration();
 
			if (gamesObj.IsChanged && (!gamesObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkGamesRegistration spSProc = new spSProcs.spU_VtkGamesRegistration(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("GamesRegistration", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (gamesObj.stationProfilesId == Int32.MinValue && !dr.IsNull(stationProfilesIdField))  {return true;} 
			else
			if (gamesObj.vaEmployeeStatusId == Int32.MinValue && !dr.IsNull(vaEmployeeStatusIdField))  {return true;} 
			else
			if (gamesObj.gameScheduleId == Int32.MinValue && !dr.IsNull(gameScheduleIdField))  {return true;} 
			else
			if (gamesObj.shirtSizeId == Int32.MinValue && !dr.IsNull(shirtSizeIdField))  {return true;} 
			else
			if (gamesObj.transportationStatus == false && !dr.IsNull(transportationStatusField))  {return true;} 
			else
			if (gamesObj.transportationStation == string.Empty && !dr.IsNull(transportationStationField))  {return true;} 
			else
			if (gamesObj.lodgingCode == string.Empty && !dr.IsNull(lodgingCodeField))  {return true;} 
			else
			if (gamesObj.firstTimeParticipant == false && !dr.IsNull(firstTimeParticipantField))  {return true;} 
			else
			if (gamesObj.startDate == DateTime.MinValue && !dr.IsNull(startDateField))  {return true;} 
			else
			if (gamesObj.endDate == DateTime.MinValue && !dr.IsNull(endDateField))  {return true;} 
			else
			if (gamesObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkGamesRegistration spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  gamesObj.id; 
			spParam._GameScheduleFK =  gamesObj.gameScheduleId; 
			spParam._TransportationStatus =  gamesObj.transportationStatus; 
			spParam._LodgingCode =  gamesObj.lodgingCode; 
			spParam._FirstTimeParticipant =  gamesObj.firstTimeParticipant; 
			spParam._Ver =  gamesObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (gamesObj.stationProfilesId != Int32.MinValue)  {spParam._VolunteerStationProfilesFK = gamesObj.stationProfilesId;}
			if (gamesObj.vaEmployeeStatusId != Int32.MinValue)  {spParam._VAEmployeeStatusFK = gamesObj.vaEmployeeStatusId;}
			if (gamesObj.shirtSizeId != Int32.MinValue)  {spParam._ShirtSizeFK = gamesObj.shirtSizeId;}
			if (gamesObj.transportationStation != string.Empty)  {spParam._TransportationStation = gamesObj.transportationStation;}
			if (gamesObj.startDate != DateTime.MinValue)  {spParam._StartDate = gamesObj.startDate;}
			if (gamesObj.endDate != DateTime.MinValue)  {spParam._EndDate = gamesObj.endDate;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkGamesRegistration spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = gamesObj.id; 
			spParam._GameScheduleFK = gamesObj.gameScheduleId; 
			spParam._TransportationStatus = gamesObj.transportationStatus; 
			spParam._LodgingCode = gamesObj.lodgingCode; 
			spParam._FirstTimeParticipant = gamesObj.firstTimeParticipant; 
			spParam._Ver =  gamesObj.version; 
	
			//stationProfilesId property
			if (!dr.IsNull(stationProfilesIdField))
			{ 
				if (gamesObj.stationProfilesId != (Int32)dr[stationProfilesIdField]) 
				{ 
					spParam._VolunteerStationProfilesFK = gamesObj.stationProfilesId; 
				} 
			} 
			else if (gamesObj.stationProfilesId != Int32.MinValue)
			{ 
				spParam._VolunteerStationProfilesFK = gamesObj.stationProfilesId; 
			} 
	
			//vaEmployeeStatusId property
			if (!dr.IsNull(vaEmployeeStatusIdField))
			{ 
				if (gamesObj.vaEmployeeStatusId != (Int32)dr[vaEmployeeStatusIdField]) 
				{ 
					spParam._VAEmployeeStatusFK = gamesObj.vaEmployeeStatusId; 
				} 
			} 
			else if (gamesObj.vaEmployeeStatusId != Int32.MinValue)
			{ 
				spParam._VAEmployeeStatusFK = gamesObj.vaEmployeeStatusId; 
			} 
	
			//shirtSizeId property
			if (!dr.IsNull(shirtSizeIdField))
			{ 
				if (gamesObj.shirtSizeId != (Int32)dr[shirtSizeIdField]) 
				{ 
					spParam._ShirtSizeFK = gamesObj.shirtSizeId; 
				} 
			} 
			else if (gamesObj.shirtSizeId != Int32.MinValue)
			{ 
				spParam._ShirtSizeFK = gamesObj.shirtSizeId; 
			} 
	
			//transportationStation property
			if (!dr.IsNull(transportationStationField))
			{ 
				if (gamesObj.transportationStation != (string)dr[transportationStationField]) 
				{ 
					spParam._TransportationStation = gamesObj.transportationStation; 
				} 
			} 
			else if (gamesObj.transportationStation != string.Empty)
			{ 
				spParam._TransportationStation = gamesObj.transportationStation; 
			} 
	
			//startDate property
			if (!dr.IsNull(startDateField))
			{ 
				if (gamesObj.startDate != (DateTime)dr[startDateField]) 
				{ 
					spParam._StartDate = gamesObj.startDate; 
				} 
			} 
			else if (gamesObj.startDate != DateTime.MinValue)
			{ 
				spParam._StartDate = gamesObj.startDate; 
			} 
	
			//endDate property
			if (!dr.IsNull(endDateField))
			{ 
				if (gamesObj.endDate != (DateTime)dr[endDateField]) 
				{ 
					spParam._EndDate = gamesObj.endDate; 
				} 
			} 
			else if (gamesObj.endDate != DateTime.MinValue)
			{ 
				spParam._EndDate = gamesObj.endDate; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (gamesObj.id > 0)
			{
				spParams.spD_VtkGamesRegistration spParam = new spParams.spD_VtkGamesRegistration ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = gamesObj.id;
				spParam._Ver = gamesObj.version; 
				spSProcs.spD_VtkGamesRegistration spSProc = new spSProcs.spD_VtkGamesRegistration();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("GamesRegistration", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + GamesRegistrationMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue, ApplicationConnection appCon)
		{
			return MsSqlDataSrv.DoesExist(idValue, GamesRegistrationMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
