﻿
/*

			Class:              GamesScheduleMsSqlSrv

			Date Produced:      11/21/2002 12:13:25 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkGamesSchedule
	/// </summary>
	public class GamesScheduleMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private GamesScheduleBase gmsObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkGamesSchedule)
		/// </summary>
		public static string tableName = "VtkGamesSchedule";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.HostStationFk database field
		/// </summary>
		public const string hostStationFkField = "HostStationFk";
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.GameTypeFk database field
		/// </summary>
		public const string gameTypeFkField = "GameTypeFk";
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.StartDate database field
		/// </summary>
		public const string startDateField = "StartDate";
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.EndDate database field
		/// </summary>
		public const string endDateField = "EndDate";
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "gmsObj"></param>
		public GamesScheduleMsSqlSrv(GamesScheduleBase gmsObj)
		{
			Initialize(gmsObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "gmsObj"></param>
		private void Initialize(GamesScheduleBase gmsObj)
		{
			this.gmsObj = gmsObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = gmsObj.AppCon;
			this.databaseTableName = GamesScheduleMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = GamesScheduleMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(gmsObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create GamesSchedule instance. Invalid ID: " + gmsObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				gmsObj.id = (Int32)dr[idField];
			}
			else
			{
				gmsObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(hostStationFkField))
			{
				gmsObj.hostStationFk = (Int32)dr[hostStationFkField];
			}
			else
			{
				gmsObj.hostStationFk = Int32.MinValue;
			}
		
			if (!dr.IsNull(gameTypeFkField))
			{
				gmsObj.gameTypeFk = (Int32)dr[gameTypeFkField];
			}
			else
			{
				gmsObj.gameTypeFk = Int32.MinValue;
			}
		
			if (!dr.IsNull(startDateField))
			{
				gmsObj.startDate = (DateTime)dr[startDateField];
			}
			else
			{
				gmsObj.startDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(endDateField))
			{
				gmsObj.endDate = (DateTime)dr[endDateField];
			}
			else
			{
				gmsObj.endDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				gmsObj.version = (Int32)dr[versionField];
			}
			else
			{
				gmsObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkGamesSchedule spParam = new spParams.spI_VtkGamesSchedule ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._HostStationFk = gmsObj.hostStationFk;
			spParam._GameTypeFk = gmsObj.gameTypeFk;
			spParam._StartDate = gmsObj.startDate;
			spParam._EndDate = gmsObj.endDate;
			spParam._Ver = gmsObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkGamesSchedule spSProc = new spSProcs.spI_VtkGamesSchedule();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {gmsObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("GamesSchedule", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return gmsObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[GamesScheduleMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkGamesSchedule spParam = new spParams.spU_VtkGamesSchedule();
 
			if (gmsObj.IsChanged && (!gmsObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkGamesSchedule spSProc = new spSProcs.spU_VtkGamesSchedule(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("GamesSchedule", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (gmsObj.hostStationFk == Int32.MinValue && !dr.IsNull(hostStationFkField))  {return true;} 
			else
			if (gmsObj.gameTypeFk == Int32.MinValue && !dr.IsNull(gameTypeFkField))  {return true;} 
			else
			if (gmsObj.startDate == DateTime.MinValue && !dr.IsNull(startDateField))  {return true;} 
			else
			if (gmsObj.endDate == DateTime.MinValue && !dr.IsNull(endDateField))  {return true;} 
			else
			if (gmsObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkGamesSchedule spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  gmsObj.id; 
			spParam._HostStationFk =  gmsObj.hostStationFk; 
			spParam._GameTypeFk =  gmsObj.gameTypeFk; 
			spParam._StartDate =  gmsObj.startDate; 
			spParam._EndDate =  gmsObj.endDate; 
			spParam._Ver =  gmsObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkGamesSchedule spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = gmsObj.id; 
			spParam._HostStationFk = gmsObj.hostStationFk; 
			spParam._GameTypeFk = gmsObj.gameTypeFk; 
			spParam._StartDate = gmsObj.startDate; 
			spParam._EndDate = gmsObj.endDate; 
			spParam._Ver =  gmsObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (gmsObj.id > 0)
			{
				spParams.spD_VtkGamesSchedule spParam = new spParams.spD_VtkGamesSchedule ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = gmsObj.id;
				spParam._Ver = gmsObj.version; 
				spSProcs.spD_VtkGamesSchedule spSProc = new spSProcs.spD_VtkGamesSchedule();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("GamesSchedule", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + GamesScheduleMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, GamesScheduleMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
