﻿
/*

			Class:              InstitutionMsSqlSrv

			Date Produced:      4/3/2002 1:15:13 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkInstitutions
	/// </summary>
	public class InstitutionMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private InstitutionBase instObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkInstitutions)
		/// </summary>
		public static string tableName = "VtkInstitutions";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.NameOfInstitution database field
		/// </summary>
		public const string nameOfInstitutionField = "NameOfInstitution";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.StationNumber database field
		/// </summary>
		public const string stationNumberField = "StationNumber";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.ParentInstitutionFK database field
		/// </summary>
		public const string parentInstitutionIdField = "ParentInstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.AdministrativeParentFK database field
		/// </summary>
		public const string administrativeParentIdField = "AdministrativeParentFK";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.StreetAddress1 database field
		/// </summary>
		public const string streetAddress1Field = "StreetAddress1";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.StreetAddress2 database field
		/// </summary>
		public const string streetAddress2Field = "StreetAddress2";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.City database field
		/// </summary>
		public const string cityField = "City";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.StateFK database field
		/// </summary>
		public const string stateIdField = "StateFK";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.ZipCode database field
		/// </summary>
		public const string zipCodeField = "ZipCode";
		
		/// <summary>
		/// Class field that maps to VtkInstitutions.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "instObj"></param>
		public InstitutionMsSqlSrv(InstitutionBase instObj)
		{
			Initialize(instObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "instObj"></param>
		private void Initialize(InstitutionBase instObj)
		{
			this.instObj = instObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = instObj.AppCon;
			this.databaseTableName = InstitutionMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = InstitutionMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(instObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Institution instance. Invalid ID: " + instObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				instObj.id = (Int32)dr[idField];
			}
			else
			{
				instObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(nameOfInstitutionField))
			{
				instObj.nameOfInstitution = (string)dr[nameOfInstitutionField];
			}
			else
			{
				instObj.nameOfInstitution = string.Empty;
			}
		
			if (!dr.IsNull(stationNumberField))
			{
				instObj.stationNumber = (string)dr[stationNumberField];
			}
			else
			{
				instObj.stationNumber = string.Empty;
			}
		
			if (!dr.IsNull(parentInstitutionIdField))
			{
				instObj.parentInstitutionId = (Int32)dr[parentInstitutionIdField];
			}
			else
			{
				instObj.parentInstitutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(administrativeParentIdField))
			{
				instObj.administrativeParentId = (Int32)dr[administrativeParentIdField];
			}
			else
			{
				instObj.administrativeParentId = Int32.MinValue;
			}
		
			if (!dr.IsNull(streetAddress1Field))
			{
				instObj.streetAddress1 = (string)dr[streetAddress1Field];
			}
			else
			{
				instObj.streetAddress1 = string.Empty;
			}
		
			if (!dr.IsNull(streetAddress2Field))
			{
				instObj.streetAddress2 = (string)dr[streetAddress2Field];
			}
			else
			{
				instObj.streetAddress2 = string.Empty;
			}
		
			if (!dr.IsNull(cityField))
			{
				instObj.city = (string)dr[cityField];
			}
			else
			{
				instObj.city = string.Empty;
			}
		
			if (!dr.IsNull(stateIdField))
			{
				instObj.stateId = (Int32)dr[stateIdField];
			}
			else
			{
				instObj.stateId = Int32.MinValue;
			}
		
			if (!dr.IsNull(zipCodeField))
			{
				instObj.zipCode = (string)dr[zipCodeField];
			}
			else
			{
				instObj.zipCode = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				instObj.version = (Int32)dr[versionField];
			}
			else
			{
				instObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkInstitutions spParam = new spParams.spI_VtkInstitutions ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._NameOfInstitution = instObj.nameOfInstitution;
			spParam._StationNumber = instObj.stationNumber;
			spParam._AdministrativeParentFK = instObj.administrativeParentId;
			spParam._StateFK = instObj.stateId;
			spParam._Ver = instObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (instObj.parentInstitutionId != Int32.MinValue) {spParam._ParentInstitutionFK = instObj.parentInstitutionId;}
			if (instObj.streetAddress1 != string.Empty) {spParam._StreetAddress1 = instObj.streetAddress1;}
			if (instObj.streetAddress2 != string.Empty) {spParam._StreetAddress2 = instObj.streetAddress2;}
			if (instObj.city != string.Empty) {spParam._City = instObj.city;}
			if (instObj.zipCode != string.Empty) {spParam._ZipCode = instObj.zipCode;}
	
			spSProcs.spI_VtkInstitutions spSProc = new spSProcs.spI_VtkInstitutions();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {instObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Institution", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return instObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[InstitutionMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkInstitutions spParam = new spParams.spU_VtkInstitutions();
 
			if (instObj.IsChanged && (!instObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkInstitutions spSProc = new spSProcs.spU_VtkInstitutions(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Institution", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (instObj.nameOfInstitution == string.Empty && !dr.IsNull(nameOfInstitutionField))  {return true;} 
			else
			if (instObj.stationNumber == string.Empty && !dr.IsNull(stationNumberField))  {return true;} 
			else
			if (instObj.parentInstitutionId == Int32.MinValue && !dr.IsNull(parentInstitutionIdField))  {return true;} 
			else
			if (instObj.administrativeParentId == Int32.MinValue && !dr.IsNull(administrativeParentIdField))  {return true;} 
			else
			if (instObj.streetAddress1 == string.Empty && !dr.IsNull(streetAddress1Field))  {return true;} 
			else
			if (instObj.streetAddress2 == string.Empty && !dr.IsNull(streetAddress2Field))  {return true;} 
			else
			if (instObj.city == string.Empty && !dr.IsNull(cityField))  {return true;} 
			else
			if (instObj.stateId == Int32.MinValue && !dr.IsNull(stateIdField))  {return true;} 
			else
			if (instObj.zipCode == string.Empty && !dr.IsNull(zipCodeField))  {return true;} 
			else
			if (instObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkInstitutions spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  instObj.id; 
			spParam._NameOfInstitution =  instObj.nameOfInstitution; 
			spParam._StationNumber =  instObj.stationNumber; 
			spParam._AdministrativeParentFK =  instObj.administrativeParentId; 
			spParam._StateFK =  instObj.stateId; 
			spParam._Ver =  instObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (instObj.parentInstitutionId != Int32.MinValue)  {spParam._ParentInstitutionFK = instObj.parentInstitutionId;}
			if (instObj.streetAddress1 != string.Empty)  {spParam._StreetAddress1 = instObj.streetAddress1;}
			if (instObj.streetAddress2 != string.Empty)  {spParam._StreetAddress2 = instObj.streetAddress2;}
			if (instObj.city != string.Empty)  {spParam._City = instObj.city;}
			if (instObj.zipCode != string.Empty)  {spParam._ZipCode = instObj.zipCode;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkInstitutions spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = instObj.id; 
			spParam._NameOfInstitution = instObj.nameOfInstitution; 
			spParam._StationNumber = instObj.stationNumber; 
			spParam._AdministrativeParentFK = instObj.administrativeParentId; 
			spParam._StateFK = instObj.stateId; 
			spParam._Ver =  instObj.version; 
	
			//parentInstitutionId property
			if (!dr.IsNull(parentInstitutionIdField))
			{ 
				if (instObj.parentInstitutionId != (Int32)dr[parentInstitutionIdField]) 
				{ 
					spParam._ParentInstitutionFK = instObj.parentInstitutionId; 
				} 
			} 
			else if (instObj.parentInstitutionId != Int32.MinValue)
			{ 
				spParam._ParentInstitutionFK = instObj.parentInstitutionId; 
			} 
	
			//streetAddress1 property
			if (!dr.IsNull(streetAddress1Field))
			{ 
				if (instObj.streetAddress1 != (string)dr[streetAddress1Field]) 
				{ 
					spParam._StreetAddress1 = instObj.streetAddress1; 
				} 
			} 
			else if (instObj.streetAddress1 != string.Empty)
			{ 
				spParam._StreetAddress1 = instObj.streetAddress1; 
			} 
	
			//streetAddress2 property
			if (!dr.IsNull(streetAddress2Field))
			{ 
				if (instObj.streetAddress2 != (string)dr[streetAddress2Field]) 
				{ 
					spParam._StreetAddress2 = instObj.streetAddress2; 
				} 
			} 
			else if (instObj.streetAddress2 != string.Empty)
			{ 
				spParam._StreetAddress2 = instObj.streetAddress2; 
			} 
	
			//city property
			if (!dr.IsNull(cityField))
			{ 
				if (instObj.city != (string)dr[cityField]) 
				{ 
					spParam._City = instObj.city; 
				} 
			} 
			else if (instObj.city != string.Empty)
			{ 
				spParam._City = instObj.city; 
			} 
	
			//zipCode property
			if (!dr.IsNull(zipCodeField))
			{ 
				if (instObj.zipCode != (string)dr[zipCodeField]) 
				{ 
					spParam._ZipCode = instObj.zipCode; 
				} 
			} 
			else if (instObj.zipCode != string.Empty)
			{ 
				spParam._ZipCode = instObj.zipCode; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (instObj.id > 0)
			{
				spParams.spD_VtkInstitutions spParam = new spParams.spD_VtkInstitutions ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = instObj.id;
				spParam._Ver = instObj.version; 
				spSProcs.spD_VtkInstitutions spSProc = new spSProcs.spD_VtkInstitutions();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Institution", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + InstitutionMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, InstitutionMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
