﻿
/*

			Class:              OccasionalHoursMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkOccasionalVolunteerTimeSheets
	/// </summary>
	public class OccasionalHoursMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private OccasionalHoursBase ohrsObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkOccasionalVolunteerTimeSheets)
		/// </summary>
		public static string tableName = "VtkOccasionalVolunteerTimeSheets";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.Comments database field
		/// </summary>
		public const string commentsField = "Comments";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.OrganizationFK database field
		/// </summary>
		public const string organizationIdField = "OrganizationFK";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.ServiceAssignmentFK database field
		/// </summary>
		public const string serviceAssignmentIdField = "ServiceAssignmentFK";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.NumberInGroup database field
		/// </summary>
		public const string numberInGroupField = "NumberInGroup";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.TotalHours database field
		/// </summary>
		public const string totalHoursField = "TotalHours";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.DateWorkProvided database field
		/// </summary>
		public const string dateWorkProvidedField = "DateWorkProvided";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.RecordStatus database field
		/// </summary>
		public const string recordStatusField = "RecordStatus";
		
		/// <summary>
		/// Class field that maps to VtkOccasionalVolunteerTimeSheets.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "ohrsObj"></param>
		public OccasionalHoursMsSqlSrv(OccasionalHoursBase ohrsObj)
		{
			Initialize(ohrsObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "ohrsObj"></param>
		private void Initialize(OccasionalHoursBase ohrsObj)
		{
			this.ohrsObj = ohrsObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = ohrsObj.AppCon;
			this.databaseTableName = OccasionalHoursMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = OccasionalHoursMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(ohrsObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create OccasionalHours instance. Invalid ID: " + ohrsObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				ohrsObj.id = (Int32)dr[idField];
			}
			else
			{
				ohrsObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				ohrsObj.stationId = (Int32)dr[stationIdField];
			}
			else
			{
				ohrsObj.stationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(commentsField))
			{
				ohrsObj.comments = (string)dr[commentsField];
			}
			else
			{
				ohrsObj.comments = string.Empty;
			}
		
			if (!dr.IsNull(organizationIdField))
			{
				ohrsObj.organizationId = (Int32)dr[organizationIdField];
			}
			else
			{
				ohrsObj.organizationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(serviceAssignmentIdField))
			{
				ohrsObj.serviceAssignmentId = (Int32)dr[serviceAssignmentIdField];
			}
			else
			{
				ohrsObj.serviceAssignmentId = Int32.MinValue;
			}
		
			if (!dr.IsNull(numberInGroupField))
			{
				ohrsObj.numberInGroup = (Int32)dr[numberInGroupField];
			}
			else
			{
				ohrsObj.numberInGroup = Int32.MinValue;
			}
		
			if (!dr.IsNull(totalHoursField))
			{
				ohrsObj.totalHours = (Int32)dr[totalHoursField];
			}
			else
			{
				ohrsObj.totalHours = Int32.MinValue;
			}
		
			if (!dr.IsNull(dateWorkProvidedField))
			{
				ohrsObj.dateWorkProvided = (DateTime)dr[dateWorkProvidedField];
			}
			else
			{
				ohrsObj.dateWorkProvided = DateTime.MinValue;
			}
		
			if (!dr.IsNull(recordStatusField))
			{
				ohrsObj.recordStatus = (string)dr[recordStatusField];
			}
			else
			{
				ohrsObj.recordStatus = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				ohrsObj.version = (Int32)dr[versionField];
			}
			else
			{
				ohrsObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkOccasionalVolunteerTimeSheets spParam = new spParams.spI_VtkOccasionalVolunteerTimeSheets ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._StationFK = ohrsObj.stationId;
			spParam._OrganizationFK = ohrsObj.organizationId;
			spParam._ServiceAssignmentFK = ohrsObj.serviceAssignmentId;
			spParam._NumberInGroup = ohrsObj.numberInGroup;
			spParam._TotalHours = ohrsObj.totalHours;
			spParam._DateWorkProvided = ohrsObj.dateWorkProvided;
			spParam._RecordStatus = ohrsObj.recordStatus;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (ohrsObj.comments != string.Empty) {spParam._Comments = ohrsObj.comments;}
			if (ohrsObj.version == Int32.MinValue) {spParam._Ver = (1);} // set to default Value 
			else {spParam._Ver = ohrsObj.version;}
	
			spSProcs.spI_VtkOccasionalVolunteerTimeSheets spSProc = new spSProcs.spI_VtkOccasionalVolunteerTimeSheets();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {ohrsObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("OccasionalHours", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return ohrsObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[OccasionalHoursMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkOccasionalVolunteerTimeSheets spParam = new spParams.spU_VtkOccasionalVolunteerTimeSheets();
 
			if (ohrsObj.IsChanged && (!ohrsObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkOccasionalVolunteerTimeSheets spSProc = new spSProcs.spU_VtkOccasionalVolunteerTimeSheets(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("OccasionalHours", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (ohrsObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (ohrsObj.comments == string.Empty && !dr.IsNull(commentsField))  {return true;} 
			else
			if (ohrsObj.organizationId == Int32.MinValue && !dr.IsNull(organizationIdField))  {return true;} 
			else
			if (ohrsObj.serviceAssignmentId == Int32.MinValue && !dr.IsNull(serviceAssignmentIdField))  {return true;} 
			else
			if (ohrsObj.numberInGroup == Int32.MinValue && !dr.IsNull(numberInGroupField))  {return true;} 
			else
			if (ohrsObj.totalHours == Int32.MinValue && !dr.IsNull(totalHoursField))  {return true;} 
			else
			if (ohrsObj.dateWorkProvided == DateTime.MinValue && !dr.IsNull(dateWorkProvidedField))  {return true;} 
			else
			if (ohrsObj.recordStatus == string.Empty && !dr.IsNull(recordStatusField))  {return true;} 
			else
			if (ohrsObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkOccasionalVolunteerTimeSheets spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  ohrsObj.id; 
			spParam._StationFK =  ohrsObj.stationId; 
			spParam._OrganizationFK =  ohrsObj.organizationId; 
			spParam._ServiceAssignmentFK =  ohrsObj.serviceAssignmentId; 
			spParam._NumberInGroup =  ohrsObj.numberInGroup; 
			spParam._TotalHours =  ohrsObj.totalHours; 
			spParam._DateWorkProvided =  ohrsObj.dateWorkProvided; 
			spParam._RecordStatus =  ohrsObj.recordStatus; 
			spParam._Ver =  ohrsObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (ohrsObj.comments != string.Empty)  {spParam._Comments = ohrsObj.comments;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkOccasionalVolunteerTimeSheets spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = ohrsObj.id; 
			spParam._StationFK = ohrsObj.stationId; 
			spParam._OrganizationFK = ohrsObj.organizationId; 
			spParam._ServiceAssignmentFK = ohrsObj.serviceAssignmentId; 
			spParam._NumberInGroup = ohrsObj.numberInGroup; 
			spParam._TotalHours = ohrsObj.totalHours; 
			spParam._DateWorkProvided = ohrsObj.dateWorkProvided; 
			spParam._RecordStatus = ohrsObj.recordStatus; 
			spParam._Ver =  ohrsObj.version; 
	
			//comments property
			if (!dr.IsNull(commentsField))
			{ 
				if (ohrsObj.comments != (string)dr[commentsField]) 
				{ 
					spParam._Comments = ohrsObj.comments; 
				} 
			} 
			else if (ohrsObj.comments != string.Empty)
			{ 
				spParam._Comments = ohrsObj.comments; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (ohrsObj.id > 0)
			{
				spParams.spD_VtkOccasionalVolunteerTimeSheets spParam = new spParams.spD_VtkOccasionalVolunteerTimeSheets ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = ohrsObj.id;
				spParam._Ver = ohrsObj.version; 
				spSProcs.spD_VtkOccasionalVolunteerTimeSheets spSProc = new spSProcs.spD_VtkOccasionalVolunteerTimeSheets();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("OccasionalHours", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + OccasionalHoursMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, OccasionalHoursMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
