﻿
/*

			Class:              OrganizationMsSqlSrv

			Date Produced:      1/23/2003 1:38:53 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        1/22/2003 8:08:01 AM
			Revision:           656

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM2
			Database:           [VSS_Beta]
			Code generated in:  C:\Olymars Test\1.0.1070.23427\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1070.23427

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerOrganizations
	/// </summary>
	public class OrganizationMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private OrganizationBase orgObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerOrganizations)
		/// </summary>
		public static string tableName = "VtkVolunteerOrganizations";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.Code database field
		/// </summary>
		public const string codeField = "Code";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.OrganizationName database field
		/// </summary>
		public const string organizationNameField = "OrganizationName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.Abbreviation database field
		/// </summary>
		public const string abbreviationField = "Abbreviation";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.IsInactive database field
		/// </summary>
		public const string isInactiveField = "IsInactive";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.Scope database field
		/// </summary>
		public const string scopeField = "Scope";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.IsOnNationalAdvisoryCommittee database field
		/// </summary>
		public const string isOnNationalAdvisoryCommitteeField = "IsOnNationalAdvisoryCommittee";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.IsNACExecutiveMember database field
		/// </summary>
		public const string isNACExecutiveMemberField = "IsNACExecutiveMember";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.NACMembershipStatusFK database field
		/// </summary>
		public const string nACMembershipStatusIdField = "NACMembershipStatusFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.AnnualJointReviewMonth database field
		/// </summary>
		public const string annualJointReviewMonthField = "AnnualJointReviewMonth";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerOrganizations.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "orgObj"></param>
		public OrganizationMsSqlSrv(OrganizationBase orgObj)
		{
			Initialize(orgObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "orgObj"></param>
		private void Initialize(OrganizationBase orgObj)
		{
			this.orgObj = orgObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = orgObj.AppCon;
			this.databaseTableName = OrganizationMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = OrganizationMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(orgObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Organization instance. Invalid ID: " + orgObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				orgObj.id = (Int32)dr[idField];
			}
			else
			{
				orgObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(codeField))
			{
				orgObj.code = (string)dr[codeField];
			}
			else
			{
				orgObj.code = string.Empty;
			}
		
			if (!dr.IsNull(organizationNameField))
			{
				orgObj.organizationName = (string)dr[organizationNameField];
			}
			else
			{
				orgObj.organizationName = string.Empty;
			}
		
			if (!dr.IsNull(abbreviationField))
			{
				orgObj.abbreviation = (string)dr[abbreviationField];
			}
			else
			{
				orgObj.abbreviation = string.Empty;
			}
		
			if (!dr.IsNull(isInactiveField))
			{
				orgObj.isInactive = (bool)dr[isInactiveField];
			}
			else
			{
				orgObj.isInactive = false;
			}
		
			if (!dr.IsNull(scopeField))
			{
				orgObj.scope = (string)dr[scopeField];
			}
			else
			{
				orgObj.scope = string.Empty;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				orgObj.stationId = (Int32)dr[stationIdField];
			}
			else
			{
				orgObj.stationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(isOnNationalAdvisoryCommitteeField))
			{
				orgObj.isOnNationalAdvisoryCommittee = (bool)dr[isOnNationalAdvisoryCommitteeField];
			}
			else
			{
				orgObj.isOnNationalAdvisoryCommittee = false;
			}
		
			if (!dr.IsNull(isNACExecutiveMemberField))
			{
				orgObj.isNACExecutiveMember = (bool)dr[isNACExecutiveMemberField];
			}
			else
			{
				orgObj.isNACExecutiveMember = false;
			}
		
			if (!dr.IsNull(nACMembershipStatusIdField))
			{
				orgObj.nACMembershipStatusId = (Int32)dr[nACMembershipStatusIdField];
			}
			else
			{
				orgObj.nACMembershipStatusId = Int32.MinValue;
			}
		
			if (!dr.IsNull(annualJointReviewMonthField))
			{
				orgObj.annualJointReviewMonth = (Int32)dr[annualJointReviewMonthField];
			}
			else
			{
				orgObj.annualJointReviewMonth = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				orgObj.version = (Int32)dr[versionField];
			}
			else
			{
				orgObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerOrganizations spParam = new spParams.spI_VtkVolunteerOrganizations ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Code = orgObj.code;
			spParam._OrganizationName = orgObj.organizationName;
			spParam._IsInactive = orgObj.isInactive;
			spParam._Scope = orgObj.scope;
			spParam._IsOnNationalAdvisoryCommittee = orgObj.isOnNationalAdvisoryCommittee;
			spParam._IsNACExecutiveMember = orgObj.isNACExecutiveMember;
			spParam._Ver = orgObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (orgObj.abbreviation != string.Empty) {spParam._Abbreviation = orgObj.abbreviation;}
			if (orgObj.stationId != Int32.MinValue) {spParam._StationFK = orgObj.stationId;}
			if (orgObj.nACMembershipStatusId != Int32.MinValue) {spParam._NACMembershipStatusFK = orgObj.nACMembershipStatusId;}
			if (orgObj.annualJointReviewMonth != Int32.MinValue) {spParam._AnnualJointReviewMonth = orgObj.annualJointReviewMonth;}
	
			spSProcs.spI_VtkVolunteerOrganizations spSProc = new spSProcs.spI_VtkVolunteerOrganizations();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {orgObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Organization", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return orgObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[OrganizationMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerOrganizations spParam = new spParams.spU_VtkVolunteerOrganizations();
 
			if (orgObj.IsChanged && (!orgObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerOrganizations spSProc = new spSProcs.spU_VtkVolunteerOrganizations(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Organization", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (orgObj.code == string.Empty && !dr.IsNull(codeField))  {return true;} 
			else
			if (orgObj.organizationName == string.Empty && !dr.IsNull(organizationNameField))  {return true;} 
			else
			if (orgObj.abbreviation == string.Empty && !dr.IsNull(abbreviationField))  {return true;} 
			else
			if (orgObj.isInactive == false && !dr.IsNull(isInactiveField))  {return true;} 
			else
			if (orgObj.scope == string.Empty && !dr.IsNull(scopeField))  {return true;} 
			else
			if (orgObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (orgObj.isOnNationalAdvisoryCommittee == false && !dr.IsNull(isOnNationalAdvisoryCommitteeField))  {return true;} 
			else
			if (orgObj.isNACExecutiveMember == false && !dr.IsNull(isNACExecutiveMemberField))  {return true;} 
			else
			if (orgObj.nACMembershipStatusId == Int32.MinValue && !dr.IsNull(nACMembershipStatusIdField))  {return true;} 
			else
			if (orgObj.annualJointReviewMonth == Int32.MinValue && !dr.IsNull(annualJointReviewMonthField))  {return true;} 
			else
			if (orgObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerOrganizations spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  orgObj.id; 
			spParam._Code =  orgObj.code; 
			spParam._OrganizationName =  orgObj.organizationName; 
			spParam._IsInactive =  orgObj.isInactive; 
			spParam._Scope =  orgObj.scope; 
			spParam._IsOnNationalAdvisoryCommittee =  orgObj.isOnNationalAdvisoryCommittee; 
			spParam._IsNACExecutiveMember =  orgObj.isNACExecutiveMember; 
			spParam._Ver =  orgObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (orgObj.abbreviation != string.Empty)  {spParam._Abbreviation = orgObj.abbreviation;}
			if (orgObj.stationId != Int32.MinValue)  {spParam._StationFK = orgObj.stationId;}
			if (orgObj.nACMembershipStatusId != Int32.MinValue)  {spParam._NACMembershipStatusFK = orgObj.nACMembershipStatusId;}
			if (orgObj.annualJointReviewMonth != Int32.MinValue)  {spParam._AnnualJointReviewMonth = orgObj.annualJointReviewMonth;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerOrganizations spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = orgObj.id; 
			spParam._Code = orgObj.code; 
			spParam._OrganizationName = orgObj.organizationName; 
			spParam._IsInactive = orgObj.isInactive; 
			spParam._Scope = orgObj.scope; 
			spParam._IsOnNationalAdvisoryCommittee = orgObj.isOnNationalAdvisoryCommittee; 
			spParam._IsNACExecutiveMember = orgObj.isNACExecutiveMember; 
			spParam._Ver =  orgObj.version; 
	
			//abbreviation property
			if (!dr.IsNull(abbreviationField))
			{ 
				if (orgObj.abbreviation != (string)dr[abbreviationField]) 
				{ 
					spParam._Abbreviation = orgObj.abbreviation; 
				} 
			} 
			else if (orgObj.abbreviation != string.Empty)
			{ 
				spParam._Abbreviation = orgObj.abbreviation; 
			} 
	
			//stationId property
			if (!dr.IsNull(stationIdField))
			{ 
				if (orgObj.stationId != (Int32)dr[stationIdField]) 
				{ 
					spParam._StationFK = orgObj.stationId; 
				} 
			} 
			else if (orgObj.stationId != Int32.MinValue)
			{ 
				spParam._StationFK = orgObj.stationId; 
			} 
	
			//nACMembershipStatusId property
			if (!dr.IsNull(nACMembershipStatusIdField))
			{ 
				if (orgObj.nACMembershipStatusId != (Int32)dr[nACMembershipStatusIdField]) 
				{ 
					spParam._NACMembershipStatusFK = orgObj.nACMembershipStatusId; 
				} 
			} 
			else if (orgObj.nACMembershipStatusId != Int32.MinValue)
			{ 
				spParam._NACMembershipStatusFK = orgObj.nACMembershipStatusId; 
			} 
	
			//annualJointReviewMonth property
			if (!dr.IsNull(annualJointReviewMonthField))
			{ 
				if (orgObj.annualJointReviewMonth != (Int32)dr[annualJointReviewMonthField]) 
				{ 
					spParam._AnnualJointReviewMonth = orgObj.annualJointReviewMonth; 
				} 
			} 
			else if (orgObj.annualJointReviewMonth != Int32.MinValue)
			{ 
				spParam._AnnualJointReviewMonth = orgObj.annualJointReviewMonth; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (orgObj.id > 0)
			{
				spParams.spD_VtkVolunteerOrganizations spParam = new spParams.spD_VtkVolunteerOrganizations ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = orgObj.id;
				spParam._Ver = orgObj.version; 
				spSProcs.spD_VtkVolunteerOrganizations spSProc = new spSProcs.spD_VtkVolunteerOrganizations();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Organization", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + OrganizationMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, OrganizationMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
