﻿
/*

			Class:              ScheduleWorkdayMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerScheduleWorkdays
	/// </summary>
	public class ScheduleWorkdayMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ScheduleWorkdayBase swdObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerScheduleWorkdays)
		/// </summary>
		public static string tableName = "VtkVolunteerScheduleWorkdays";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Code database field
		/// </summary>
		public const string codeField = "Code";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Days database field
		/// </summary>
		public const string daysField = "Days";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.AppearsAs database field
		/// </summary>
		public const string appearsAsField = "AppearsAs";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "swdObj"></param>
		public ScheduleWorkdayMsSqlSrv(ScheduleWorkdayBase swdObj)
		{
			Initialize(swdObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "swdObj"></param>
		private void Initialize(ScheduleWorkdayBase swdObj)
		{
			this.swdObj = swdObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = swdObj.AppCon;
			this.databaseTableName = ScheduleWorkdayMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ScheduleWorkdayMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(swdObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create ScheduleWorkday instance. Invalid ID: " + swdObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				swdObj.id = (Int32)dr[idField];
			}
			else
			{
				swdObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(codeField))
			{
				swdObj.code = (string)dr[codeField];
			}
			else
			{
				swdObj.code = string.Empty;
			}
		
			if (!dr.IsNull(daysField))
			{
				swdObj.days = (string)dr[daysField];
			}
			else
			{
				swdObj.days = string.Empty;
			}
		
			if (!dr.IsNull(appearsAsField))
			{
				swdObj.appearsAs = (string)dr[appearsAsField];
			}
			else
			{
				swdObj.appearsAs = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				swdObj.version = (Int32)dr[versionField];
			}
			else
			{
				swdObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerScheduleWorkdays spParam = new spParams.spI_VtkVolunteerScheduleWorkdays ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Code = swdObj.code;
			spParam._Days = swdObj.days;
			spParam._AppearsAs = swdObj.appearsAs;
			spParam._Ver = swdObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkVolunteerScheduleWorkdays spSProc = new spSProcs.spI_VtkVolunteerScheduleWorkdays();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {swdObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("ScheduleWorkday", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return swdObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ScheduleWorkdayMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerScheduleWorkdays spParam = new spParams.spU_VtkVolunteerScheduleWorkdays();
 
			if (swdObj.IsChanged && (!swdObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerScheduleWorkdays spSProc = new spSProcs.spU_VtkVolunteerScheduleWorkdays(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("ScheduleWorkday", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (swdObj.code == string.Empty && !dr.IsNull(codeField))  {return true;} 
			else
			if (swdObj.days == string.Empty && !dr.IsNull(daysField))  {return true;} 
			else
			if (swdObj.appearsAs == string.Empty && !dr.IsNull(appearsAsField))  {return true;} 
			else
			if (swdObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerScheduleWorkdays spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  swdObj.id; 
			spParam._Code =  swdObj.code; 
			spParam._Days =  swdObj.days; 
			spParam._AppearsAs =  swdObj.appearsAs; 
			spParam._Ver =  swdObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerScheduleWorkdays spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = swdObj.id; 
			spParam._Code = swdObj.code; 
			spParam._Days = swdObj.days; 
			spParam._AppearsAs = swdObj.appearsAs; 
			spParam._Ver =  swdObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (swdObj.id > 0)
			{
				spParams.spD_VtkVolunteerScheduleWorkdays spParam = new spParams.spD_VtkVolunteerScheduleWorkdays ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = swdObj.id;
				spParam._Ver = swdObj.version; 
				spSProcs.spD_VtkVolunteerScheduleWorkdays spSProc = new spSProcs.spD_VtkVolunteerScheduleWorkdays();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("ScheduleWorkday", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ScheduleWorkdayMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ScheduleWorkdayMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
