﻿
/*

			Class:              StaffTitleBase

			Date Produced:      3/14/2002 12:24:37 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkStaffTitles
	/// </summary>
	public abstract class StaffTitleBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Title database field
		/// </summary>
		protected internal string  title;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.IsVolChiefSupervisor database field
		/// </summary>
		protected internal bool  isVolChiefSupervisor;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Description database field
		/// </summary>
		protected internal string  description;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Scope database field
		/// </summary>
		protected internal string  scope;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.InstitutionFK database field
		/// </summary>
		protected internal Int32  institutionId;
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to title class field
		/// </summary>
		public string  Title
		{
			get { return title;}    
      set {isChanged = true; title = value;}
		}
		
		/// <summary>
		/// Property that maps to isVolChiefSupervisor class field
		/// </summary>
		public bool  IsVolChiefSupervisor
		{
			get { return isVolChiefSupervisor;}    
      set 
      {
        isChanged = true; 
        isVolChiefSupervisor = value;
      }
		}
		
		/// <summary>
		/// Property that maps to description class field
		/// </summary>
		public string  Description
		{
			get { return description;}    
      set {isChanged = true; description = value;}
		}
		
		/// <summary>
		/// Property that maps to scope class field
		/// </summary>
		public string  Scope
		{
			get { return scope;}    
      set {isChanged = true; scope = value;}
		}
		
		/// <summary>
		/// Property that maps to institutionId class field
		/// </summary>
		public Int32  InstitutionId
		{
			get { return institutionId;}    
      set {isChanged = true; institutionId = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected StaffTitleBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkStaffTitles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected StaffTitleBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkStaffTitles</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkStaffTitles definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected StaffTitleBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[StaffTitleMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			title = string.Empty;
			isVolChiefSupervisor = false;
			description = string.Empty;
			scope = string.Empty;
			institutionId = Int32.MinValue;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new StaffTitleMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of StaffTitle.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for Title property values
		/// </summary>
		/// <param name="value">Current instance value of Title</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateTitle(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StaffTitle";
			ret.PropertyName = "Title";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Title' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 30))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Title' length (" + value.Length +  ") is greater than 30 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsVolChiefSupervisor property values
		/// </summary>
		/// <param name="value">Current instance value of IsVolChiefSupervisor</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateIsVolChiefSupervisor(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StaffTitle";
			ret.PropertyName = "IsVolChiefSupervisor";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Description property values
		/// </summary>
		/// <param name="value">Current instance value of Description</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateDescription(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StaffTitle";
			ret.PropertyName = "Description";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 250))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Description' length (" + value.Length +  ") is greater than 250 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Scope property values
		/// </summary>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StaffTitle";
			ret.PropertyName = "Scope";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Scope' length (" + value.Length +  ") is greater than 1 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for InstitutionId property values
		/// </summary>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StaffTitle";
			ret.PropertyName = "InstitutionId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!InstitutionBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'InstitutionId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkStaffTitles.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkStaffTitles table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkStaffTitles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return StaffTitleMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "Title")  {return title.ToString();}
			if (prop == "IsVolChiefSupervisor")  {return isVolChiefSupervisor.ToString();}
			if (prop == "Description")  {return description.ToString();}
			if (prop == "Scope")  {return scope.ToString();}
			if (prop == "InstitutionId")  {return institutionId.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
