﻿
/*

			Class:              StationProfileMsSqlSrv

			Date Produced:      6/18/2002 9:35:48 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        6/17/2002 1:07:16 PM
			Revision:           651

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerStationProfiles
	/// </summary>
	public class StationProfileMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private StationProfileBase staproObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerStationProfiles)
		/// </summary>
		public static string tableName = "VtkVolunteerStationProfiles";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.VolunteerFK database field
		/// </summary>
		public const string volunteerIdField = "VolunteerFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.VolunteerContactInfoFK database field
		/// </summary>
		public const string contactInfoIdField = "VolunteerContactInfoFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.NextOfKinFK database field
		/// </summary>
		public const string nextOfKinIdField = "NextOfKinFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.EntryDate database field
		/// </summary>
		public const string entryDateField = "EntryDate";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.YearsAtStation database field
		/// </summary>
		public const string yearsAtStationField = "YearsAtStation";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.PriorYearsHoursServed database field
		/// </summary>
		public const string priorYearsHoursServedField = "PriorYearsHoursServed";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.CurrentYearHoursServed database field
		/// </summary>
		public const string currentYearHoursServedField = "CurrentYearHoursServed";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.TotalHoursServed database field
		/// </summary>
		public const string totalHoursServedField = "TotalHoursServed";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.HoursLastAward database field
		/// </summary>
		public const string hoursLastAwardField = "HoursLastAward";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.DateLastAward database field
		/// </summary>
		public const string dateLastAwardField = "DateLastAward";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.AwardCodesFK database field
		/// </summary>
		public const string awardCodesIdField = "AwardCodesFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.TerminationDate database field
		/// </summary>
		public const string terminationDateField = "TerminationDate";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.IsTerminatedWithCause database field
		/// </summary>
		public const string isTerminatedWithCauseField = "IsTerminatedWithCause";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.Remarks database field
		/// </summary>
		public const string remarksField = "Remarks";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.MethodOfTransportation database field
		/// </summary>
		public const string methodOfTransportationField = "MethodOfTransportation";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.EligibleForMeals database field
		/// </summary>
		public const string eligibleForMealsField = "EligibleForMeals";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerStationProfiles.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "staproObj"></param>
		public StationProfileMsSqlSrv(StationProfileBase staproObj)
		{
			Initialize(staproObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "staproObj"></param>
		private void Initialize(StationProfileBase staproObj)
		{
			this.staproObj = staproObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = staproObj.AppCon;
			this.databaseTableName = StationProfileMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = StationProfileMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(staproObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create StationProfile instance. Invalid ID: " + staproObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				staproObj.id = (Int32)dr[idField];
			}
			else
			{
				staproObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				staproObj.stationId = (Int32)dr[stationIdField];
			}
			else
			{
				staproObj.stationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(volunteerIdField))
			{
				staproObj.volunteerId = (Int32)dr[volunteerIdField];
			}
			else
			{
				staproObj.volunteerId = Int32.MinValue;
			}
		
			if (!dr.IsNull(contactInfoIdField))
			{
				staproObj.contactInfoId = (Int32)dr[contactInfoIdField];
			}
			else
			{
				staproObj.contactInfoId = Int32.MinValue;
			}
		
			if (!dr.IsNull(nextOfKinIdField))
			{
				staproObj.nextOfKinId = (Int32)dr[nextOfKinIdField];
			}
			else
			{
				staproObj.nextOfKinId = Int32.MinValue;
			}
		
			if (!dr.IsNull(entryDateField))
			{
				staproObj.entryDate = (DateTime)dr[entryDateField];
			}
			else
			{
				staproObj.entryDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(yearsAtStationField))
			{
				staproObj.yearsAtStation = (Int32)dr[yearsAtStationField];
			}
			else
			{
				staproObj.yearsAtStation = Int32.MinValue;
			}
		
			if (!dr.IsNull(priorYearsHoursServedField))
			{
				staproObj.priorYearsHoursServed = (Int32)dr[priorYearsHoursServedField];
			}
			else
			{
				staproObj.priorYearsHoursServed = Int32.MinValue;
			}
		
			if (!dr.IsNull(currentYearHoursServedField))
			{
				staproObj.currentYearHoursServed = (Int32)dr[currentYearHoursServedField];
			}
			else
			{
				staproObj.currentYearHoursServed = Int32.MinValue;
			}
		
			if (!dr.IsNull(totalHoursServedField))
			{
				staproObj.totalHoursServed = (Int32)dr[totalHoursServedField];
			}
			else
			{
				staproObj.totalHoursServed = Int32.MinValue;
			}
		
			if (!dr.IsNull(hoursLastAwardField))
			{
				staproObj.hoursLastAward = (Int32)dr[hoursLastAwardField];
			}
			else
			{
				staproObj.hoursLastAward = Int32.MinValue;
			}
		
			if (!dr.IsNull(dateLastAwardField))
			{
				staproObj.dateLastAward = (DateTime)dr[dateLastAwardField];
			}
			else
			{
				staproObj.dateLastAward = DateTime.MinValue;
			}
		
			if (!dr.IsNull(awardCodesIdField))
			{
				staproObj.awardCodesId = (Int32)dr[awardCodesIdField];
			}
			else
			{
				staproObj.awardCodesId = Int32.MinValue;
			}
		
			if (!dr.IsNull(terminationDateField))
			{
				staproObj.terminationDate = (DateTime)dr[terminationDateField];
			}
			else
			{
				staproObj.terminationDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(isTerminatedWithCauseField))
			{
				staproObj.isTerminatedWithCause = (bool)dr[isTerminatedWithCauseField];
			}
			else
			{
				staproObj.isTerminatedWithCause = false;
			}
		
			if (!dr.IsNull(remarksField))
			{
				staproObj.remarks = (string)dr[remarksField];
			}
			else
			{
				staproObj.remarks = string.Empty;
			}
		
			if (!dr.IsNull(methodOfTransportationField))
			{
				staproObj.methodOfTransportation = (string)dr[methodOfTransportationField];
			}
			else
			{
				staproObj.methodOfTransportation = string.Empty;
			}
		
			if (!dr.IsNull(eligibleForMealsField))
			{
				staproObj.eligibleForMeals = (Int32)dr[eligibleForMealsField];
			}
			else
			{
				staproObj.eligibleForMeals = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				staproObj.version = (Int32)dr[versionField];
			}
			else
			{
				staproObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerStationProfiles spParam = new spParams.spI_VtkVolunteerStationProfiles ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._StationFK = staproObj.stationId;
			spParam._VolunteerFK = staproObj.volunteerId;
			spParam._VolunteerContactInfoFK = staproObj.contactInfoId;
			spParam._EntryDate = staproObj.entryDate;
			spParam._Ver = staproObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (staproObj.nextOfKinId != Int32.MinValue) {spParam._NextOfKinFK = staproObj.nextOfKinId;}
			if (staproObj.yearsAtStation == Int32.MinValue) {spParam._YearsAtStation = (0);} // set to default Value 
			else {spParam._YearsAtStation = staproObj.yearsAtStation;}
			if (staproObj.priorYearsHoursServed == Int32.MinValue) {spParam._PriorYearsHoursServed = (0);} // set to default Value 
			else {spParam._PriorYearsHoursServed = staproObj.priorYearsHoursServed;}
			if (staproObj.currentYearHoursServed == Int32.MinValue) {spParam._CurrentYearHoursServed = (0);} // set to default Value 
			else {spParam._CurrentYearHoursServed = staproObj.currentYearHoursServed;}
			if (staproObj.hoursLastAward == Int32.MinValue) {spParam._HoursLastAward = (0);} // set to default Value 
			else {spParam._HoursLastAward = staproObj.hoursLastAward;}
			if (staproObj.dateLastAward != DateTime.MinValue) {spParam._DateLastAward = staproObj.dateLastAward;}
			if (staproObj.awardCodesId != Int32.MinValue) {spParam._AwardCodesFK = staproObj.awardCodesId;}
			if (staproObj.terminationDate != DateTime.MinValue) {spParam._TerminationDate = staproObj.terminationDate;}
			if (staproObj.isTerminatedWithCause == false) {spParam._IsTerminatedWithCause = (0);} // set to default Value 
			else {spParam._IsTerminatedWithCause = staproObj.isTerminatedWithCause;}
			if (staproObj.remarks != string.Empty) {spParam._Remarks = staproObj.remarks;}
			if (staproObj.methodOfTransportation == string.Empty) {spParam._MethodOfTransportation = (4);} // set to default Value 
			else {spParam._MethodOfTransportation = staproObj.methodOfTransportation;}
			if (staproObj.eligibleForMeals == Int32.MinValue) {spParam._EligibleForMeals = (0);} // set to default Value 
			else {spParam._EligibleForMeals = staproObj.eligibleForMeals;}
	
			spSProcs.spI_VtkVolunteerStationProfiles spSProc = new spSProcs.spI_VtkVolunteerStationProfiles();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {staproObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("StationProfile", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return staproObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[StationProfileMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerStationProfiles spParam = new spParams.spU_VtkVolunteerStationProfiles();
 
			if (staproObj.IsChanged && (!staproObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerStationProfiles spSProc = new spSProcs.spU_VtkVolunteerStationProfiles(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("StationProfile", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (staproObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (staproObj.volunteerId == Int32.MinValue && !dr.IsNull(volunteerIdField))  {return true;} 
			else
			if (staproObj.contactInfoId == Int32.MinValue && !dr.IsNull(contactInfoIdField))  {return true;} 
			else
			if (staproObj.nextOfKinId == Int32.MinValue && !dr.IsNull(nextOfKinIdField))  {return true;} 
			else
			if (staproObj.entryDate == DateTime.MinValue && !dr.IsNull(entryDateField))  {return true;} 
			else
			if (staproObj.yearsAtStation == Int32.MinValue && !dr.IsNull(yearsAtStationField))  {return true;} 
			else
			if (staproObj.priorYearsHoursServed == Int32.MinValue && !dr.IsNull(priorYearsHoursServedField))  {return true;} 
			else
			if (staproObj.currentYearHoursServed == Int32.MinValue && !dr.IsNull(currentYearHoursServedField))  {return true;} 
			else
			if (staproObj.hoursLastAward == Int32.MinValue && !dr.IsNull(hoursLastAwardField))  {return true;} 
			else
			if (staproObj.dateLastAward == DateTime.MinValue && !dr.IsNull(dateLastAwardField))  {return true;} 
			else
			if (staproObj.awardCodesId == Int32.MinValue && !dr.IsNull(awardCodesIdField))  {return true;} 
			else
			if (staproObj.terminationDate == DateTime.MinValue && !dr.IsNull(terminationDateField))  {return true;} 
			else
			if (staproObj.isTerminatedWithCause == false && !dr.IsNull(isTerminatedWithCauseField))  {return true;} 
			else
			if (staproObj.remarks == string.Empty && !dr.IsNull(remarksField))  {return true;} 
			else
			if (staproObj.methodOfTransportation == string.Empty && !dr.IsNull(methodOfTransportationField))  {return true;} 
			else
			if (staproObj.eligibleForMeals == Int32.MinValue && !dr.IsNull(eligibleForMealsField))  {return true;} 
			else
			if (staproObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerStationProfiles spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  staproObj.id; 
			spParam._StationFK =  staproObj.stationId; 
			spParam._VolunteerFK =  staproObj.volunteerId; 
			spParam._VolunteerContactInfoFK =  staproObj.contactInfoId; 
			spParam._EntryDate =  staproObj.entryDate; 
			spParam._Ver =  staproObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (staproObj.nextOfKinId != Int32.MinValue)  {spParam._NextOfKinFK = staproObj.nextOfKinId;}
			if (staproObj.yearsAtStation != Int32.MinValue)  {spParam._YearsAtStation = staproObj.yearsAtStation;}
			if (staproObj.priorYearsHoursServed != Int32.MinValue)  {spParam._PriorYearsHoursServed = staproObj.priorYearsHoursServed;}
			if (staproObj.currentYearHoursServed != Int32.MinValue)  {spParam._CurrentYearHoursServed = staproObj.currentYearHoursServed;}
			if (staproObj.hoursLastAward != Int32.MinValue)  {spParam._HoursLastAward = staproObj.hoursLastAward;}
			if (staproObj.dateLastAward != DateTime.MinValue)  {spParam._DateLastAward = staproObj.dateLastAward;}
			if (staproObj.awardCodesId != Int32.MinValue)  {spParam._AwardCodesFK = staproObj.awardCodesId;}
			if (staproObj.terminationDate != DateTime.MinValue)  {spParam._TerminationDate = staproObj.terminationDate;}
			if (staproObj.isTerminatedWithCause != false)  {spParam._IsTerminatedWithCause = staproObj.isTerminatedWithCause;}
			if (staproObj.remarks != string.Empty)  {spParam._Remarks = staproObj.remarks;}
			if (staproObj.methodOfTransportation != string.Empty)  {spParam._MethodOfTransportation = staproObj.methodOfTransportation;}
			if (staproObj.eligibleForMeals != Int32.MinValue)  {spParam._EligibleForMeals = staproObj.eligibleForMeals;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerStationProfiles spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = staproObj.id; 
			spParam._StationFK = staproObj.stationId; 
			spParam._VolunteerFK = staproObj.volunteerId; 
			spParam._VolunteerContactInfoFK = staproObj.contactInfoId; 
			spParam._EntryDate = staproObj.entryDate; 
			spParam._Ver =  staproObj.version; 
	
			//nextOfKinId property
			if (!dr.IsNull(nextOfKinIdField))
			{ 
				if (staproObj.nextOfKinId != (Int32)dr[nextOfKinIdField]) 
				{ 
					spParam._NextOfKinFK = staproObj.nextOfKinId; 
				} 
			} 
			else if (staproObj.nextOfKinId != Int32.MinValue)
			{ 
				spParam._NextOfKinFK = staproObj.nextOfKinId; 
			} 
	
			//yearsAtStation property
			if (!dr.IsNull(yearsAtStationField))
			{ 
				if (staproObj.yearsAtStation != (Int32)dr[yearsAtStationField]) 
				{ 
					spParam._YearsAtStation = staproObj.yearsAtStation; 
				} 
			} 
			else if (staproObj.yearsAtStation != Int32.MinValue)
			{ 
				spParam._YearsAtStation = staproObj.yearsAtStation; 
			} 
	
			//priorYearsHoursServed property
			if (!dr.IsNull(priorYearsHoursServedField))
			{ 
				if (staproObj.priorYearsHoursServed != (Int32)dr[priorYearsHoursServedField]) 
				{ 
					spParam._PriorYearsHoursServed = staproObj.priorYearsHoursServed; 
				} 
			} 
			else if (staproObj.priorYearsHoursServed != Int32.MinValue)
			{ 
				spParam._PriorYearsHoursServed = staproObj.priorYearsHoursServed; 
			} 
	
			//currentYearHoursServed property
			if (!dr.IsNull(currentYearHoursServedField))
			{ 
				if (staproObj.currentYearHoursServed != (Int32)dr[currentYearHoursServedField]) 
				{ 
					spParam._CurrentYearHoursServed = staproObj.currentYearHoursServed; 
				} 
			} 
			else if (staproObj.currentYearHoursServed != Int32.MinValue)
			{ 
				spParam._CurrentYearHoursServed = staproObj.currentYearHoursServed; 
			} 
	
			//hoursLastAward property
			if (!dr.IsNull(hoursLastAwardField))
			{ 
				if (staproObj.hoursLastAward != (Int32)dr[hoursLastAwardField]) 
				{ 
					spParam._HoursLastAward = staproObj.hoursLastAward; 
				} 
			} 
			else if (staproObj.hoursLastAward != Int32.MinValue)
			{ 
				spParam._HoursLastAward = staproObj.hoursLastAward; 
			} 
	
			//dateLastAward property
			if (!dr.IsNull(dateLastAwardField))
			{ 
				if (staproObj.dateLastAward != (DateTime)dr[dateLastAwardField]) 
				{ 
					spParam._DateLastAward = staproObj.dateLastAward; 
				} 
			} 
			else if (staproObj.dateLastAward != DateTime.MinValue)
			{ 
				spParam._DateLastAward = staproObj.dateLastAward; 
			} 
	
			//awardCodesId property
			if (!dr.IsNull(awardCodesIdField))
			{ 
				if (staproObj.awardCodesId != (Int32)dr[awardCodesIdField]) 
				{ 
					spParam._AwardCodesFK = staproObj.awardCodesId; 
				} 
			} 
			else if (staproObj.awardCodesId != Int32.MinValue)
			{ 
				spParam._AwardCodesFK = staproObj.awardCodesId; 
			} 
	
			//terminationDate property
			if (!dr.IsNull(terminationDateField))
			{ 
				if (staproObj.terminationDate != (DateTime)dr[terminationDateField]) 
				{ 
					spParam._TerminationDate = staproObj.terminationDate; 
				} 
			} 
			else if (staproObj.terminationDate != DateTime.MinValue)
			{ 
				spParam._TerminationDate = staproObj.terminationDate; 
			} 
	
			//isTerminatedWithCause property
			if (!dr.IsNull(isTerminatedWithCauseField))
			{ 
				if (staproObj.isTerminatedWithCause != (bool)dr[isTerminatedWithCauseField]) 
				{ 
					spParam._IsTerminatedWithCause = staproObj.isTerminatedWithCause; 
				} 
			} 
			else if (staproObj.isTerminatedWithCause != false)
			{ 
				spParam._IsTerminatedWithCause = staproObj.isTerminatedWithCause; 
			} 
	
			//remarks property
			if (!dr.IsNull(remarksField))
			{ 
				if (staproObj.remarks != (string)dr[remarksField]) 
				{ 
					spParam._Remarks = staproObj.remarks; 
				} 
			} 
			else if (staproObj.remarks != string.Empty)
			{ 
				spParam._Remarks = staproObj.remarks; 
			} 
	
			//methodOfTransportation property
			if (!dr.IsNull(methodOfTransportationField))
			{ 
				if (staproObj.methodOfTransportation != (string)dr[methodOfTransportationField]) 
				{ 
					spParam._MethodOfTransportation = staproObj.methodOfTransportation; 
				} 
			} 
			else if (staproObj.methodOfTransportation != string.Empty)
			{ 
				spParam._MethodOfTransportation = staproObj.methodOfTransportation; 
			} 
	
			//eligibleForMeals property
			if (!dr.IsNull(eligibleForMealsField))
			{ 
				if (staproObj.eligibleForMeals != (Int32)dr[eligibleForMealsField]) 
				{ 
					spParam._EligibleForMeals = staproObj.eligibleForMeals; 
				} 
			} 
			else if (staproObj.eligibleForMeals != Int32.MinValue)
			{ 
				spParam._EligibleForMeals = staproObj.eligibleForMeals; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (staproObj.id > 0)
			{
				spParams.spD_VtkVolunteerStationProfiles spParam = new spParams.spD_VtkVolunteerStationProfiles ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = staproObj.id;
				spParam._Ver = staproObj.version; 
				spSProcs.spD_VtkVolunteerStationProfiles spSProc = new spSProcs.spD_VtkVolunteerStationProfiles();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("StationProfile", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + StationProfileMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, StationProfileMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
