﻿
/*

			Class:              UserMsSqlSrv

			Date Produced:      4/23/2002 3:18:28 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        4/23/2002 2:50:47 PM
			Revision:           620

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  \DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.842.2440

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkUsers
	/// </summary>
	public class UserMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private UserBase userObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkUsers)
		/// </summary>
		public static string tableName = "VtkUsers";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkUsers.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkUsers.NtUserName database field
		/// </summary>
		public const string ntUserNameField = "NtUserName";
		
		/// <summary>
		/// Class field that maps to VtkUsers.LastName database field
		/// </summary>
		public const string lastNameField = "LastName";
		
		/// <summary>
		/// Class field that maps to VtkUsers.FirstName database field
		/// </summary>
		public const string firstNameField = "FirstName";
		
		/// <summary>
		/// Class field that maps to VtkUsers.MiddleName database field
		/// </summary>
		public const string middleNameField = "MiddleName";
		
		/// <summary>
		/// Class field that maps to VtkUsers.PrimaryInstitutionFK database field
		/// </summary>
		public const string primaryInstitutionField = "PrimaryInstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkUsers.Nickname database field
		/// </summary>
		public const string nicknameField = "Nickname";
		
		/// <summary>
		/// Class field that maps to VtkUsers.JobTitleFK database field
		/// </summary>
		public const string jobTitleIdField = "JobTitleFK";
		
		/// <summary>
		/// Class field that maps to VtkUsers.PositionStartDate database field
		/// </summary>
		public const string positionStartDateField = "PositionStartDate";
		
		/// <summary>
		/// Class field that maps to VtkUsers.Sex database field
		/// </summary>
		public const string sexField = "Sex";
		
		/// <summary>
		/// Class field that maps to VtkUsers.Grade database field
		/// </summary>
		public const string gradeField = "Grade";
		
		/// <summary>
		/// Class field that maps to VtkUsers.LowercaseNameForDisplay database field
		/// </summary>
		public const string lowercaseNameForDisplayField = "LowercaseNameForDisplay";
		
		/// <summary>
		/// Class field that maps to VtkUsers.UppercaseNameForDisplay database field
		/// </summary>
		public const string uppercaseNameForDisplayField = "UppercaseNameForDisplay";
		
		/// <summary>
		/// Class field that maps to VtkUsers.FullNameForReports database field
		/// </summary>
		public const string fullNameForReportsField = "FullNameForReports";
		
		/// <summary>
		/// Class field that maps to VtkUsers.EMailAddress database field
		/// </summary>
		public const string eMailAddressField = "EMailAddress";
		
		/// <summary>
		/// Class field that maps to VtkUsers.DefaultInstitutionFK database field
		/// </summary>
		public const string defaultInstitutionIdField = "DefaultInstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkUsers.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "userObj"></param>
		public UserMsSqlSrv(UserBase userObj)
		{
			Initialize(userObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "userObj"></param>
		private void Initialize(UserBase userObj)
		{
			this.userObj = userObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = userObj.AppCon;
			this.databaseTableName = UserMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = UserMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(userObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create User instance. Invalid ID: " + userObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				userObj.id = (Int32)dr[idField];
			}
			else
			{
				userObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(ntUserNameField))
			{
				userObj.ntUserName = (string)dr[ntUserNameField];
			}
			else
			{
				userObj.ntUserName = string.Empty;
			}
		
			if (!dr.IsNull(lastNameField))
			{
				userObj.lastName = (string)dr[lastNameField];
			}
			else
			{
				userObj.lastName = string.Empty;
			}
		
			if (!dr.IsNull(firstNameField))
			{
				userObj.firstName = (string)dr[firstNameField];
			}
			else
			{
				userObj.firstName = string.Empty;
			}
		
			if (!dr.IsNull(middleNameField))
			{
				userObj.middleName = (string)dr[middleNameField];
			}
			else
			{
				userObj.middleName = string.Empty;
			}
		
			if (!dr.IsNull(primaryInstitutionField))
			{
				userObj.primaryInstitution = (Int32)dr[primaryInstitutionField];
			}
			else
			{
				userObj.primaryInstitution = Int32.MinValue;
			}
		
			if (!dr.IsNull(nicknameField))
			{
				userObj.nickname = (string)dr[nicknameField];
			}
			else
			{
				userObj.nickname = string.Empty;
			}
		
			if (!dr.IsNull(jobTitleIdField))
			{
				userObj.jobTitleId = (Int32)dr[jobTitleIdField];
			}
			else
			{
				userObj.jobTitleId = Int32.MinValue;
			}
		
			if (!dr.IsNull(positionStartDateField))
			{
				userObj.positionStartDate = (DateTime)dr[positionStartDateField];
			}
			else
			{
				userObj.positionStartDate = DateTime.MinValue;
			}
		
			if (!dr.IsNull(sexField))
			{
				userObj.sex = (string)dr[sexField];
			}
			else
			{
				userObj.sex = string.Empty;
			}
		
			if (!dr.IsNull(gradeField))
			{
				userObj.grade = (string)dr[gradeField];
			}
			else
			{
				userObj.grade = string.Empty;
			}
		
			if (!dr.IsNull(lowercaseNameForDisplayField))
			{
				userObj.lowercaseNameForDisplay = (string)dr[lowercaseNameForDisplayField];
			}
			else
			{
				userObj.lowercaseNameForDisplay = string.Empty;
			}
		
			if (!dr.IsNull(uppercaseNameForDisplayField))
			{
				userObj.uppercaseNameForDisplay = (string)dr[uppercaseNameForDisplayField];
			}
			else
			{
				userObj.uppercaseNameForDisplay = string.Empty;
			}
		
			if (!dr.IsNull(fullNameForReportsField))
			{
				userObj.fullNameForReports = (string)dr[fullNameForReportsField];
			}
			else
			{
				userObj.fullNameForReports = string.Empty;
			}
		
			if (!dr.IsNull(eMailAddressField))
			{
				userObj.eMailAddress = (string)dr[eMailAddressField];
			}
			else
			{
				userObj.eMailAddress = string.Empty;
			}
		
			if (!dr.IsNull(defaultInstitutionIdField))
			{
				userObj.defaultInstitutionId = (Int32)dr[defaultInstitutionIdField];
			}
			else
			{
				userObj.defaultInstitutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				userObj.version = (Int32)dr[versionField];
			}
			else
			{
				userObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkUsers spParam = new spParams.spI_VtkUsers ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._LastName = userObj.lastName;
			spParam._FirstName = userObj.firstName;
			spParam._PrimaryInstitutionFK = userObj.primaryInstitution;
			spParam._Ver = userObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (userObj.ntUserName != string.Empty) {spParam._NtUserName = userObj.ntUserName;}
			if (userObj.middleName != string.Empty) {spParam._MiddleName = userObj.middleName;}
			if (userObj.nickname != string.Empty) {spParam._Nickname = userObj.nickname;}
			if (userObj.jobTitleId != Int32.MinValue) {spParam._JobTitleFK = userObj.jobTitleId;}
			if (userObj.positionStartDate != DateTime.MinValue) {spParam._PositionStartDate = userObj.positionStartDate;}
			if (userObj.sex != string.Empty) {spParam._Sex = userObj.sex;}
			if (userObj.grade != string.Empty) {spParam._Grade = userObj.grade;}
			if (userObj.eMailAddress != string.Empty) {spParam._EMailAddress = userObj.eMailAddress;}
			if (userObj.defaultInstitutionId != Int32.MinValue) {spParam._DefaultInstitutionFK = userObj.defaultInstitutionId;}
	
			spSProcs.spI_VtkUsers spSProc = new spSProcs.spI_VtkUsers();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {userObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("User", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return userObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[UserMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkUsers spParam = new spParams.spU_VtkUsers();
 
			if (userObj.IsChanged && (!userObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkUsers spSProc = new spSProcs.spU_VtkUsers(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("User", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (userObj.ntUserName == string.Empty && !dr.IsNull(ntUserNameField))  {return true;} 
			else
			if (userObj.lastName == string.Empty && !dr.IsNull(lastNameField))  {return true;} 
			else
			if (userObj.firstName == string.Empty && !dr.IsNull(firstNameField))  {return true;} 
			else
			if (userObj.middleName == string.Empty && !dr.IsNull(middleNameField))  {return true;} 
			else
			if (userObj.primaryInstitution == Int32.MinValue && !dr.IsNull(primaryInstitutionField))  {return true;} 
			else
			if (userObj.nickname == string.Empty && !dr.IsNull(nicknameField))  {return true;} 
			else
			if (userObj.jobTitleId == Int32.MinValue && !dr.IsNull(jobTitleIdField))  {return true;} 
			else
			if (userObj.positionStartDate == DateTime.MinValue && !dr.IsNull(positionStartDateField))  {return true;} 
			else
			if (userObj.sex == string.Empty && !dr.IsNull(sexField))  {return true;} 
			else
			if (userObj.grade == string.Empty && !dr.IsNull(gradeField))  {return true;} 
			else
			if (userObj.eMailAddress == string.Empty && !dr.IsNull(eMailAddressField))  {return true;} 
			else
			if (userObj.defaultInstitutionId == Int32.MinValue && !dr.IsNull(defaultInstitutionIdField))  {return true;} 
			else
			if (userObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkUsers spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  userObj.id; 
			spParam._LastName =  userObj.lastName; 
			spParam._FirstName =  userObj.firstName; 
			spParam._PrimaryInstitutionFK =  userObj.primaryInstitution; 
			spParam._Ver =  userObj.version; 

			//Set all non-null, not required properties, otherwise leave null (default value)
			if (userObj.ntUserName != string.Empty)  {spParam._NtUserName = userObj.ntUserName;}
			if (userObj.middleName != string.Empty)  {spParam._MiddleName = userObj.middleName;}
			if (userObj.nickname != string.Empty)  {spParam._Nickname = userObj.nickname;}
			if (userObj.jobTitleId != Int32.MinValue)  {spParam._JobTitleFK = userObj.jobTitleId;}
			if (userObj.positionStartDate != DateTime.MinValue)  {spParam._PositionStartDate = userObj.positionStartDate;}
			if (userObj.sex != string.Empty)  {spParam._Sex = userObj.sex;}
			if (userObj.grade != string.Empty)  {spParam._Grade = userObj.grade;}
			if (userObj.eMailAddress != string.Empty)  {spParam._EMailAddress = userObj.eMailAddress;}
			if (userObj.defaultInstitutionId != Int32.MinValue)  {spParam._DefaultInstitutionFK = userObj.defaultInstitutionId;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkUsers spParam, DataRow dr)
		{
			//required or bool properties
      spParam._Id = userObj.id; 
			spParam._LastName = userObj.lastName; 
			spParam._FirstName = userObj.firstName; 
			spParam._PrimaryInstitutionFK = userObj.primaryInstitution; 
			spParam._Ver =  userObj.version; 
	
			//ntUserName property
			if (!dr.IsNull(ntUserNameField))
			{ 
				if (userObj.ntUserName != (string)dr[ntUserNameField]) 
				{ 
					spParam._NtUserName = userObj.ntUserName; 
				} 
			} 
			else if (userObj.ntUserName != string.Empty)
			{ 
				spParam._NtUserName = userObj.ntUserName; 
			} 
	
			//middleName property
			if (!dr.IsNull(middleNameField))
			{ 
				if (userObj.middleName != (string)dr[middleNameField]) 
				{ 
					spParam._MiddleName = userObj.middleName; 
				} 
			} 
			else if (userObj.middleName != string.Empty)
			{ 
				spParam._MiddleName = userObj.middleName; 
			} 
	
			//nickname property
			if (!dr.IsNull(nicknameField))
			{ 
				if (userObj.nickname != (string)dr[nicknameField]) 
				{ 
					spParam._Nickname = userObj.nickname; 
				} 
			} 
			else if (userObj.nickname != string.Empty)
			{ 
				spParam._Nickname = userObj.nickname; 
			} 
	
			//jobTitleId property
			if (!dr.IsNull(jobTitleIdField))
			{ 
				if (userObj.jobTitleId != (Int32)dr[jobTitleIdField]) 
				{ 
					spParam._JobTitleFK = userObj.jobTitleId; 
				} 
			} 
			else if (userObj.jobTitleId != Int32.MinValue)
			{ 
				spParam._JobTitleFK = userObj.jobTitleId; 
			} 
	
			//positionStartDate property
			if (!dr.IsNull(positionStartDateField))
			{ 
				if (userObj.positionStartDate != (DateTime)dr[positionStartDateField]) 
				{ 
					spParam._PositionStartDate = userObj.positionStartDate; 
				} 
			} 
			else if (userObj.positionStartDate != DateTime.MinValue)
			{ 
				spParam._PositionStartDate = userObj.positionStartDate; 
			} 
	
			//sex property
			if (!dr.IsNull(sexField))
			{ 
				if (userObj.sex != (string)dr[sexField]) 
				{ 
					spParam._Sex = userObj.sex; 
				} 
			} 
			else if (userObj.sex != string.Empty)
			{ 
				spParam._Sex = userObj.sex; 
			} 
	
			//grade property
			if (!dr.IsNull(gradeField))
			{ 
				if (userObj.grade != (string)dr[gradeField]) 
				{ 
					spParam._Grade = userObj.grade; 
				} 
			} 
			else if (userObj.grade != string.Empty)
			{ 
				spParam._Grade = userObj.grade; 
			} 
	
			//eMailAddress property
			if (!dr.IsNull(eMailAddressField))
			{ 
				if (userObj.eMailAddress != (string)dr[eMailAddressField]) 
				{ 
					spParam._EMailAddress = userObj.eMailAddress; 
				} 
			} 
			else if (userObj.eMailAddress != string.Empty)
			{ 
				spParam._EMailAddress = userObj.eMailAddress; 
			} 
	
			//defaultInstitutionId property
			if (!dr.IsNull(defaultInstitutionIdField))
			{ 
				if (userObj.defaultInstitutionId != (Int32)dr[defaultInstitutionIdField]) 
				{ 
					spParam._DefaultInstitutionFK = userObj.defaultInstitutionId; 
				} 
			} 
			else if (userObj.defaultInstitutionId != Int32.MinValue)
			{ 
				spParam._DefaultInstitutionFK = userObj.defaultInstitutionId; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (userObj.id > 0)
			{
				spParams.spD_VtkUsers spParam = new spParams.spD_VtkUsers ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = userObj.id;
				spParam._Ver = userObj.version; 
				spSProcs.spD_VtkUsers spSProc = new spSProcs.spD_VtkUsers();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("User", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + UserMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, UserMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
