﻿
/*

			Class:              ServiceTypeMsSqlSrv

			Date Produced:      3/14/2002 8:30:33 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 8:29:11 AM
			Revision:           605

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVoluntaryServiceTypes
	/// </summary>
	public class ServiceTypeMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ServiceTypeBase vstObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVoluntaryServiceTypes)
		/// </summary>
		public static string tableName = "VtkVoluntaryServiceTypes";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Type database field
		/// </summary>
		public const string typeField = "Type";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Description database field
		/// </summary>
		public const string descriptionField = "Description";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "vstObj"></param>
		public ServiceTypeMsSqlSrv(ServiceTypeBase vstObj)
		{
			Initialize(vstObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "vstObj"></param>
		private void Initialize(ServiceTypeBase vstObj)
		{
			this.vstObj = vstObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = vstObj.AppCon;
			this.databaseTableName = ServiceTypeMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ServiceTypeMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(vstObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create ServiceType instance. Invalid ID: " + vstObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				vstObj.id = (Int32)dr[idField];
			}
			else
			{
				vstObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(typeField))
			{
				vstObj.type = (String)dr[typeField];
			}
			else
			{
				vstObj.type = string.Empty;
			}
		
			if (!dr.IsNull(descriptionField))
			{
				vstObj.description = (String)dr[descriptionField];
			}
			else
			{
				vstObj.description = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				vstObj.version = (Int32)dr[versionField];
			}
			else
			{
				vstObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVoluntaryServiceTypes spParam = new spParams.spI_VtkVoluntaryServiceTypes ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Type = vstObj.type;
			spParam._Ver = vstObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (vstObj.description != string.Empty) {spParam._Description = vstObj.description;}
	
			spSProcs.spI_VtkVoluntaryServiceTypes spSProc = new spSProcs.spI_VtkVoluntaryServiceTypes();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {vstObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("ServiceType", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return vstObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ServiceTypeMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVoluntaryServiceTypes spParam = new spParams.spU_VtkVoluntaryServiceTypes();
 
			if (vstObj.IsChanged && (!vstObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVoluntaryServiceTypes spSProc = new spSProcs.spU_VtkVoluntaryServiceTypes(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("ServiceType", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (vstObj.type == string.Empty && !dr.IsNull(typeField))  {return true;} 
			else
			if (vstObj.description == string.Empty && !dr.IsNull(descriptionField))  {return true;} 
			else
			if (vstObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVoluntaryServiceTypes spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  vstObj.id; 
			spParam._Type =  vstObj.type; 
			spParam._Ver =  vstObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (vstObj.description != string.Empty)  {spParam._Description = vstObj.description;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVoluntaryServiceTypes spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = vstObj.id; 
			spParam._Type = vstObj.type; 
			spParam._Ver =  vstObj.version; 
	
			//description property
			if (!dr.IsNull(descriptionField))
			{ 
				if (vstObj.description != (String)dr[descriptionField]) 
				{ 
					spParam._Description = vstObj.description; 
				} 
			} 
			else if (vstObj.description != string.Empty)
			{ 
				spParam._Description = vstObj.description; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (vstObj.id > 0)
			{
				spParams.spD_VtkVoluntaryServiceTypes spParam = new spParams.spD_VtkVoluntaryServiceTypes ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = vstObj.id;
				spParam._Ver = vstObj.version; 
				spSProcs.spD_VtkVoluntaryServiceTypes spSProc = new spSProcs.spD_VtkVoluntaryServiceTypes();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("ServiceType", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ServiceTypeMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ServiceTypeMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
