﻿
/*

			Class:              ServiceStaffBase

			Date Produced:      3/14/2002 12:41:51 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVoluntaryServiceStaff
	/// </summary>
	public abstract class ServiceStaffBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.UserFK database field
		/// </summary>
		protected internal Int32  userId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.InstitutionFK database field
		/// </summary>
		protected internal Int32  institutionId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.ReportOrder database field
		/// </summary>
		protected internal Int32  reportOrder;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.IsChief database field
		/// </summary>
		protected internal bool  isChief;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.IsVISNLiaison database field
		/// </summary>
		protected internal bool  isVISNLiaison;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.ProgramFK database field
		/// </summary>
		protected internal Int32  programId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Comment database field
		/// </summary>
		protected internal string  comment;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}    set {isChanged = true; id = value;}
		}
		
		/// <summary>
		/// Property that maps to userId class field
		/// </summary>
		public Int32  UserId
		{
			get { return userId;}    set {isChanged = true; userId = value;}
		}
		
		/// <summary>
		/// Property that maps to institutionId class field
		/// </summary>
		public Int32  InstitutionId
		{
			get { return institutionId;}    set {isChanged = true; institutionId = value;}
		}
		
		/// <summary>
		/// Property that maps to reportOrder class field
		/// </summary>
		public Int32  ReportOrder
		{
			get { return reportOrder;}    set {isChanged = true; reportOrder = value;}
		}
		
		/// <summary>
		/// Property that maps to isChief class field
		/// </summary>
		public bool  IsChief
		{
			get { return isChief;}    set {isChanged = true; isChief = value;}
		}
		
		/// <summary>
		/// Property that maps to isVISNLiaison class field
		/// </summary>
		public bool  IsVISNLiaison
		{
			get { return isVISNLiaison;}    set {isChanged = true; isVISNLiaison = value;}
		}
		
		/// <summary>
		/// Property that maps to programId class field
		/// </summary>
		public Int32  ProgramId
		{
			get { return programId;}    set {isChanged = true; programId = value;}
		}
		
		/// <summary>
		/// Property that maps to comment class field
		/// </summary>
		public string  Comment
		{
			get { return comment;}    set {isChanged = true; comment = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected ServiceStaffBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryServiceStaff entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected ServiceStaffBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVoluntaryServiceStaff</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVoluntaryServiceStaff definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected ServiceStaffBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[ServiceStaffMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			userId = Int32.MinValue;
			institutionId = Int32.MinValue;
			reportOrder = Int32.MinValue;
			isChief = false;
			isVISNLiaison = false;
			programId = Int32.MinValue;
			comment = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new ServiceStaffMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of ServiceStaff.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for UserId property values
		/// </summary>
		/// <param name="value">Current instance value of UserId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateUserId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "UserId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'UserId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!UserBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'UserId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for InstitutionId property values
		/// </summary>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "InstitutionId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'InstitutionId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ServicesBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'InstitutionId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for ReportOrder property values
		/// </summary>
		/// <param name="value">Current instance value of ReportOrder</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateReportOrder(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "ReportOrder";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'ReportOrder' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsChief property values
		/// </summary>
		/// <param name="value">Current instance value of IsChief</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateIsChief(Int32 InstitutionId, Int32 UserId, bool value)
		{			
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "IsChief";


			// quit if field allows nulls and currently set to default
			if (value == false) return ret;

			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkChiefExists", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionId;

			sqlParam							= sqlCmd.Parameters.Add("@UserFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= UserId;			

			sqlParam							= sqlCmd.Parameters.Add("@IsChiefThere", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Output;

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			byte RETURN_ISCHIEFEXISTS = Convert.ToByte(sqlCmd.Parameters["@IsChiefThere"].Value);
			byte RETURN_STATUS = Convert.ToByte(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			if(Convert.ToBoolean(RETURN_STATUS))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An Error accured validating Existing Chiefs.";
				return ret;
			}
			else if(Convert.ToBoolean(RETURN_ISCHIEFEXISTS))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "A Chief already exists for this Institution. Please remove the Existing Chief before setting another.";
				return ret;
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsVISNLiaison property values
		/// </summary>
		/// <param name="value">Current instance value of IsVISNLiaison</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateIsVISNLiaison(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "IsVISNLiaison";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for ProgramId property values
		/// </summary>
		/// <param name="value">Current instance value of ProgramId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateProgramId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "ProgramId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!SupervisedProgramsBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'ProgramId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Comment property values
		/// </summary>
		/// <param name="value">Current instance value of Comment</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateComment(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceStaff";
			ret.PropertyName = "Comment";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 250))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Comment' length (" + value.Length +  ") is greater than 250 characters.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVoluntaryServiceStaff.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVoluntaryServiceStaff table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVoluntaryServiceStaff entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return ServiceStaffMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "UserId")  {return userId.ToString();}
			if (prop == "InstitutionId")  {return institutionId.ToString();}
			if (prop == "ReportOrder")  {return reportOrder.ToString();}
			if (prop == "IsChief")  {return isChief.ToString();}
			if (prop == "IsVISNLiaison")  {return isVISNLiaison.ToString();}
			if (prop == "ProgramId")  {return programId.ToString();}
			if (prop == "Comment")  {return comment.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
