﻿
/*

			Class:              GameType

			Date Produced:      11/21/2002 12:13:25 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\Vha.Vtk.Games

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text;

using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.GameTypeMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Games
{
	/// <summary>
	///  Public Class mapped to VtkGameType
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class GameType : GameTypeBase
	{
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGameType entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public GameType(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private GameType(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of GameType thate will be used to add a record to the VtkGameType database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="GameType"/></returns>
		public static GameType AddRecord(ApplicationConnection appCon)
		{
			GameType gmtObj = new GameType(appCon);
			gmtObj.FillDataNew();
			return gmtObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateName(Name);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCode(Code);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Name property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GameTypeBase.ValidateName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Name</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateName(string value)
		{
			ReturnStatus ret = GameTypeBase.ValidateName(value);
		 
			// TODO: Add property specific validation logic for 'Name'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Code property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GameTypeBase.ValidateCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCode(string value)
		{
			ReturnStatus ret = GameTypeBase.ValidateCode(value);
		 
			// TODO: Add property specific validation logic for 'Code'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'GameType'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkGameType table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkGameType entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>GameType</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>Name</b>  [string]</li>
		///  <li><b>Code</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select Id As ID" +
				", Name" +
				", InstitutionFK InstitutionId" +
				", Code" +
				", Ver As Version" +
				" FROM  VtkGameType";

			StringBuilder command = new StringBuilder(sCommand);
			if(idValue != 0)
				command.Append(" WHERE Id = '" + idValue.ToString() + "' ");
			
			return ApplicationConnection.ExecuteQuery(command.ToString(), "GameTypeList");
		}

		public static DataSet GetQuickList()
		{
			return GetQuickList(0);
		}
		
		public static int GetGameCode(int InstitutionId)
		{
			
			//Create the ApplicationConnection Object to use for Creating the Volunteer in the DB.
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());
			

			SqlCommand sqlCmd			= new SqlCommand("spS_GamesCodeByInstitutionId", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			//Create Parameters for the Volunteer
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@InstitutionId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionId;
			
			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.VarChar, 4);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			int RETURN_STATUS = Convert.ToInt32(sqlCmd.Parameters["RETURN_STATUS"].Value);

			sqlConn.Close();
			sqlConn.Dispose();

			return RETURN_STATUS;
		}
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
