﻿
/*

			Class:              GamesSchedule

			Date Produced:      11/21/2002 12:13:25 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\Vha.Vtk.Games

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Data.SqlTypes;

using System.Text;

using Vha.Vtk.DataClasses;
using Vha.Vtk.DataClasses.Parameters;
using Vha.Vtk.DataClasses.StoredProcedures;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Kernel.Data;
using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.GamesScheduleMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Games
{
	/// <summary>
	///  Public Class mapped to VtkGamesSchedule
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class GamesSchedule : GamesScheduleBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGamesSchedule entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public GamesSchedule(int id) : base(id)
		{
		}

		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGamesSchedule entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public GamesSchedule(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public GamesSchedule(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		public GamesSchedule() : base()
		{
		}
		/// <summary>
		/// Creates an instance of GamesSchedule thate will be used to add a record to the VtkGamesSchedule database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="GamesSchedule"/></returns>
		public static GamesSchedule AddRecord(ApplicationConnection appCon)
		{
			GamesSchedule gmsObj = new GamesSchedule(appCon);
			gmsObj.FillDataNew();
			return gmsObj;
		}
		
		public static int AddRecord(int HostStationId, int GameTypeId, DateTime StartDate, DateTime EndDate)
		{
			GamesSchedule gmsObj = new GamesSchedule();
			gmsObj.FillDataNew();
			gmsObj.HostStationFk = HostStationId;
			gmsObj.GameTypeFk = GameTypeId;
			gmsObj.StartDate = StartDate;
			gmsObj.EndDate = EndDate;

			gmsObj.Validate();
			
			
			//Create the ApplicationConnection Object to use for Creating the Volunteer in the DB.
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());
			

			SqlCommand sqlCmd			= new SqlCommand("spI_VtkGamesSchedule", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			//Create Parameters for the Volunteer
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@Id", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Output;

			sqlParam							= sqlCmd.Parameters.Add("@HostStationFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= gmsObj.HostStationFk;

			sqlParam							= sqlCmd.Parameters.Add("@GameTypeFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= gmsObj.GameTypeFk;

			sqlParam							= sqlCmd.Parameters.Add("@StartDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= gmsObj.StartDate;

			sqlParam							= sqlCmd.Parameters.Add("@EndDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= gmsObj.EndDate;


			sqlParam							= sqlCmd.Parameters.Add("@Ver", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= 1;
			
			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.VarChar, 50);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			Int32 RETURN_ID = Convert.ToInt32(sqlCmd.Parameters["@Id"].Value);

			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);

			sqlConn.Close();
			sqlConn.Dispose();

			if(RETURN_STATUS)
			{
				throw new Exception("There was an error inserting the Games Schedule.");
		
				return 0;
			}

			return RETURN_ID;
		}
		
		public static int UpdateRecord(GamesSchedule GameSchedule)
		{
			ReturnStatus ret = GameSchedule.Validate();
			if(ret.Status == si.Pass)
			{
				SqlParameterCollection sqlParams = new SqlCommand().Parameters;
				
				SqlParameter sqlParam = sqlParams.Add("@Id", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.ID;

				sqlParam = sqlParams.Add("@HostStationFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.HostStationFk;

				sqlParam = sqlParams.Add("@GameTypeFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.GameTypeFk;

				sqlParam = sqlParams.Add("@StartDate", SqlDbType.DateTime);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.StartDate;

				sqlParam = sqlParams.Add("@EndDate", SqlDbType.DateTime);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.EndDate;

				sqlParam = sqlParams.Add("@Ver", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value = GameSchedule.Version;
				
				return ApplicationConnection.ExecuteNonQuery("spU_VtkGamesSchedule", sqlParams);
			}

			return 0;
		}
		public static int DeleteRecord(int GameScheduleId)
		{
			SqlParameter sqlParam = new SqlParameter("@Id", SqlDbType.Int);
			sqlParam.Value = GameScheduleId;
			return ApplicationConnection.ExecuteNonQuery("spD_VtkGamesSchedule", sqlParam);
		}
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateHostStationFk(HostStationFk, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateGameTypeFk(GameTypeFk, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStartDate(StartDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEndDate(EndDate);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for HostStationFk property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesScheduleBase.ValidateHostStationFk.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of HostStationFk</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateHostStationFk(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesScheduleBase.ValidateHostStationFk(value, appCon);
		 
			// TODO: Add property specific validation logic for 'HostStationFk'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for GameTypeFk property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesScheduleBase.ValidateGameTypeFk.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of GameTypeFk</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateGameTypeFk(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesScheduleBase.ValidateGameTypeFk(value, appCon);
		 
			// TODO: Add property specific validation logic for 'GameTypeFk'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StartDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesScheduleBase.ValidateStartDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StartDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStartDate(DateTime value)
		{
			ReturnStatus ret = GamesScheduleBase.ValidateStartDate(value);
		 
			// TODO: Add property specific validation logic for 'StartDate'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EndDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesScheduleBase.ValidateEndDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of EndDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateEndDate(DateTime value)
		{
			ReturnStatus ret = GamesScheduleBase.ValidateEndDate(value);
		 
			// TODO: Add property specific validation logic for 'EndDate'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'GamesSchedule'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkGamesSchedule table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkGamesSchedule entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>GamesSchedule</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>HostStationFk</b>  [Int32]</li>
		///  <li><b>GameTypeFk</b>  [Int32]</li>
		///  <li><b>StartDate</b>  [DateTime]</li>
		///  <li><b>EndDate</b>  [DateTime]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = "Select"
				 + " VGS." + GamesScheduleMsSqlSrv.idField + " As ID"
				 + ", VI." + InstitutionMsSqlSrv.nameOfInstitutionField + " As HostInstitutionName"
				 + ", VGS." + GamesScheduleMsSqlSrv.hostStationFkField + " As HostStationFk"
				 + ", VGT." + GameTypeMsSqlSrv.nameField + " As Name"
				 + ", VGT." + GameTypeMsSqlSrv.codeField + " As Code"
				 + ", VGS." + GamesScheduleMsSqlSrv.gameTypeFkField + " As GameTypeFk"
				 + ", VGS." + GamesScheduleMsSqlSrv.startDateField + " As StartDate"
				 + ", VGS." + GamesScheduleMsSqlSrv.endDateField + " As EndDate"
				 + ", VGS." + GamesScheduleMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName + " VGS"
				 + " INNER JOIN VtkGameType VGT ON VGS.GAmeTypeFk = VGT.Id"
				 + " INNER JOIN VtkInstitutions VI ON VGS.HostStationFK = VI.Id"; 

			StringBuilder command = new StringBuilder(sCommand);
			if(idValue != 0)
				command.Append(" WHERE VGS.Id = '" + idValue.ToString() + "' ");
			
			return ApplicationConnection.ExecuteQuery(command.ToString(), "GamesScheduleList");
		}

		public static DataSet GetQuickList()
		{
			return GetQuickList(0);
		}

		public static DataSet GetQuickListByGameScheduleId(int GameScheduleId)
		{
			SqlParameter sqlParam = new SqlParameter("@GameScheduleId", SqlDbType.Int);
									 sqlParam.Value = GameScheduleId;
			return GetQuickList(sqlParam);
		}
		public static DataSet GetQuickListByInstitutionId(int StationId)
		{
			SqlParameter sqlParam = new SqlParameter("@InstitutionId", SqlDbType.Int);
									 sqlParam.Value = StationId;
			return GetQuickList(sqlParam);
		}

		public static DataSet GetQuickListByGamesTypeId(int GamesTypeId)
		{
			SqlParameter sqlParam = new SqlParameter("@GamesTypeId", SqlDbType.Int);
			sqlParam.Value = GamesTypeId;		
			return GetQuickList(sqlParam);
		}
		
		public static DataSet GetQuickListByHostInstitutionId(int HostInstitutionId)
		{
			SqlParameter sqlParam = new SqlParameter("@HostInstitutionId", SqlDbType.Int);
			sqlParam.Value = HostInstitutionId;		
			return GetQuickList(sqlParam);
		}

		public static DataSet GetQuickList(SqlParameter sqlParam)
		{
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("spS_GamesListByInstitutionId_GamesTypeId_HostInstitutionId_GameScheduleId", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			sqlCmd.Parameters.Add(sqlParam);

			return ApplicationConnection.ExecuteQuery(sqlCmd, "GamesList");
		}
		#endif
		
		#endregion
		
		#region Section: Utilities
	
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
