﻿
/*

			Class:              Institution

			Date Produced:      10/2/2002 10:11:54 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        6/18/2002 11:43:05 AM
			Revision:           655

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text;

using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;

using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.InstitutionMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkInstitutions
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Institution : InstitutionBase
	{
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkInstitutions entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Institution(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Institution(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Institution thate will be used to add a record to the VtkInstitutions database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Institution"/></returns>
		public static Institution AddRecord(ApplicationConnection appCon)
		{
			Institution instObj = new Institution(appCon);
			instObj.FillDataNew();
			return instObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNameOfInstitution(NameOfInstitution);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationNumber(StationNumber);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateParentInstitutionId(ParentInstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAdministrativeParentId(AdministrativeParentId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStreetAddress1(StreetAddress1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStreetAddress2(StreetAddress2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCity(City);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStateId(StateId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateZipCode(ZipCode);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(StationNumber, ID);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NameOfInstitution property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateNameOfInstitution.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NameOfInstitution</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNameOfInstitution(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateNameOfInstitution(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationNumber property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateStationNumber.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationNumber</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStationNumber(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateStationNumber(value);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ParentInstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateParentInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ParentInstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateParentInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = InstitutionBase.ValidateParentInstitutionId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AdministrativeParentId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateAdministrativeParentId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AdministrativeParentId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAdministrativeParentId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = InstitutionBase.ValidateAdministrativeParentId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'AdministrativeParentId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StreetAddress1 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateStreetAddress1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StreetAddress1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStreetAddress1(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateStreetAddress1(value);
		 
			// TODO: Add property specific validation logic for 'StreetAddress1'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StreetAddress2 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateStreetAddress2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StreetAddress2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStreetAddress2(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateStreetAddress2(value);
		 
			// TODO: Add property specific validation logic for 'StreetAddress2'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for City property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateCity.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of City</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCity(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateCity(value);
		 
			// TODO: Add property specific validation logic for 'City'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StateId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateStateId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StateId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStateId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = InstitutionBase.ValidateStateId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'StateId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ZipCode property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling InstitutionBase.ValidateZipCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ZipCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateZipCode(string value)
		{
			ReturnStatus ret = InstitutionBase.ValidateZipCode(value);
		 
			// TODO: Add property specific validation logic for 'ZipCode'.
		 
			return ret;
		}		

		public static ReturnStatus CheckForDuplicates(string StationNumber, int InstitutionId)
		{
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkStationNumberExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@StationNumber", SqlDbType.VarChar, 7);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= StationNumber;
			
			sqlParam							= sqlCmd.Parameters.Add("@InstitutionId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionId;			

			sqlParam							= sqlCmd.Parameters.Add("@IsStationNumberExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISSTATIONNUMBEREXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsStationNumberExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Station";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the Institutions table.";		
			}
			else if(RETURN_ISSTATIONNUMBEREXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "StationNumber";
				ret.ErrorText = "'StationNumber'(" + StationNumber.ToString() + ") already exists, please enter another value.";
			}

			return ret;
		}
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'Institution'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkInstitutions table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkInstitutions entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>Institution</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>NameOfInstitution</b>  [string]</li>
		///  <li><b>StationNumber</b>  [string]</li>
		///  <li><b>ParentInstitutionId</b>  [Int32]</li>
		///  <li><b>AdministrativeParentId</b>  [Int32]</li>
		///  <li><b>StreetAddress1</b>  [string]</li>
		///  <li><b>StreetAddress2</b>  [string]</li>
		///  <li><b>City</b>  [string]</li>
		///  <li><b>StateId</b>  [Int32]</li>
		///  <li><b>ZipCode</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				+ InstitutionMsSqlSrv.idField + " As ID"
				+ ", " + InstitutionMsSqlSrv.nameOfInstitutionField + " As Name"
				+ ", " + InstitutionMsSqlSrv.stationNumberField + " As StationNumber"
				+ ", " + InstitutionMsSqlSrv.parentInstitutionIdField + " As ParentInstitutionId"
				+ ", " + InstitutionMsSqlSrv.administrativeParentIdField + " As AdministrativeParentId"
				+ ", " + InstitutionMsSqlSrv.streetAddress1Field + " As StreetAddress1"
				+ ", " + InstitutionMsSqlSrv.streetAddress2Field + " As StreetAddress2"
				+ ", " + InstitutionMsSqlSrv.cityField + " As City"
				+ ", " + InstitutionMsSqlSrv.stateIdField + " As StateId"
				+ ", " + InstitutionMsSqlSrv.zipCodeField + " As ZipCode"
				+ ", " + InstitutionMsSqlSrv.versionField + " As Version"
				+ " FROM  " + sqlDrv.tableName 
				+ " WHERE Id = '" + idValue + "' ";
			
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"InstitutionList");
			da.Dispose();
			return ds;
		}
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkInstitutions table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkInstitutions entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>Institution</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>NameOfInstitution</b>  [string]</li>
		///  <li><b>StationNumber</b>  [string]</li>
		///  <li><b>ParentInstitutionId</b>  [Int32]</li>
		///  <li><b>AdministrativeParentId</b>  [Int32]</li>
		///  <li><b>StreetAddress1</b>  [string]</li>
		///  <li><b>StreetAddress2</b>  [string]</li>
		///  <li><b>City</b>  [string]</li>
		///  <li><b>StateId</b>  [Int32]</li>
		///  <li><b>ZipCode</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  <li>Sorted By:  <b>Not Specified</b></li>
		///  </ul>
		/// </returns>
		public static DataSet GetQuickList()
		{
			string sCommand = "Select "
				+ sqlDrv.idField + " As ID"
				+ ", " + sqlDrv.nameOfInstitutionField + " As Name"
				+ ", " + sqlDrv.stationNumberField + " As StationNumber"
				+ ", " + sqlDrv.nameOfInstitutionField   + "  + ' (' + " + sqlDrv.stationNumberField + " + ')' AS DisplayName"
				+ ", " + sqlDrv.parentInstitutionIdField + " As ParentInstitutionId"
				+ ", " + sqlDrv.administrativeParentIdField + " As AdministrativeParentId"
				+ ", " + sqlDrv.streetAddress1Field + " As StreetAddress1"
				+ ", " + sqlDrv.streetAddress2Field + " As StreetAddress2"
				+ ", " + sqlDrv.cityField + " As City"
				+ ", " + sqlDrv.stateIdField + " As StateId"
				+ ", " + sqlDrv.zipCodeField + " As ZipCode"
				+ ", " + sqlDrv.versionField + " As Version"
				+ " FROM  " + sqlDrv.tableName
				+ " Order By " + sqlDrv.nameOfInstitutionField ;
		
			//return ApplicationConnection.ExecuteQuery(sCommand, "InstitutionList");
			return ApplicationConnection.ExecuteQueryRetry(sCommand, "InstitutionList", 3);
		}
		
		/// Returns a list of all Institutions in the NameObjectCollection.
		/// DataReader: 
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>nameOfInstitution</b>  [string]</li>
		///  </ul>
		/// <br></br>
		/// </returns>
		public static NameObjectCollection GetQuickDRList()
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "Select "
				+ sqlDrv.idField + " As ID"
				+ ", " + sqlDrv.nameOfInstitutionField   + "  + ' (' + " + sqlDrv.stationNumberField + " + ')' AS DisplayName"
				+ " FROM  " + sqlDrv.tableName;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkInstitutions table.>
		/// </summary>
		/// <param type="ApplicationConnection"/>
		/// <param type="string"/>
		/// <returns type="DataSet"/>
		public static DataSet GetQuickList(string InstitutionExcludes)
		{
			string sCommand = "Select "
				+ sqlDrv.idField + " As ID"
				+ ", " + sqlDrv.nameOfInstitutionField + " As Name"
				+ ", " + sqlDrv.stationNumberField + " As StationNumber"
				+ ", " + sqlDrv.nameOfInstitutionField   + "  + ' (' + " + sqlDrv.stationNumberField + " + ')' AS DisplayName"
				+ ", " + sqlDrv.parentInstitutionIdField + " As ParentInstitutionId"
				+ ", " + sqlDrv.administrativeParentIdField + " As AdministrativeParentId"
				+ ", " + sqlDrv.streetAddress1Field + " As StreetAddress1"
				+ ", " + sqlDrv.streetAddress2Field + " As StreetAddress2"
				+ ", " + sqlDrv.cityField + " As City"
				+ ", " + sqlDrv.stateIdField + " As StateId"
				+ ", " + sqlDrv.zipCodeField + " As ZipCode"
				+ ", " + sqlDrv.versionField + " As Version"
				+ " FROM  " + sqlDrv.tableName
				+ " Where " + sqlDrv.stationNumberField + " NOT IN (" + InstitutionExcludes + ")";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "InstitutionList");
		}
		
		/// <summary>
		/// Returns the institution with the Id input in the parentId param
		/// and all Institutions where the ParentId equals the parentInstitutionId
		/// </summary>
		/// <param name="parentId">ParentInstitutionId</param>
		/// <param name="appCon">ApplicationConnection Object Reference</param>
		/// <returns>
		/// <br>DataSet TableName: <b>InstitutionList</b></br>
		/// <br></br>
		/// <br>Data Columns Returned: </br>
		/// <br><b>ID</b> [int]</br>
		/// <br><b>Name</b> [string (40)]</br>
		/// <br><b>StationNumber</b> [string (7)]</br>
		/// <br><b>DisplayName</b> combination of Name and StationNumber (i.e. 'Name (number)')</br>
		/// <br><b>ParentInstitutionId</b> [int]</br>
		/// <br><b>StateId</b>	[int]</br>
		/// <br><b>AdministrativeParentId</b> [int]</br>
		/// <br></br>
		/// <br>Sorted By:  <b>Name</b></br>
		/// </returns>
		public static DataSet GetQuickListByParent(int parentId)
		{
			string sCommand = "Select id ID, "     + 
				sqlDrv.nameOfInstitutionField      + " Name, " +
				sqlDrv.stationNumberField          + " StationNumber, " +
				sqlDrv.nameOfInstitutionField + " + ' (' + "    + sqlDrv.stationNumberField + " + ')' AS DisplayName, " +
				sqlDrv.parentInstitutionIdField    + " ParentInstitutionId, " +
				sqlDrv.stateIdField                + " StateId, " +
				sqlDrv.administrativeParentIdField + " AdministrativeParentId " +
				" FROM " + InstitutionMsSqlSrv.tableName +
				" WHERE " + sqlDrv.parentInstitutionIdField + " = '" + parentId.ToString() + "' " +
				" OR " + sqlDrv.idField + " = '" + parentId.ToString() + "' " + 
				" ORDER BY " + sqlDrv.nameOfInstitutionField;

			return ApplicationConnection.ExecuteQuery(sCommand, "InstitutionList");
		}

		/// <summary>
		/// Returns the institutions with the Visn (AdministrativeParent) input in
		/// the adminId param
		/// </summary>
		/// <param name="adminId">AdministrativeParentId</param>
		/// <param name="appCon">ApplicationConnection Object Reference</param>
		/// <returns>
		/// <br>DataSet TableName: <b>InstitutionList</b></br>
		/// <br>Data Columns Returned: </br>
		/// <br><b>ID</b> [int]</br>
		/// <br><b>Name</b> [string (40)]</br>
		/// <br><b>StationNumber</b> [string (7)]</br>
		/// <br><b>DisplayName</b> combination of Name and StationNumber (i.e. 'Name (number)')</br>
		/// <br><b>ParentInstitutionId</b> [int]</br>
		/// <br><b>StateId</b>	[int]</br>
		/// <br><b>AdministrativeParentId</b> [int]</br>
		/// <br></br>
		/// <br>Sorted By:  <b>Name</b></br>
		/// </returns>
		public static DataSet GetQuickListByVISN(int adminId)
		{
			// TODO: Stored Procedure: (3) This quicklist was requested.
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.nameOfInstitutionField      + " Name, " +
				sqlDrv.stationNumberField          + " StationNumber, " +
				sqlDrv.nameOfInstitutionField + "  + ' (' + " + sqlDrv.stationNumberField + " + ')' AS DisplayName, " +
				sqlDrv.parentInstitutionIdField    + " ParentInstitutionId, " +
				sqlDrv.stateIdField                + " StateId, " +
				sqlDrv.administrativeParentIdField + " AdministrativeParentId " +
				" FROM " + sqlDrv.tableName + " " +
				" WHERE " + sqlDrv.administrativeParentIdField + " = '" + adminId.ToString() + "' " +
				" ORDER BY " + sqlDrv.nameOfInstitutionField;

			return ApplicationConnection.ExecuteQuery(sCommand, "InstitutionList");
		}

		public static int GetStationId(string StationNumber)
		{
			string sCommand = "SELECT id ID FROM VtkInstitutions WHERE StationNumber = '" + StationNumber + "'";
			DataSet ds = ApplicationConnection.ExecuteQuery(sCommand, "Institution");

			DataTable dt = ds.Tables["Institution"];
			if(dt.Rows.Count == 1)
				return Convert.ToInt32(dt.Rows[0]["ID"]);
			else
				return 0;
		}
		#endif

		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
