﻿
/*

			Class:              RollupLog

			Date Produced:      3/19/2002 11:59:58 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.RollupLogMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkRollupLog
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class RollupLog : RollupLogBase
	{		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkRollupLog entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public RollupLog(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private RollupLog(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of RollupLog thate will be used to add a record to the VtkRollupLog database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="RollupLog"/></returns>
		public static RollupLog AddRecord(ApplicationConnection appCon)
		{
			RollupLog rulObj = new RollupLog(appCon);
			rulObj.FillDataNew();
			return rulObj;
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
		
// TODO: Id is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
		
// TODO: RollupRun is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRollupRun(RollupRun);
		
// TODO: RollupEnd is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRollupEnd(RollupEnd);
		
// TODO: ClosedMonth is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateClosedMonth(ClosedMonth);
		
// TODO: RegularRowsInserted is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRegularRowsInserted(RegularRowsInserted);
		
// TODO: OccasionalRowsInserted is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOccasionalRowsInserted(OccasionalRowsInserted);
		
// TODO: IsSuccessful is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsSuccessful(IsSuccessful);
		
// TODO: History is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateHistory(History);
		
// TODO: Ver is NEW!! Evaluate! Change IsNewColumn extended property to 'false'.
		
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for RollupRun property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateRollupRun.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of RollupRun</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRollupRun(DateTime value)
		{
			ReturnStatus ret = RollupLogBase.ValidateRollupRun(value);
		 
			// TODO: Add property specific validation logic for 'RollupRun'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for RollupEnd property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateRollupEnd.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of RollupEnd</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRollupEnd(DateTime value)
		{
			ReturnStatus ret = RollupLogBase.ValidateRollupEnd(value);
		 
			// TODO: Add property specific validation logic for 'RollupEnd'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ClosedMonth property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateClosedMonth.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ClosedMonth</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateClosedMonth(DateTime value)
		{
			ReturnStatus ret = RollupLogBase.ValidateClosedMonth(value);
		 
			// TODO: Add property specific validation logic for 'ClosedMonth'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for RegularRowsInserted property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateRegularRowsInserted.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of RegularRowsInserted</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRegularRowsInserted(Int32 value)
		{
			ReturnStatus ret = RollupLogBase.ValidateRegularRowsInserted(value);
		 
			// TODO: Add property specific validation logic for 'RegularRowsInserted'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OccasionalRowsInserted property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateOccasionalRowsInserted.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of OccasionalRowsInserted</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateOccasionalRowsInserted(Int32 value)
		{
			ReturnStatus ret = RollupLogBase.ValidateOccasionalRowsInserted(value);
		 
			// TODO: Add property specific validation logic for 'OccasionalRowsInserted'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsSuccessful property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateIsSuccessful.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsSuccessful</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsSuccessful(bool value)
		{
			ReturnStatus ret = RollupLogBase.ValidateIsSuccessful(value);
		 
			// TODO: Add property specific validation logic for 'IsSuccessful'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for History property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling RollupLogBase.ValidateHistory.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of History</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateHistory(string value)
		{
			ReturnStatus ret = RollupLogBase.ValidateHistory(value);
		 
			// TODO: Add property specific validation logic for 'History'.
		  
			return ret;
		}
		 
				
		/// <summary>
		/// Checks to see if the given MM/YY combo is able to be edited based on the LastMonth in the database.
		/// </summary>
		/// <param name="MM"></param>
		/// <param name="YY"></param>
		/// <param name="appCon"></param>
		/// <returns></returns>
		public static bool IsMonthEditable(int MM, int YY)
		{

//			string sCommand = "VtkClosedMonthQuery";

//			DataSet ds = ApplicationConnection.ExecuteQuery(sCommand, "NoneEditableMonth");
//			int CompareMM = Convert.ToInt32(ds.Tables["NoneEditableMonth"].Rows[0]["ClosedMonth"]);
//			int CompareYY = Convert.ToInt32(ds.Tables["NoneEditableMonth"].Rows[0]["ClosedYear"]);
	      
			return IsClosedMonth(new DateTime(YY, MM, 01), GetClosedMonth());


		}

		/// <summary>
		/// Checks to see if the given MM/YY combo is able to be edited based on the LastMonth in the database.
		/// </summary>
		/// <returns type="DateTime"/>
		public static DateTime GetClosedMonth()
		{
			string sCommand = "VtkClosedMonthQuery";
			int CompareMM = 0;
			int CompareYY = 0;

			SqlCommand sqlCommand = new SqlCommand();
			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			

//			DataSet ds = ApplicationConnection.ExecuteQuery(sCommand, "NoneEditableMonth");

			NameObjectCollection cmList = ApplicationConnection.ExecuteReader(sqlCommand);

			if (cmList.Count > 0)
			{
				NameObjectCollection cmRec = (NameObjectCollection)cmList.Get(0);
				if (cmRec.Count > 0)
				{
					CompareMM = (int)cmRec.Get("Column1");
					CompareYY = (int)cmRec.Get("Column2");
				}
				cmRec.Dispose();
			}
					
			cmList.Dispose();

//			int CompareMM = Convert.ToInt32(ds.Tables["NoneEditableMonth"].Rows[0]["ClosedMonth"]);
//			int CompareYY = Convert.ToInt32(ds.Tables["NoneEditableMonth"].Rows[0]["ClosedYear"]);
      
			return new DateTime(CompareYY, CompareMM, 01);
		}

		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'RollupLog'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkRollupLog table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkRollupLog entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>RollupLog</b></li></ul>
		/// <br />
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>RollupRun</b>  [DateTime]</li>
		///  <li><b>RollupEnd</b>  [DateTime]</li>
		///  <li><b>ClosedMonth</b>  [DateTime]</li>
		///  <li><b>RegularRowsInserted</b>  [Int32]</li>
		///  <li><b>OccasionalRowsInserted</b>  [Int32]</li>
		///  <li><b>IsSuccessful</b>  [bool]</li>
		///  <li><b>History</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br />
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select "
				 + RollupLogMsSqlSrv.idField + " As ID"
				 + ", " + RollupLogMsSqlSrv.rollupRunField + " As RollupRun"
				 + ", " + RollupLogMsSqlSrv.rollupEndField + " As RollupEnd"
				 + ", " + RollupLogMsSqlSrv.closedMonthField + " As ClosedMonth"
				 + ", " + RollupLogMsSqlSrv.regularRowsInsertedField + " As RegularRowsInserted"
				 + ", " + RollupLogMsSqlSrv.occasionalRowsInsertedField + " As OccasionalRowsInserted"
				 + ", " + RollupLogMsSqlSrv.isSuccessfulField + " As IsSuccessful"
				 + ", " + RollupLogMsSqlSrv.historyField + " As History"
				 + ", " + RollupLogMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "RollupLogList");
		}

		#endif
		#endregion
		
		#region Section: Utilities
		/// <summary>
		/// CheckForClosedMonth Takes 2 DateTime Ojects which will be used in a greater than operation
		/// to see if the MMYY DateTime is greater than the CompareMMYY. If the comparison
		/// is successfull then true is returned indicating that it is a valid month to 
		/// use. Otherwise, false is returned indicating it is uneditable.
		/// </summary>
		/// <param name="MMYY">Month/Year you are attempting to edit.</param>
		/// <param name="CompareMMYY">Last Month/Year which is uneditable.</param>
		/// <returns>bool</returns>
    public static bool IsClosedMonth(DateTime MMYY, DateTime CompareMMYY)
    {
      return MMYY > CompareMMYY;
    }

		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
