﻿
/*

			Class:              NACStatus

			Date Produced:      3/8/2002 1:13:32 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        3/7/2002 10:53:17 AM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.789.33698\Vha.Vtk.NationalOfficials

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.789.33698

*/

#define msSql		
#region Section: Using Declarations		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;

using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.NACStatusMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.NationalOfficials
{
	/// <summary>
	///  Public Class mapped to VtkNACStatuses
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class NACStatus : NACStatusBase
	{		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkNACStatuses entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public NACStatus(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private NACStatus(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of NACStatus thate will be used to add a record to the VtkNACStatuses database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="NACStatus"/></returns>
		public static NACStatus AddRecord(ApplicationConnection appCon)
		{
			NACStatus nacObj = new NACStatus(appCon);
			nacObj.FillDataNew();
			return nacObj;
		}		
		#endregion
				
		#region Section: Field Validaters		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMembershipStatus(MembershipStatus);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDescription(Description);
		
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MembershipStatus property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NACStatusBase.ValidateMembershipStatus.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MembershipStatus</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMembershipStatus(string value)
		{
			ReturnStatus ret = NACStatusBase.ValidateMembershipStatus(value);
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Description property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NACStatusBase.ValidateDescription.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Description</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDescription(string value)
		{
			ReturnStatus ret = NACStatusBase.ValidateDescription(value);
			return ret;
		}	
		#endregion
				
		#region Section: Quick Lists
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkNACStatuses table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkNACStatuses entry</param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>NACStatus</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>MembershipStatus</b>  [string]</li>
		///  <li><b>Description</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select "
				 + NACStatusMsSqlSrv.idField + " As ID"
				 + ", " + NACStatusMsSqlSrv.membershipStatusField + " As MembershipStatus"
				 + ", " + NACStatusMsSqlSrv.descriptionField + " As Description"
				 + ", " + NACStatusMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
			
			SqlDataAdapter da = new SqlDataAdapter(sCommand, ApplicationConnection.GetConnectionString());
			DataSet ds = new DataSet();
			da.Fill(ds,"NACStatusList");
			da.Dispose();
			return ds;
		}		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkNACStatuses table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkNACStatuses entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>NACStatus</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>MembershipStatus</b>  [string]</li>
		///  <li><b>Description</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetNacStatusList()
		{
			string sCommand = 
				"Select "
				+ NACStatusMsSqlSrv.idField + " As ID"
				+ ", " + NACStatusMsSqlSrv.membershipStatusField + " As MembershipStatus"
				+ ", " + NACStatusMsSqlSrv.descriptionField + " As Description"
				+ ", " + NACStatusMsSqlSrv.versionField + " As Version"
				+ " FROM  " + sqlDrv.tableName;
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, ApplicationConnection.GetConnectionString());
			DataSet ds = new DataSet();
			da.Fill(ds,"NACStatusList");
			da.Dispose();
			return ds;
		}		
		#endif		
		#endregion
		
		#region Section: Utilities		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
