﻿
/*

			Class:              StaffTitle

			Date Produced:      3/8/2002 1:13:32 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        3/7/2002 10:53:17 AM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.789.33698\Vha.Vtk.ServicesDirectory

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.789.33698

*/

// TODO: VtkStaffTitles is NEW!! Evaluate! Change IsNewTable extended property to 'false'.
#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.StaffTitleMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.ServicesDirectory
{
	/// <summary>
	///  Public Class mapped to VtkStaffTitles
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class StaffTitle : StaffTitleBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkStaffTitles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public StaffTitle(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private StaffTitle(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of StaffTitle thate will be used to add a record to the VtkStaffTitles database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="StaffTitle"/></returns>
		public static StaffTitle AddRecord(ApplicationConnection appCon)
		{
			StaffTitle sttlObj = new StaffTitle(appCon);
			sttlObj.FillDataNew();
			return sttlObj;
		}
		
		#endregion
					
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTitle(Title);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsVolChiefSupervisor(IsVolChiefSupervisor);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDescription(Description);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateScope(Scope);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(Title, Scope, InstitutionId, ID);
			return returnStatus;
		}
		
		public static ReturnStatus CheckForDuplicates(string StaffTitle, string Scope, int InstitutionId, int ID)
		{			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkStaffTitleExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@StaffTitle", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= StaffTitle;

			sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= "N";
			
			sqlParam							= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionId;
			
			sqlParam							= sqlCmd.Parameters.Add("@StaffTitleId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;
			
			sqlParam							= sqlCmd.Parameters.Add("@IsStaffTitleExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISSTAFFTITLEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsStaffTitleExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "StaffTitle";
			if(RETURN_ISSTAFFTITLEEXISTING)
			{
				ret.Status = si.Fail;
				if(Scope == "N")
					ret.ErrorText = "'StaffTitle'(" + StaffTitle + ")  already exists Nationally, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate a 'StaffTitle'(" + StaffTitle + ")  which already exists Nationally, please enter another value.";
			}
			else if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "StaffTitle";
				ret.ErrorText = "An error occured checking for duplicate StaffTitles.";
			}
			
			if(ret.Status == si.Pass && Scope == "L")
			{	
				//Run a DB Check to see if another Volunteer exists with this SSN
				sqlConn					= new SqlConnection(ApplicationConnection.GetConnectionString());

				sqlCmd					= new SqlCommand("VtkStaffTitleExistsQuery", sqlConn);
				sqlCmd.CommandType		= CommandType.StoredProcedure;

				sqlParam				= sqlCmd.Parameters.Add("@StaffTitle", SqlDbType.VarChar, 30);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= StaffTitle;

				sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= "L";
			
				sqlParam							= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= InstitutionId;
			
				sqlParam							= sqlCmd.Parameters.Add("@StaffTitleId", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= ID;
			
				sqlParam							= sqlCmd.Parameters.Add("@IsStaffTitleExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.ReturnValue;

				sqlConn.Open();
				sqlCmd.ExecuteNonQuery();

				RETURN_ISSTAFFTITLEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsStaffTitleExisting"].Value);
				RETURN_STATUS			= Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
				sqlConn.Close();

				ret						= new ReturnStatus();
				ret.ClassName			= "StaffTitle";
				if(RETURN_ISSTAFFTITLEEXISTING)
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StaffTitle'(" + StaffTitle + ")  already exists Locally, please enter another value.";
				}
				else if(RETURN_STATUS)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "StaffTitle";
					ret.ErrorText = "An error occured checking for duplicate StaffTitles.";
				}
			}
			return ret;
		}
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Title property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StaffTitleBase.ValidateTitle.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Title</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateTitle(string value)
		{
			ReturnStatus ret = StaffTitleBase.ValidateTitle(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsVolChiefSupervisor property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StaffTitleBase.ValidateIsVolChiefSupervisor.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsVolChiefSupervisor</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsVolChiefSupervisor(bool value)
		{
			ReturnStatus ret = StaffTitleBase.ValidateIsVolChiefSupervisor(value);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Description property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StaffTitleBase.ValidateDescription.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Description</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDescription(string value)
		{
			ReturnStatus ret = StaffTitleBase.ValidateDescription(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Scope property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StaffTitleBase.ValidateScope.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = StaffTitleBase.ValidateScope(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StaffTitleBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StaffTitleBase.ValidateInstitutionId(value, appCon);
			return ret;
		}		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'StaffTitle'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkStaffTitles table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkStaffTitles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>StaffTitle</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>Title</b>  [string]</li>
		///  <li><b>IsVolChiefSupervisor</b>  [bool]</li>
		///  <li><b>Description</b>  [string]</li>
		///  <li><b>Scope</b>  [string]</li>
		///  <li><b>InstitutionId</b>  [Int32]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				 + StaffTitleMsSqlSrv.idField + " As ID"
				 + ", " + StaffTitleMsSqlSrv.titleField + " As Title"
				 + ", " + StaffTitleMsSqlSrv.isVolChiefSupervisorField + " As IsVolChiefSupervisor"
				 + ", " + StaffTitleMsSqlSrv.descriptionField + " As Description"
				 + ", " + StaffTitleMsSqlSrv.scopeField + " As Scope"
				 + ", " + StaffTitleMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + StaffTitleMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"StaffTitleList");
			da.Dispose();
			return ds;
    }
    /// <summary>
    /// Basic method the retrieves all the fields for an entry in the VtkStaffTitles table.>
    /// </summary>
    /// <param name="InstitutionId">
    /// 0 will give you National Titles, 
    /// Any Int will give you a specific Institution if one exists with that Id, 
    /// </param>
    /// <param name="IsVolChiefSupervisor">
    /// 0 = false<br/>
    /// 1 = true<br/>
    /// 2 = NULL
    /// </param>
    /// <param name="appCon">ApplicationConnection Object</param>
    /// <returns>
    /// Returns dataset for entry.
    /// <li>DataSet TableName:</li> <ul><li><b>StaffTitle</b></li></ul>
    /// <br></br>
    /// <li>Data Columns Returned:</li>
    ///  <ul>
    ///  <li><b>ID</b>  [Int32]</li>
    ///  <li><b>Title</b>  [string]</li>
    ///  </ul>
    /// <br> </br>
    /// <li>Sorted By:  <b>Not Specified</b></li>
    /// </returns>
    public static DataSet GetQuickList(int InstitutionId, byte IsVolChiefSupervisor, ApplicationConnection appCon)
    {
      string sCommand = "VtkStaffTitlesQuery ";
      if(IsVolChiefSupervisor == 0 || IsVolChiefSupervisor == 1)
      {
        sCommand += InstitutionId + ", " + IsVolChiefSupervisor;
      }
      else if(IsVolChiefSupervisor == 2)
      {
        sCommand += InstitutionId + ", NULL";
      }
		
      SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
      DataSet ds = new DataSet();
      da.Fill(ds,"StaffTitleList");
      da.Dispose();
      return ds;
    }
		
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
