﻿
/*

			Class:              SupervisedPrograms

			Date Produced:      3/14/2002 3:04:54 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\Vha.Vtk.ServicesDirectory

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

// TODO: VtkSupervisedPrograms is NEW!! Evaluate! Change IsNewTable extended property to 'false'.
#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.SupervisedProgramsMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.ServicesDirectory
{
	/// <summary>
	///  Public Class mapped to VtkSupervisedPrograms
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class SupervisedPrograms : SupervisedProgramsBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkSupervisedPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public SupervisedPrograms(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private SupervisedPrograms(ApplicationConnection appCon) : base(appCon)
		{
		}
		
    /// <summary>
    /// Creates an instance of SupervisedPrograms thate will be used to add a record to the VtkSupervisedPrograms database table.
    /// </summary>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns><see cref="SupervisedPrograms"/></returns>
    public static SupervisedPrograms AddRecord(ApplicationConnection appCon)
    {
      SupervisedPrograms ssdObj = new SupervisedPrograms(appCon);
      ssdObj.FillDataNew();
      return ssdObj;
    }
    /// <summary>
    /// Creates an instance of SupervisedPrograms thate will be used to add a record to the VtkSupervisedPrograms database table.
    /// </summary>
    /// <Params>
    /// <param name="programId" type="System.Int"></param>
    /// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
    /// </Params>
    /// <returns type="Vha.Vtk.ServicesDirectory.SupervisedPrograms"></returns>
    public static SupervisedPrograms AddRecord(int programId, ApplicationConnection appCon)
    {
      SupervisedPrograms ssdObj = new SupervisedPrograms(appCon);
      ssdObj.FillDataNew();
      ssdObj.ProgramId = programId;
      return ssdObj;
    }
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateProgramId(ProgramId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(ProgramId, InstitutionId, ID);
			return returnStatus;
		}
		
		public static ReturnStatus CheckForDuplicates(int ProgramFK, int InstitutionFK, int ID)
		{						
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkSupervisedProgramExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@ProgramFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ProgramFK;

			sqlParam							= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionFK;

			sqlParam							= sqlCmd.Parameters.Add("@SupervisedProgramId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;

			sqlParam							= sqlCmd.Parameters.Add("@IsSupervisedProgramExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISSUPERVISEDPROGRAMEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsSupervisedProgramExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Organization";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the Organization table.";		
			}
			else if(RETURN_ISSUPERVISEDPROGRAMEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "SupervisedProgram";
				ret.ErrorText = "'SupervisedProgram'(ProgramId/InstitutionId Pair " + ProgramFK + " and " + InstitutionFK + ")  already exists, please enter another value pair.";
			}

			return ret;
		}
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ProgramId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling SupervisedProgramsBase.ValidateProgramId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ProgramId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateProgramId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = SupervisedProgramsBase.ValidateProgramId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'ProgramId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling SupervisedProgramsBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = SupervisedProgramsBase.ValidateInstitutionId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'InstitutionId'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'SupervisedPrograms'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkSupervisedPrograms table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkSupervisedPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName: <b>SupervisedPrograms</b></li>
		/// <br />
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>ProgramId</b>  [Int32]</li>
		///  <li><b>InstitutionId</b>  [Int32]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br/>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				 + SupervisedProgramsMsSqlSrv.idField + " As ID"
				 + ", " + SupervisedProgramsMsSqlSrv.programIdField + " As ProgramId"
				 + ", " + SupervisedProgramsMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + SupervisedProgramsMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName;
			if(idValue != 0)
				 sCommand += " WHERE Id = '" + idValue + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"SupervisedProgramsList");
			da.Dispose();
			return ds;
		}
		
    /// <summary>
    /// Basic method the retrieves all the fields for an entry in the VtkSupervisedPrograms table.>
    /// </summary>
    /// <param name="InstitutionId">Primary key value for VtkSupervisedPrograms entry</param>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns>
    /// Returns dataset for entry.
    /// <li>DataSet TableName: <b>SupervisedPrograms</b></li>
    /// <br />
    /// <li>Data Columns Returned:</li>
    ///  <ul>
    ///  <li><b>ProgramId</b>  [Int32]</li>
    ///  <li><b>ProgramCode</b>  [Int32]</li>
    ///  <li><b>ProgramName</b>  [Int32]</li>
    ///  <li><b>DisplayProgram</b>  [Int32]</li>
    ///  </ul>
    /// <br/>
    /// <li>Sorted By:  <b>Not Specified</b></li>
    /// </returns>
    public static DataSet GetQuickListByInstitutionId(int InstitutionId, ApplicationConnection appCon)
    {
      string sCommand = "VtkSupervisedProgramsQuery " + InstitutionId;
      SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
      DataSet ds = new DataSet();
      da.Fill(ds,"SupervisedProgramsList");
      da.Dispose();
      return ds;
    }
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
