﻿
/*

			Class:              SupervisedProgramsCollection

			Date Produced:      4/25/2002 8:21:34 AM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        4/23/2002 2:50:47 PM
			Revision:           620

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.842.2440\Vha.Vtk.ServicesDirectory

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.842.2440

*/

#define msSql
#define transAction
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.ServicesDirectory
{
    /// <summary>
    /// A collection that stores <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> objects.
    /// </summary>
    /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>
    [Serializable()]
    #if msSql
    public class SupervisedProgramsCollection : MsSqlDataSrvCollection {
    #endif
        
        private int institutionId;
        
        /// <summary>
        /// Initializes a new instance of <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name="institutionId">Primary key for an entry in VtkSupervisedPrograms table</param>
        /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
        public SupervisedProgramsCollection(int institutionId, ApplicationConnection appCon) {
             this.institutionId = institutionId;
             this.appCon   = appCon;
             Populate(institutionId);
        }
        
        #if msSql
        /// <summary>
        /// Populates the collection with <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> instances for the specified station.
        /// </summary>
        /// <param name="institutionId">Primary key for an entry in VtkSupervisedPrograms table</param>
        public void Populate(int institutionId)
        {
              Hashtable entries = new Hashtable();
              foreach(SupervisedPrograms entry in List)
              {
                   entries.Add(entry.ID, entry);
              }
      
              int keyId;
              SupervisedPrograms refObj;
              SqlDataAdapter da = new SqlDataAdapter("SELECT id, " + SupervisedProgramsMsSqlSrv.institutionIdField + " FROM VtkSupervisedPrograms WHERE " + SupervisedProgramsMsSqlSrv.institutionIdField + " = " + institutionId.ToString(), appCon.ConnectString);
              DataSet ds = new DataSet();
              da.Fill(ds, "VtkSupervisedPrograms");
              da.Dispose();
              DataTable dt = ds.Tables["VtkSupervisedPrograms"];
              if (dt == null) return;
              DataRow dr;
        
              for (int row = 0 ; row < dt.Rows.Count ; row++)
              {
                     dr = dt.Rows[row];
                     keyId = (int)dr["id"];
                     if(entries.ContainsKey(keyId))
                     {
                            refObj = (SupervisedPrograms)entries[keyId];
                            refObj.Refresh();
                            entries.Remove(keyId);
                     }
                     else
                     {
                            refObj = new SupervisedPrograms((int)dr["id"], appCon);
                            Add(refObj);
                     }
             }
        
              // remove existing entries that the database no longer contains (rare)
              IDictionaryEnumerator entryEnum = entries.GetEnumerator();
              while (entryEnum.MoveNext()) List.Remove(entryEnum.Value);
        }
        #endif
        
        /// <summary>
        /// Initializes a new instance of <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> based on another <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name='value'>
        ///       A <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> from which the contents are copied
        /// </param>
        public SupervisedProgramsCollection(SupervisedProgramsCollection value) {
            this.AddRange(value);
        }
        
        /// <summary>
        /// Initializes a new instance of <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> containing any array of <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> objects.
        /// </summary>
        /// <param name='value'>
        ///       A array of <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> objects with which to intialize the collection
        /// </param>
        public SupervisedProgramsCollection(SupervisedPrograms[] value) {
            this.AddRange(value);
        }
        
        /// <summary>
        /// Represents the entry at the specified index of the <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/>.
        /// </summary>
        /// <param name='index'>The zero-based index of the entry to locate in the collection.</param>
        /// <value>
        /// The entry at the specified index of the collection.
        /// </value>
        /// <exception cref='System.ArgumentOutOfRangeException'><paramref name='index'/> is outside the valid range of indexes for the collection.</exception>
        public SupervisedPrograms this[int index] {
            get {
                return ((SupervisedPrograms)(List[index]));
            }
            set {
                List[index] = value;
            }
        }
        
        /// <summary>
        /// Adds a <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> with the specified value to the 
        /// <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> .
        /// </summary>
        		/// <param name="value">Reference to a <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/> variable.</param>
        /// <returns>
        /// The index at which the new element was inserted. Reference returned in 'out' parameter.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.AddRange'/>
        public int Add(out SupervisedPrograms value) {
            value = SupervisedPrograms.AddRecord(institutionId, appCon);
            return List.Add(value);
        }
        
        /// <summary>
        /// Adds a <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> with the specified value to the 
        ///    <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name='value'>The <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> to add.</param>
        /// <returns>
        /// The index at which the new element was inserted.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.AddRange'/>
        private int Add(SupervisedPrograms value) {
            return List.Add(value);
        }
        
        /// <summary>
        /// Mark instance of <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> in the collection as Deleted.
        /// </summary>
        /// <param name="value">Instance of <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/> in the collection.</param>
        public void Delete(SupervisedPrograms value) {
            value.Delete();
        }
        
        /// <summary>
        /// Copies the elements of an array to the end of the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name='value'>
        ///    An array of type <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> containing the objects to add to the collection.
        /// </param>
        /// <returns>
        /// None.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.Add'/>
        private void AddRange(SupervisedPrograms[] value) {
            for (int i = 0; (i < value.Length); i = (i + 1)) {
                this.Add(value[i]);
            }
        }
        
        /// <summary>
        /// Adds the contents of another <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> to the end of the collection.
        /// </summary>
        /// <param name='value'>
        ///    A <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> containing the objects to add to the collection.
        /// </param>
        /// <returns>
        /// None.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.Add'/>
        private void AddRange(SupervisedProgramsCollection value) {
            for (int i = 0; (i < value.Count); i = (i + 1)) {
                this.Add(value[i]);
            }
        }
        
		/// <summary>
		/// Saves the collection of <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> instances to the database.
		/// </summary>
		public void Save()
		{
			ReturnStatus returnStatus = ValidateCollection();
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
        
			try
			{
				DoBeginTransaction();
				ArrayList deletedList = new ArrayList();
				foreach(SupervisedPrograms oRef in List)
				{
					// keep track of to be deleted and new entries
					if (oRef.IsDeleted) deletedList.Add(oRef);
					//if ((oRef.IsNew) && (!oRef.IsDeleted)) oRef.InstitutionId = this.institutionId;
					oRef.Save();
				}
				DoCommitTransaction();
	   
				// remove objects from list
				for(int i=0; i < deletedList.Count ;i++)
				{
					List.Remove(deletedList[i]);
				}
				Populate(institutionId);
			}
			catch (Exception e)
			{
				DoRollbackTransaction();
				throw e;
			}
		}
        
        /// <summary>
        /// Performs validation rules that apply across all <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> instances in the collection,
        /// like checking for duplicate organization entries.
        /// </summary>
        /// <remarks>This method is called by the <see cref="Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.Save"/> method.</remarks>
        /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus" /></returns>
        public ReturnStatus ValidateCollection()
        {
        	ReturnStatus ret = new ReturnStatus();
        	return ret;
        }
        
       /// <summary>
       /// Searches the collection for an <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> instance that matches the specified id.
       /// </summary>
       /// <remarks>If a match is found, a reference to the instance is returned. Otherwise, null is returned.</remarks>
       /// <param name="id">Primary key for an entry in the VtkSupervisedPrograms table.</param>
       /// <returns>Matching <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/> instance.</returns>
       public SupervisedPrograms GetObjectForId(int id)
       {
              SupervisedPrograms ssdObj;
              for (int i = 0; (i < List.Count); i = (i + 1))
              {
                  ssdObj = this[i];
                  if (ssdObj.ID == id) return ssdObj;
              }
              return null;
       }
        
       /// <summary>
       /// Returns all rows in a DataSet to used for inserts, updates and deletes.
       /// Use SaveCollectionDataSet to save edits.
       /// </summary>
       /// <param name="institutionId">Primary key of entry in the VtkSupervisedPrograms table.</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
       /// <returns>
       /// Returns all rows
       /// <ul>
       /// <li>DataSet TableName:</li> <ul><li><b>SupervisedProgramsCollection</b></li></ul>
       /// <br></br>
       /// <li>Data Columns Returned:</li>
       ///  <ul>
       ///  <li><b>ID</b>  [Int32]</li>
       ///  <li><b>ProgramId</b>  [Int32]</li>
       ///  <li><b>InstitutionId</b>  [Int32]</li>
       ///  <li><b>Version</b>  [Int32]</li>
       ///  </ul>
       /// <br> </br>
       /// <li>Sorted By:  <b>Not Specified</b></li>
       /// </ul>
       /// </returns>
       public static DataSet GetCollectionDataSet(int institutionId, ApplicationConnection appCon)
       {
              string sCommand = 
              "Select "
                + "SP." + SupervisedProgramsMsSqlSrv.idField + " As ID"
                + ", SP." + SupervisedProgramsMsSqlSrv.programIdField + " As ProgramId"
                + ", VP." + ProgramsMsSqlSrv.programNameField + " As ProgramName"
                + ", SP." + SupervisedProgramsMsSqlSrv.institutionIdField + " As InstitutionId"
                + ", SP." + SupervisedProgramsMsSqlSrv.versionField + " As Version"
                + " FROM  " + SupervisedProgramsMsSqlSrv.tableName + " As SP"
                + " INNER JOIN " + ProgramsMsSqlSrv.tableName + " As VP"
                + " ON SP." + SupervisedProgramsMsSqlSrv.programIdField + " = VP." + ProgramsMsSqlSrv.idField
                + " WHERE SP." + SupervisedProgramsMsSqlSrv.institutionIdField + " = " + institutionId;
       
              SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
              DataSet ds = new DataSet();
              da.Fill(ds,"SupervisedProgramsCollection");
              da.Dispose();
              return ds;
       }
        
       /// <summary>
       /// Saves inserts, updates and deletes in a dataset initially created with the GetCollectionDataSet method.
       /// </summary>
       /// <param name="institutionId">Primary key of entry in the VtkSupervisedPrograms table.</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
       /// <param name="ds">DataSet containing <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> information.</param>
       public static void SaveCollectionDataSet(int institutionId, ApplicationConnection appCon, DataSet ds)
       {
              if (!ds.HasChanges()) return; // no changes in dataset
        
              DataTable dtChanges = ds.Tables["SupervisedProgramsCollection"].GetChanges();
        
              if (dtChanges.Rows.Count == 0) return; // no changes in table
        
              SupervisedPrograms ssdObj;
              SupervisedProgramsCollection coll = new SupervisedProgramsCollection(institutionId, appCon);
              foreach(DataRow dr in ds.Tables["SupervisedProgramsCollection"].Rows)
              {
                     switch (dr.RowState)
                     {
                         case DataRowState.Added:
                            int index = coll.Add(out ssdObj);
                            PopulateInstance(ssdObj, dr);
                            break;
        
                         case DataRowState.Modified:
                            ssdObj = coll.GetObjectForId((int)dr[SupervisedProgramsMsSqlSrv.idField]);
                            PopulateInstance(ssdObj, dr);
                            break;
        
                         case DataRowState.Deleted:
                            dr.RejectChanges();
                            ssdObj = coll.GetObjectForId((int)dr[SupervisedProgramsMsSqlSrv.idField]);
                            dr.Delete();
                            if (ssdObj != null) ssdObj.Delete();
                            break;
        
                         default:
                            break;
                    }
              }
              coll.Save();
              ds.AcceptChanges();
       }
		
       /// <summary>
       /// Populates a <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/> instance based on information in a DataRow.
       /// </summary>
       /// <param name="ssdObj">Instance of <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/></param>
       /// <param name="dr">DataRow contain information for a <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/>.</param>
       private static void PopulateInstance(SupervisedPrograms ssdObj, DataRow dr)
       {
          if (!dr.IsNull("ProgramId"))
          {
                  ssdObj.ProgramId = (Int32)dr["ProgramId"];
          }
          else
          {
                  ssdObj.ProgramId = Int32.MinValue;
          }
          
          // reset version
          if (!dr.IsNull("Version"))
          {
          ssdObj.SetVersion((int)dr["Version"]);
          }
       }
        
        /// <summary>
        /// Gets a value indicating whether the 
        ///    <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> contains the specified <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/>.
        /// </summary>
        /// <param name='value'>The <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> to locate.</param>
        /// <returns>
        /// <see langword='true'/> if the <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> is contained in the collection; 
        ///   otherwise, <see langword='false'/>.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.IndexOf'/>
        public bool Contains(SupervisedPrograms value) {
            return List.Contains(value);
        }
        
        /// <summary>
        /// Copies the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> values to a one-dimensional <see cref='System.Array'/> instance at the 
        ///    specified index.
        /// </summary>
        /// <param name='array'>The one-dimensional <see cref='System.Array'/> that is the destination of the values copied from <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> .</param>
        /// <param name='index'>The index in <paramref name='array'/> where copying begins.</param>
        /// <returns>
        /// None.
        /// </returns>
        /// <exception cref='System.ArgumentException'><paramref name='array'/> is multidimensional. -or- The number of elements in the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> is greater than the available space between <paramref name='arrayIndex'/> and the end of <paramref name='array'/>.</exception>
        /// <exception cref='System.ArgumentNullException'><paramref name='array'/> is <see langword='null'/>. </exception>
        /// <exception cref='System.ArgumentOutOfRangeException'><paramref name='arrayIndex'/> is less than <paramref name='array'/>'s lowbound. </exception>
        /// <seealso cref='System.Array'/>
        public void CopyTo(SupervisedPrograms[] array, int index) {
            List.CopyTo(array, index);
        }
        
        /// <summary>
        /// Returns the index of a <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> in 
        /// the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name='value'>The <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> to locate.</param>
        /// <returns>
        /// The index of the <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> of <paramref name='value'/> in the 
        /// <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>, if found; otherwise, -1.
        /// </returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>
        public int IndexOf(SupervisedPrograms value) {
            return List.IndexOf(value);
        }
        
        /// <summary>
        /// Inserts a <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> into the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> at the specified index.
        /// </summary>
        /// <param name='index'>The zero-based index where <paramref name='value'/> should be inserted.</param>
        /// <param name=' value'>The <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> to insert.</param>
        /// <returns>None.</returns>
        /// <seealso cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection.Add'/>
        private void Insert(int index, SupervisedPrograms value) {
            List.Insert(index, value);
        }
        
        /// <summary>
        /// Returns an enumerator that can iterate through 
        /// the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <returns>None.</returns>
        /// <seealso cref='System.Collections.IEnumerator'/>
        public new SupervisedProgramsEnumerator GetEnumerator() {
            return new SupervisedProgramsEnumerator(this);
        }
        
        /// <summary>
        /// Removes a specific <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> from the 
        /// <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/>.
        /// </summary>
        /// <param name='value'>The <see cref='Vha.Vtk.ServicesDirectory.SupervisedPrograms'/> to remove from the <see cref='Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection'/> .</param>
        /// <returns>None.</returns>
        /// <exception cref='System.ArgumentException'><paramref name='value'/> is not found in the Collection. </exception>
        private void Remove(SupervisedPrograms value) {
            List.Remove(value);
        }
        
    }
        
    /// <summary>
    /// Enumerator class used to navigate an instance of <see cref="Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection" />.
    /// </summary>
    public class SupervisedProgramsEnumerator : object, IEnumerator {
        
        private IEnumerator baseEnumerator;
        
        private IEnumerable temp;
        
        /// <summary>
        /// Set mappings for this enumerator instance.
        /// </summary>
        /// <param name="mappings"><see cref="Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection"/></param>
        public SupervisedProgramsEnumerator(SupervisedProgramsCollection mappings) {
            this.temp = ((IEnumerable)(mappings));
            this.baseEnumerator = temp.GetEnumerator();
        }
        
        /// <summary>
        /// Get <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms" /> instance at the current cursor position.
        /// </summary>
        public SupervisedPrograms Current {
            get {
                return ((SupervisedPrograms)(baseEnumerator.Current));
            }
        }
        
        /// <summary>
        /// Get object at current cursor position.
        /// </summary>
        object IEnumerator.Current {
            get {
                return baseEnumerator.Current;
            }
        }
        
        /// <summary>
        /// Moves cursor to next <see cref="Vha.Vtk.ServicesDirectory.SupervisedPrograms"/> instance in collection.
        /// </summary>
        /// <returns>Returns 'true' if operation moved cursor to next instance. Otherwise, returns 'false' cursor is at end of collection. </returns>
        public bool MoveNext() {
            return baseEnumerator.MoveNext();
        }
        
        /// <summary>
        /// Moves cursor to next instance in collection.
        /// </summary>
        /// <returns>Returns 'true' if operation moved cursor to next instance. Otherwise, returns 'false' cursor is at end of collection. </returns>
        bool IEnumerator.MoveNext() {
            return baseEnumerator.MoveNext();
        }
        
        /// <summary>
        /// Resets <see cref="Vha.Vtk.ServicesDirectory.SupervisedProgramsCollection"/> enumerator.
        /// </summary>
        public void Reset() {
           baseEnumerator.Reset();
        }
        
        /// <summary>
        /// Resets enumerator.
        /// </summary>
        void IEnumerator.Reset() {
           baseEnumerator.Reset();
        }
    }
}
