﻿
/*

			Class:              Programs

			Date Produced:      3/14/2002 3:04:54 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\Vha.Vtk.ServicesDirectory

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/
#define msSql
		
#region Section: Using Declarations
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;

#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ProgramsMsSqlSrv;
#endif

#endregion
		
namespace Vha.Vtk.ServicesDirectory
{
	/// <summary>
	///  Public Class mapped to VtkVoluntaryPrograms
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Programs : ProgramsBase
	{
		#region Section: Constructors
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Programs(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Programs(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Programs thate will be used to add a record to the VtkVoluntaryPrograms database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Programs"/></returns>
		public static Programs AddRecord(ApplicationConnection appCon)
		{
			Programs vprgObj = new Programs(appCon);
			vprgObj.FillDataNew();
			return vprgObj;
		}
		
		#endregion
				
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCode(Code, Scope);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateProgramName(ProgramName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateScope(Scope);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(ID, ProgramName, Code, Scope, InstitutionId);
			return returnStatus;
		}
		
		public static ReturnStatus CheckForDuplicates(int ID, string ProgramName, int Code, 
																	 string Scope, int InstitutionId)
		{			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkProgramExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@ProgramName", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ProgramName;

			sqlParam							= sqlCmd.Parameters.Add("@Code", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= Code;
			
			sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= "N";
			
			sqlParam							= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= InstitutionId;

			sqlParam							= sqlCmd.Parameters.Add("@ProgramId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;

			sqlParam							= sqlCmd.Parameters.Add("@IsProgramNameExisting", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Output;
			
			sqlParam							= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			byte RETURN_ISPROGRAMNAMEEXISTING = Convert.ToByte(sqlCmd.Parameters["@IsProgramNameExisting"].Value);
			byte RETURN_ISCODEEXISTING = Convert.ToByte(sqlCmd.Parameters["@IsCodeExisting"].Value);
			byte RETURN_STATUS = Convert.ToByte(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Programs";
			if(Convert.ToBoolean(RETURN_STATUS))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An Error accured checking for duplicate ProgramNames and Codes.";
			}
			else if(Convert.ToBoolean(RETURN_ISPROGRAMNAMEEXISTING))
			{
				ret.Status = si.Fail;
				ret.PropertyName = "ProgramName";
				if(Scope == "N")
					ret.ErrorText = "'ProgramName'(" + ProgramName + ") already exists, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate a 'ProgramName'(" + ProgramName + ") which already exists Nationally, please enter another value.";
			}
			else if(Convert.ToBoolean(RETURN_ISCODEEXISTING))
			{
				ret.Status = si.Fail;
				ret.PropertyName = "Code";
				if(Scope == "N")
					ret.ErrorText = "'Code'(" + Code + ") already exists, please enter another value.";				
				else if(Scope == "L")
					ret.ErrorText = "This code is out of the 001 - 099 range for Local Site Codes. Please enter another value within the specified range.";
			}
			
			if(ret.Status == si.Pass && Scope == "L")
			{
				//Run a DB Check to see if another Volunteer exists with this SSN
				sqlConn					= new SqlConnection(ApplicationConnection.GetConnectionString());

				sqlCmd					= new SqlCommand("VtkProgramExistsQuery", sqlConn);
				sqlCmd.CommandType		= CommandType.StoredProcedure;

				sqlParam				= sqlCmd.Parameters.Add("@ProgramName", SqlDbType.VarChar, 30);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= ProgramName;

				sqlParam							= sqlCmd.Parameters.Add("@Code", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= Code;
			
				sqlParam							= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= "L";
			
				sqlParam							= sqlCmd.Parameters.Add("@InstitutionFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= InstitutionId;

				sqlParam							= sqlCmd.Parameters.Add("@ProgramId", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value				= ID;

				sqlParam							= sqlCmd.Parameters.Add("@IsProgramNameExisting", SqlDbType.VarChar, 30);
				sqlParam.Direction		= ParameterDirection.Output;
			
				sqlParam							= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.VarChar, 30);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.ReturnValue;

				sqlConn.Open();
				sqlCmd.ExecuteNonQuery();

				RETURN_ISPROGRAMNAMEEXISTING = Convert.ToByte(sqlCmd.Parameters["@IsProgramNameExisting"].Value);
				RETURN_ISCODEEXISTING = Convert.ToByte(sqlCmd.Parameters["@IsCodeExisting"].Value);
				RETURN_STATUS = Convert.ToByte(sqlCmd.Parameters["RETURN_STATUS"].Value);
				sqlConn.Close();

				ret				= new ReturnStatus();
				ret.ClassName	= "Programs";

				if(Convert.ToBoolean(RETURN_STATUS))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "An Error accured checking for duplicate ProgramNames and Codes.";
				}
				else if(Convert.ToBoolean(RETURN_ISPROGRAMNAMEEXISTING))
				{
					ret.ErrorText = "'ProgramName'(" + ProgramName + ") already exists Locally, please enter another value.";
					ret.Status = si.Fail;
					ret.PropertyName = "ProgramName";
				}
				else if(Convert.ToBoolean(RETURN_ISCODEEXISTING))
				{
					ret.ErrorText = "'Code'(" + Code + ") already exists Locally, please enter another value.";
					ret.Status = si.Fail;
					ret.PropertyName = "Code";			
				}
			}
			return ret;
		}
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Code property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ProgramsBase.ValidateCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCode(Int32 value, String Scope)
		{
			ReturnStatus ret = ProgramsBase.ValidateCode(value, Scope);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ProgramName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ProgramsBase.ValidateProgramName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ProgramName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateProgramName(string value)
		{
			ReturnStatus ret = ProgramsBase.ValidateProgramName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Scope property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ProgramsBase.ValidateScope.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = ProgramsBase.ValidateScope(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ProgramsBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ProgramsBase.ValidateInstitutionId(value, appCon);
			return ret;
		}
		#endregion
		
		#region Section: Quick Lists
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkVoluntaryPrograms table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkVoluntaryPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName: <b>Programs</b></li> 
		/// <br />
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>Code</b>  [Int32]</li>
		///  <li><b>ProgramName</b>  [string]</li>
		///  <li><b>Scope</b>  [string]</li>
		///  <li><b>InstitutionId</b>  [Int32]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br />
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				 + ProgramsMsSqlSrv.idField + " As ID"
				 + ", " + ProgramsMsSqlSrv.codeField + " As Code"
				 + ", " + ProgramsMsSqlSrv.programNameField + " As ProgramName"
				 + ", " + ProgramsMsSqlSrv.scopeField + " As Scope"
				 + ", " + ProgramsMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + ProgramsMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"ProgramsList");
			da.Dispose();
			return ds;
    }
    /// <summary>
    /// This method retrieves all the fields for an entry in the VtkVoluntaryPrograms table. 
    /// If you provide an InstitutionId parameter you will be returned a particular Institutions
    /// programs list. However if you provide no InstitutionId you will be returned all the National
    /// Programs. 
    /// </summary>
    /// <param name="InstitutionId">Primary key value for VtkVoluntaryPrograms entry</param>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns>
    /// Returns dataset for entry.
    /// <li>DataSet TableName: <b>ProgramsList</b></li> 
    /// <br />
    /// <li>Data Columns Returned:</li>
    ///  <ul>
    ///  <li><b>ProgramId</b>  [Int32]</li>
    ///  <li><b>ProgramCode</b>  [Int32]</li>
    ///  <li><b>ProgramName</b>  [string]</li>
    ///  <li><b>DisplayProgram</b>  [string]</li>
    ///  </ul>
    /// <br />
    /// <li>Sorted By:  <b>Not Specified</b></li>
    /// </returns>
    public static DataSet GetVoluntaryPrograms(int InstitutionId, ApplicationConnection appCon)
    {
      string sCommand = "VtkVoluntaryProgramsQuery " + InstitutionId;
      SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
      DataSet ds = new DataSet();
      da.Fill(ds,"ProgramsList");
      da.Dispose();
      return ds;

    }
		#endif
		#endregion
		
		#region Section: Utilities
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		#endregion
		
	}
}
