﻿
/*

			Class:              Services

			Date Produced:      4/24/2002 12:54:37 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        4/23/2002 2:50:47 PM
			Revision:           620

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.842.2440\Vha.Vtk.ServicesDirectory

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.842.2440

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ServicesMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.ServicesDirectory
{
	/// <summary>
	///  Public Class mapped to VtkVoluntaryServices
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Services : ServicesBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryServices entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Services(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Services(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Services thate will be used to add a record to the VtkVoluntaryServices database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Services"/></returns>
		public static Services AddRecord(ApplicationConnection appCon)
		{
			Services vsrvObj = new Services(appCon);
			vsrvObj.FillDataNew();
			return vsrvObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateServiceTitle(ServiceTitle);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMailStop(MailStop);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTypeId(TypeId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsOwnVAVSCommittee(IsOwnVAVSCommittee);
			if (returnStatus.Status == si.Pass) returnStatus = ValidatePrimaryPhone(PrimaryPhone);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSecondaryPhone(SecondaryPhone);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFaxNumber(FaxNumber);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOperatingCosts(OperatingCosts);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStaffCosts(StaffCosts);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLastUpdated(LastUpdated);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateChiefManager(ChiefManager);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ServiceTitle property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateServiceTitle.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ServiceTitle</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateServiceTitle(string value)
		{
			ReturnStatus ret = ServicesBase.ValidateServiceTitle(value);
		 
			// TODO: Add property specific validation logic for 'ServiceTitle'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MailStop property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateMailStop.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MailStop</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMailStop(string value)
		{
			ReturnStatus ret = ServicesBase.ValidateMailStop(value);
		 
			// TODO: Add property specific validation logic for 'MailStop'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for TypeId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateTypeId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TypeId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateTypeId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ServicesBase.ValidateTypeId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'TypeId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsOwnVAVSCommittee property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateIsOwnVAVSCommittee.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsOwnVAVSCommittee</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsOwnVAVSCommittee(bool value)
		{
			ReturnStatus ret = ServicesBase.ValidateIsOwnVAVSCommittee(value);
		 
			// TODO: Add property specific validation logic for 'IsOwnVAVSCommittee'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for PrimaryPhone property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidatePrimaryPhone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of PrimaryPhone</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidatePrimaryPhone(string value)
		{
			ReturnStatus ret = ServicesBase.ValidatePrimaryPhone(value);
		 
			// TODO: Add property specific validation logic for 'PrimaryPhone'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for SecondaryPhone property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateSecondaryPhone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of SecondaryPhone</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateSecondaryPhone(string value)
		{
			ReturnStatus ret = ServicesBase.ValidateSecondaryPhone(value);
		 
			// TODO: Add property specific validation logic for 'SecondaryPhone'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FaxNumber property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateFaxNumber.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FaxNumber</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFaxNumber(string value)
		{
			ReturnStatus ret = ServicesBase.ValidateFaxNumber(value);
		 
			// TODO: Add property specific validation logic for 'FaxNumber'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OperatingCosts property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateOperatingCosts.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of OperatingCosts</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateOperatingCosts(decimal value)
		{
			ReturnStatus ret = ServicesBase.ValidateOperatingCosts(value);
		 
			// TODO: Add property specific validation logic for 'OperatingCosts'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StaffCosts property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateStaffCosts.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StaffCosts</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStaffCosts(decimal value)
		{
			ReturnStatus ret = ServicesBase.ValidateStaffCosts(value);
		 
			// TODO: Add property specific validation logic for 'StaffCosts'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LastUpdated property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateLastUpdated.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of LastUpdated</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateLastUpdated(DateTime value)
		{
			ReturnStatus ret = ServicesBase.ValidateLastUpdated(value);
		 
			// TODO: Add property specific validation logic for 'LastUpdated'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ChiefManager property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServicesBase.ValidateChiefManager.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ChiefManager</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateChiefManager(string value)
		{
			ReturnStatus ret = ServicesBase.ValidateChiefManager(value);
		 
			// TODO: Add property specific validation logic for 'ChiefManager'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'Services'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkVoluntaryServices table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkVoluntaryServices entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>Services</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>ServiceTitle</b>  [string]</li>
		///  <li><b>MailStop</b>  [string]</li>
		///  <li><b>TypeId</b>  [Int32]</li>
		///  <li><b>IsOwnVAVSCommittee</b>  [bool]</li>
		///  <li><b>PrimaryPhone</b>  [string]</li>
		///  <li><b>SecondaryPhone</b>  [string]</li>
		///  <li><b>FaxNumber</b>  [string]</li>
		///  <li><b>OperatingCosts</b>  [decimal]</li>
		///  <li><b>StaffCosts</b>  [decimal]</li>
		///  <li><b>LastUpdated</b>  [DateTime]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  <li><b>ChiefManager</b>  [string]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				 + ServicesMsSqlSrv.idField + " As ID"
				 + ", " + ServicesMsSqlSrv.serviceTitleField + " As ServiceTitle"
				 + ", " + ServicesMsSqlSrv.mailStopField + " As MailStop"
				 + ", " + ServicesMsSqlSrv.typeIdField + " As TypeId"
				 + ", " + ServicesMsSqlSrv.isOwnVAVSCommitteeField + " As IsOwnVAVSCommittee"
				 + ", " + ServicesMsSqlSrv.primaryPhoneField + " As PrimaryPhone"
				 + ", " + ServicesMsSqlSrv.secondaryPhoneField + " As SecondaryPhone"
				 + ", " + ServicesMsSqlSrv.faxNumberField + " As FaxNumber"
				 + ", " + ServicesMsSqlSrv.operatingCostsField + " As OperatingCosts"
				 + ", " + ServicesMsSqlSrv.staffCostsField + " As StaffCosts"
				 + ", " + ServicesMsSqlSrv.lastUpdatedField + " As LastUpdated"
				 + ", " + ServicesMsSqlSrv.versionField + " As Version"
				 + ", " + ServicesMsSqlSrv.chiefManagerField + " As ChiefManager"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"ServicesList");
			da.Dispose();
			return ds;
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
