﻿
/*

			Class:              Volunteer

			Date Produced:      03/12/2003 10:38:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        02/27/2003 9:10:36 AM
			Revision:           673

			SQL Server Version: 08.00.0760
			Server:             ISF-LANGLEYM
			Database:           [VSS_Games_Test]
			Code generated in:  D:\Olymars_test\1.0.1160.319\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1160.319

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text.RegularExpressions;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Kernel.Data;
using Vha.Vtk.Kernel.Data.SystemTables;
using Vha.Vss.Utility;

using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.VolunteerMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteers
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Volunteer : VolunteerBase
	{		
		#region Section: Constructors
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		public Volunteer() : base()
		{
		}

		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id">Primary Key value for VtkVolunteers</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Volunteer(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}

		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Volunteer(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Volunteer that will be used to add a record to the VtkNextOfKin database table.
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Volunteer" /></returns>
		public static Volunteer AddRecord(ApplicationConnection appCon)
		{
			Volunteer volObj = new Volunteer(appCon);
			volObj.FillDataNew();
			return volObj;
		}
		
		/// <summary>
		/// Creates an instance of Volunteer that will be used to add a record to the VtkNextOfKin database table.
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="NextOfKin" /></returns>
		public static Volunteer AddRecord()
		{
			Volunteer volObj = new Volunteer();
			return volObj;
		}

		public static int AddRecord(Volunteer NewVolunteer, ContactInformation NewContactInformation, StationProfile NewStationProfile, out ReturnStatus returnStatus)
		{
			returnStatus = NewVolunteer.ValidateNew();
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);

			returnStatus = NewContactInformation.ValidateNew();
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			returnStatus = NewStationProfile.ValidateNew();
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);


			//Create the ApplicationConnection Object to use for Creating the Volunteer in the DB.
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());
			

			SqlCommand sqlCmd			= new SqlCommand("sptx_AddVolunteer", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			//Create Parameters for the Volunteer
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@Id", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.InputOutput;
			sqlParam.Value				= NewVolunteer.ID;

			sqlParam							= sqlCmd.Parameters.Add("@LastName", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.LastName;

			sqlParam							= sqlCmd.Parameters.Add("@FirstName", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.FirstName;

			sqlParam							= sqlCmd.Parameters.Add("@MiddleName", SqlDbType.VarChar, 20);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.MiddleName;

			sqlParam							= sqlCmd.Parameters.Add("@NickName", SqlDbType.VarChar, 20);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.NickName;

			sqlParam							= sqlCmd.Parameters.Add("@SocialSecurityNumber", SqlDbType.VarChar, 9);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.SocialSecurityNumber;

			sqlParam							= sqlCmd.Parameters.Add("@Sex", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.Sex;

			sqlParam							= sqlCmd.Parameters.Add("@DateOfBirth", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.DateOfBirth;

			sqlParam							= sqlCmd.Parameters.Add("@IsVAEmployee", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.IsVAEmployee;

			sqlParam							= sqlCmd.Parameters.Add("@IsPseudoSSN", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.IsPseudoSSN;

			sqlParam							= sqlCmd.Parameters.Add("@PreferredLanguageForLoginFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.PreferredLanguageForLoginId;

			sqlParam							= sqlCmd.Parameters.Add("@Ver", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewVolunteer.ID == 0?1:NewVolunteer.Version;
			
			//Create Parameters for the Volunteer ContactInformation
			sqlParam							= sqlCmd.Parameters.Add("@ContactInformationId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.InputOutput;
			sqlParam.Value				= NewContactInformation.ID;	
	
			sqlParam							= sqlCmd.Parameters.Add("@StreetAddress1", SqlDbType.VarChar, 35);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.StreetAddress1;			

			sqlParam							= sqlCmd.Parameters.Add("@StreetAddress2", SqlDbType.VarChar, 35);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.StreetAddress2;			

			sqlParam							= sqlCmd.Parameters.Add("@City", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.City;			

			sqlParam							= sqlCmd.Parameters.Add("@StateFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.StateId;			

			sqlParam							= sqlCmd.Parameters.Add("@ZipCode", SqlDbType.VarChar, 10);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.ZipCode;			

			sqlParam							= sqlCmd.Parameters.Add("@Telephone", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.Telephone;			

			sqlParam							= sqlCmd.Parameters.Add("@AlternateTelephone", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.AlternateTelephone;			

			sqlParam							= sqlCmd.Parameters.Add("@AlternateTelephone2", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.AlternateTelephone2;			

			sqlParam							= sqlCmd.Parameters.Add("@EMailAddress", SqlDbType.VarChar, 50);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.EMailAddress;			
			
			sqlParam							= sqlCmd.Parameters.Add("@ContactInformationVer", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewContactInformation.ID == 0? 1:NewContactInformation.Version;			
			
			//Create Parameters for the Volunteer StationProfile
			sqlParam							= sqlCmd.Parameters.Add("@VolunteerStationProfileId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.InputOutput;	
			sqlParam.Value				= NewStationProfile.ID;	

			sqlParam							= sqlCmd.Parameters.Add("@StationFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewStationProfile.StationId;	

			sqlParam							= sqlCmd.Parameters.Add("@EntryDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewStationProfile.EntryDate;			

			sqlParam							= sqlCmd.Parameters.Add("@EligibleForMeals", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NewStationProfile.EligibleForMeals;

			sqlParam	= sqlCmd.Parameters.Add("@StationProfileVer", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= 1;

			//Create Return Status Error If Any
		
			sqlParam							= sqlCmd.Parameters.Add("@ERROR_MESSAGE", SqlDbType.VarChar, 50);
			sqlParam.Direction		= ParameterDirection.Output;

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.VarChar, 50);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			Int32 RETURN_ID = Convert.ToInt32(sqlCmd.Parameters["@Id"].Value);

			string ERROR_MESSAGE = sqlCmd.Parameters["@ERROR_MESSAGE"].Value.ToString();
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);

			sqlConn.Close();
			sqlConn.Dispose();

			if(RETURN_STATUS)
			{
				returnStatus.Status = si.Fail;
				returnStatus.ErrorText = ERROR_MESSAGE;
		
				return 0;
			}

			return RETURN_ID;
		}		
		#endregion
				
		#region Section: Field Validaters		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLastName(LastName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFirstName(FirstName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMiddleName(MiddleName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNameSuffix(NameSuffix);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSocialSecurityNumber(SocialSecurityNumber, ID);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSex(Sex);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateOfBirth(DateOfBirth);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateOfBirthImprecision(DateOfBirthImprecision);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRemarks(Remarks);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsVAEmployee(IsVAEmployee);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsPseudoSSN(IsPseudoSSN);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNickName(NickName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidatePreferredLanguageForLoginId(PreferredLanguageForLoginId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateD0(D0);
			return returnStatus;
		}
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus ValidateNew()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLastName(LastName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFirstName(FirstName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMiddleName(MiddleName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSocialSecurityNumber(SocialSecurityNumber, ID);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSex(Sex);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateOfBirth(DateOfBirth);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsPseudoSSN(IsPseudoSSN);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNickName(NickName);
			return returnStatus;
		}
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LastName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateLastName.</description></item>
		/// <item><description>Validates that LastName does not contain a comma.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of LastName.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateLastName(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateLastName(value);
			if (ret.Status != si.Pass) return ret;
		 
			if (value.IndexOf(",") > -1)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'LastName' contains a comma ',' and is not allowed.";
			}
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FirstName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateFirstName.</description></item>
		/// <item><description>Validates that FirstName does not contain a comma.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of FirstName.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateFirstName(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateFirstName(value);
			if (ret.Status != si.Pass) return ret;
		 
			if (value.IndexOf(",") > -1)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'FirstName' contains a comma ',' and is not allowed.";
			}
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MiddleName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateMiddleName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MiddleName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateMiddleName(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateMiddleName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NameSuffix property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateNameSuffix.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NameSuffix</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateNameSuffix(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateNameSuffix(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for SocialSecurityNumber property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateSocialSecurityNumber.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of SocialSecurityNumber</param>
		/// <param name="ID"></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateSocialSecurityNumber(string value,int ID)
		{
			ReturnStatus ret = VolunteerBase.ValidateSocialSecurityNumber(value, ID);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Sex property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateSex.</description></item>
		/// <item><description>Validates that Sex is an 'M' or 'F'.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of Sex.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateSex(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateSex(value);
			if (ret.Status != si.Pass) return ret;

			if (!Regex.IsMatch(value, @"\b[M|F]\b"))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Sex' is not valid, must be 'M' for Male or 'F' for Female.";
			}
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateOfBirth property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateDateOfBirth.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of DateOfBirth.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateDateOfBirth(DateTime value)
		{
			ReturnStatus ret = VolunteerBase.ValidateDateOfBirth(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateOfBirthImprecision property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateDateOfBirthImprecision.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DateOfBirthImprecision</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDateOfBirthImprecision(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateDateOfBirthImprecision(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Remarks property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateRemarks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Remarks</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRemarks(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateRemarks(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsVAEmployee property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateIsVAEmployee.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsVAEmployee</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsVAEmployee(bool value)
		{
			ReturnStatus ret = VolunteerBase.ValidateIsVAEmployee(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsPseudoSSN property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateIsPseudoSSN.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsPseudoSSN</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateIsPseudoSSN(bool value)
		{
			ReturnStatus ret = VolunteerBase.ValidateIsPseudoSSN(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NickName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateNickName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NickName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateNickName(string value)
		{
			ReturnStatus ret = VolunteerBase.ValidateNickName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for PreferredLanguageForLoginId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidatePreferredLanguageForLoginId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of PreferredLanguageForLoginId.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidatePreferredLanguageForLoginId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerBase.ValidatePreferredLanguageForLoginId(value, appCon);
			return ret;
		}
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		/// Returns full DataSet for specified Volunteer
		/// DataSet Table Name: 'VolunteerList'
		/// </summary>
		/// <param name="volId">Volunteer ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: VolunteerList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>Id</br>
		/// <br>LastName</br>
		/// <br>FirstName</br>
		/// <br>MiddleName</br>
		/// <br>NameSuffix</br>
		/// <br>LowercaseNameForDisplay</br>
		/// <br>UppercaseNameForDisplay</br>
		/// <br>SocialSecurityNumber</br>
		/// <br>Sex</br>
		/// <br>DateOfBirth</br>
		/// <br>Age</br>
		/// <br>IsPseudoSSN</br>>
		/// <br>NickName</br>
		/// <br>PreferredLanguageForLoginId</br>
		/// <br>IdentifyingCode</br>
		/// <br>FullNameForReports</br>
		///	<br></br>
		///	<br>Sorted By: Id</br>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int volId)
		{
			string sCommand = "Select " +
				sqlDrv.idField                          + " ID, " +
				sqlDrv.lastNameField                    + " LastName, " +
				sqlDrv.firstNameField                   + " FirstName, " +
				sqlDrv.middleNameField                  + " MiddleName, " +
				sqlDrv.nameSuffixField                  + " NameSuffix, " +
				sqlDrv.lowercaseNameForDisplayField     + " LowerCaseNameForDisplay, " +
				sqlDrv.uppercaseNameForDisplayField     + " UpperCaseNameForDisplay, " +
				sqlDrv.socialSecurityNumberField        + " SocialSecurityNumber, " +
				sqlDrv.sexField                         + " Sex, " +
				sqlDrv.dateOfBirthField                 + " DateOfBirth, " +
				sqlDrv.ageField                         + " Age, " +
				sqlDrv.isPseudoSSNField                 + " IsPseudoSSN, " +
				sqlDrv.nickNameField                    + " NickName, " +
				sqlDrv.preferredLanguageForLoginIdField + " PreferredLanguageForLoginId, " +
				sqlDrv.identifyingCodeField             + " IdentifyingCode, " +
				sqlDrv.fullNameForReportsField          + " FullNameForReports " +
				" FROM  " + sqlDrv.tableName +
				" WHERE Id = '" + volId + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		///  Get list of contact information and stations for a volunteerId
		/// DataSet Table Name: 'StationListForVolunteer'
		/// </summary>
		/// <param name="volId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <b>StationListForVolunteer</b></li>
		/// <br>Data Columns Returned:</br>
		/// <ul>
		/// <li><b>StationDisplayName</b> [string] (StationName (StationNumber))</li>
		/// <li><b>StationId</b> [int]</li>
		/// <li><b>ContactInformationDisplayName</b> [string])</li>
		/// <li><b>ContactInformationId</b> [int]</li>
		/// </ul>
		///	<li>Sorted By: nothing Specified</li>
		/// </ul>
		/// </returns>
		public static DataSet GetVolunteerListOfStations(int volId)
		{
			string sCommand = "SELECT " + 
				" VI.NameOfInstitution + '(' + VI.StationNumber + ')' AS StationDisplayName, " +
				" VI.Id AS StationID, " +
				" CON." + ContactInformationMsSqlSrv.idField + " As ContactInformationId, " +
				" CON." + ContactInformationMsSqlSrv.streetAddress1Field + " + ', ' + " +
				" CON." + ContactInformationMsSqlSrv.cityField           + " + ', ' + " +
				"  ST." + StateMsSqlSrv.stateNameField                   + " As ContactInformationDisplayName " +
				" FROM " + ContactInformationMsSqlSrv.tableName + " CON " +
				" INNER JOIN " + StateMsSqlSrv.tableName + " ST ON CON." + ContactInformationMsSqlSrv.stateIdField + " = ST." + StateMsSqlSrv.idField + " " +
				" LEFT JOIN VtkVolunteerStationProfiles SPO ON CON.Id = SPO.VolunteerContactInfoFK " +
				" LEFT JOIN VtkInstitutions VI ON SPO.StationFK = VI.Id " +
				" WHERE CON.Id IN (SELECT CON.Id FROM " + ContactInformationMsSqlSrv.tableName + " CON WHERE CON." + ContactInformationMsSqlSrv.volunteerIdField + " = '" + volId + "') ";

			return ApplicationConnection.ExecuteQuery(sCommand, "StationListForVolunteer");
		}

		/// <summary>
		///  Get list of station profiles for a volunteerId
		/// DataSet Table Name: 'StationNOKListForVolunteer'
		/// </summary>
		/// <param name="volId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <b>StationNOKListForVolunteer</b></li>
		/// <br>Data Columns Returned:</br>
		/// <ul>
		/// <li><b>StationDisplayName</b> [string] (StationName (StationNumber))</li>
		/// <li><b>StationId</b> [int]</li>
		/// <li><b>NextOfKinDisplayName</b> [string])</li>
		/// <li><b>NextOfKinId</b> [int]</li>
		/// </ul>
		///	<li>Sorted By: nothing Specified</li>
		/// </ul>
		/// </returns>
		public static DataSet GetVolunteerListOfNOKStations(int volId)
		{
			string sCommand = "SELECT " +
				" VI.NameOfInstitution + '(' + VI.StationNumber + ')' AS StationDisplayName, " +
				" VI.Id AS StationID, " +
				" NOK." + NextOfKinMsSqlSrv.idField + " As NextOfKinId, " +
				" NOK." + NextOfKinMsSqlSrv.kinsNameField + " As NextOfKinDisplayName " +
				" FROM VtkVolunteerStationProfiles SPO, VtkNextOfKin NOK, VtkInstitutions VI " +
				" WHERE SPO.VolunteerFK = '" + volId + "' AND SPO.StationFK = VI.Id AND SPO.NextOfKinFK *= NOK.Id " ;

			return ApplicationConnection.ExecuteQuery(sCommand, "StationNOKListForVolunteer");
		}

		/// <summary>
		///  Get list of Next of Kins for a volunteerId, that are not reference in a station profile
		/// DataSet Table Name: 'NOKListForVolunteer'
		/// </summary>
		/// <param name="volId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <b>NOKListForVolunteer</b></li>
		/// <br>Data Columns Returned:</br>
		/// <ul>
		/// <li><b>NextOfKinId</b> [int]</li>
		/// <li><b>NextOfKinDisplayName</b> [string])</li>
		/// <li><b>NextOfKinRelationship</b></li>
		/// </ul>
		///	<li>Sorted By: nothing Specified</li>
		/// </ul>
		/// </returns>
		public static DataSet GetVolunteerListOfNOKs(int volId)
		{
			string sCommand = "SELECT " +
				" NOK." + NextOfKinMsSqlSrv.idField + " As NextOfKinId, " +
				" NOK." + NextOfKinMsSqlSrv.kinsNameField + " As NextOfKinDisplayName, " +
				" NOK." + NextOfKinMsSqlSrv.relationshipField + " As NextOfKinRelationship " +
				" FROM VtkVolunteers V, VtkNextOfKin NOK " +
				" WHERE V.Id = '" + volId + "' AND V.Id = NOK.VolunteerFK" +
				" AND NOK.ID not in (Select Distinct SPO.NextOfKinFK" +
						" FROM VtkVolunteers V, VtkVolunteerStationProfiles SPO, VtkNextOfKin NOK" +
						" WHERE V.Id = '" + volId + "' AND SPO.NextOfKinFK is NOT NULL" +
						" AND V.Id = SPO.VolunteerFK AND SPO.NextOfKinFK *= NOK.Id)" ;

			return ApplicationConnection.ExecuteQuery(sCommand, "NOKListForVolunteer");
		}

		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// at a specifiic Station
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match IdentifyingCode and station Id.</returns>
		public static DataSet GetVolunteerListByIdentifierCode(string volIdenCode, int stationId, bool includeTerminated)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                       + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField       + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ')' DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField     + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField        + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."  + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + StationProfileMsSqlSrv.tableName     + " SP " +
				" INNER JOIN " + sqlDrv.tableName               + " VOL  ON SP."   + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName  + " INST ON INST." + InstitutionMsSqlSrv.idField             + " = '" + stationId + "' " +
				" WHERE SP."   + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "'" +
				" AND VOL."    + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "' ";
			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// at a specifiic Station
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <param name="retryCount" type="INT32">An intereger value, for this function to make an attempt to populate the dataset</param>
		/// <returns type="DataSet">Returns list of volunteers that match IdentifyingCode and station Id.</returns>
		public static DataSet GetVolunteerListByIdentifierCode(string volIdenCode, int stationId, bool includeTerminated, int retryCount)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                       + " Id " +
				" FROM " + sqlDrv.tableName						+ " VOL " + 
				" INNER JOIN " + StationProfileMsSqlSrv.tableName     + " SP ON VOL." + sqlDrv.idField + " = SP." + StationProfileMsSqlSrv.volunteerIdField +  
				" WHERE VOL."    + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "' " +
				" AND  SP."   + StationProfileMsSqlSrv.stationIdField + " = " + stationId + "";

			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}
			
			return ApplicationConnection.ExecuteQueryRetry(sCommand, "VolunteerList", retryCount);


//			int Success = 0;
//			return ApplicationConnection.ExecuteQuery("spQ_AuthVolByIdentifyingCode " + stationId.ToString() + ", " + volIdenCode + ", '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "'", "VolunteerList", out Success);
		}


		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// at a specifiic Station
		/// DataReader: 
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="retryCount" type="INT32">An intereger value, for this function to make an attempt to populate the dataset</param>
		/// <returns type="DataSet">Returns list of volunteers in a DataReader object that match IdentifyingCode and station Id.</returns>
		public static NameObjectCollection GetVolunteerDRByIdentifierCode(string volIdenCode, int stationId, bool includeTerminated, bool includeVolFullName)
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand="";
			if (!includeVolFullName) 
			{
				sCommand = "SELECT Id" +
					" FROM Vol_Profiles " + 
					" WHERE identifyingCode = '" + volIdenCode + "' " +
					" AND  stationId = " + stationId + "";

				if (!includeTerminated)
				{
					sCommand = sCommand + " AND (TerminationDate Is Null OR TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
				}
			}
			else
			{
				sCommand = "SELECT " +
					" VOL."  + sqlDrv.idField                       + " Id, " +
					" VOL."  + sqlDrv.fullNameForReportsField       + " DisplayName " +
					" FROM " + sqlDrv.tableName						+ " VOL " +
					" INNER JOIN " + StationProfileMsSqlSrv.tableName  + " SP ON VOL."   + sqlDrv.idField + " = SP." + StationProfileMsSqlSrv.volunteerIdField + " " +
					" WHERE SP."   + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "'" +
					" AND VOL."    + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "' ";
				if (!includeTerminated)
				{
					sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
				}
			}

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}


		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// at a specifiic Station
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="ExcludedVolunteerId" type="System.String">Volunteer ID to be excluded from Result Set.</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match IdentifyingCode and station Id.</returns>
		public static DataSet GetVolunteerListByIdentifierCode(string volIdenCode, int stationId, bool includeTerminated, string ExcludeVolunteerId)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                       + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField       + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ')' DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField     + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField        + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."  + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + StationProfileMsSqlSrv.tableName     + " SP " +
				" INNER JOIN " + sqlDrv.tableName               + " VOL  ON SP."   + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName  + " INST ON INST." + InstitutionMsSqlSrv.idField             + " = '" + stationId + "' " +
				" WHERE SP."   + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "' AND VOL.Id NOT IN ('" + ExcludeVolunteerId + "')" +
				" AND VOL."    + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "' ";
			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}
		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match IdentifyingCode.</returns>
		public static DataSet GetVolunteerListByIdentifierCode(string volIdenCode, bool includeTerminated)
		{
			string sCommand = "SELECT DISTINCT " +
				"VOL."  + sqlDrv.idField                        + " Id, " +
				"VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				"VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ') ' + INST.NameOfInstitution DisplayNameWithSSN, " +
				"VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				"INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				"SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				"SP."   + StationProfileMsSqlSrv.stationIdField + " StationId, " +
				"Convert(varchar, SP." + StationProfileMsSqlSrv.volunteerIdField + ") + '&' + Convert(varchar, SP." + StationProfileMsSqlSrv.stationIdField + ") IdAndStationId " +
				"FROM " + sqlDrv.tableName + " VOL " +
				"INNER JOIN " + StationProfileMsSqlSrv.tableName + " SP ON SP." + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				"INNER JOIN " + InstitutionMsSqlSrv.tableName    + " INST ON INST." + InstitutionMsSqlSrv.idField  + " = SP." + StationProfileMsSqlSrv.stationIdField + " " +
				"WHERE VOL." + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "'";
			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers for a specific IndentifyingCode
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="ExcludeVolunteerId" type="System.String">Volunteers ID to Exclude from returned List.</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match IdentifyingCode.</returns>
		public static DataSet GetVolunteerListByIdentifierCode(string volIdenCode, bool includeTerminated, string ExcludeVolunteerId)
		{
			string sCommand = "SELECT DISTINCT " +
				" VOL."  + sqlDrv.idField                        + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ') ' + INST.NameOfInstitution DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."   + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + sqlDrv.tableName + " VOL " +
				" INNER JOIN " + StationProfileMsSqlSrv.tableName + " SP ON SP." + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName    + " INST ON INST." + InstitutionMsSqlSrv.idField  + " = SP." + StationProfileMsSqlSrv.stationIdField + " " +
				" WHERE VOL." + sqlDrv.identifyingCodeField + " = '" + volIdenCode + "' AND VOL.Id NOT IN ('" + ExcludeVolunteerId + "')";
			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (SP.TerminationDate Is Null OR SP.TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers SSN at a specific station
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="ssn" type="System.String"> Volunteer Social Security Number</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match SSN at a specific station.</returns>
		public static DataSet GetVolunteerListBySSN(string ssn, int stationId)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                        + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ')' DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."   + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + StationProfileMsSqlSrv.tableName      + " SP " +
				" INNER JOIN " + sqlDrv.tableName                + " VOL  ON SP."   + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName   + " INST ON INST." + InstitutionMsSqlSrv.idField             + " = '" + stationId + "' " +
				" WHERE SP."   + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "' " +
				" AND VOL." + sqlDrv.socialSecurityNumberField + " = '" + ssn + "' ";
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers SSN at a specific station
		/// DataReader: 
		/// </summary>
		/// <param name="volIdenCode" type="System.String"> Volunteer Indentifying Code</param>
		/// <param name="stationId" type="INT32"> Station Id</param>
		/// <param name="includeTerminated" type="System.Bool"> bool, Include Terminated Volunteers (based on Termination Date)</param>
		/// <param name="retryCount" type="INT32">An intereger value, for this function to make an attempt to populate the dataset</param>
		/// <returns type="DataSet">Returns list of volunteers in a DataReader object that match IdentifyingCode and station Id.</returns>
		public static NameObjectCollection GetVolunteerDRBySSN(string ssn, int stationId, bool includeTerminated)
		{
			SqlCommand sqlCommand = new SqlCommand();

			string sCommand = "SELECT Id" +
				" FROM Vol_Profiles " + 
				" WHERE SocialSecurityNumber = '" + ssn + "' " +
				" AND  stationId = " + stationId + "";

			if (!includeTerminated)
			{
				sCommand = sCommand + " AND (TerminationDate Is Null OR TerminationDate > '" + DateTime.Now.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') ";
			}

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		/// <summary>
		/// Get List of Volunteers SSN at a specific station
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="ssn" type="System.String">Volunteer Social Security Number</param>
		/// <param name="stationId" type="INT32"/>
		/// <param name="appCon" type="ApplicationConnection"/>
		/// <returns type="DataSet">Returns list of volunteers that match SSN at a specific station.</returns>
		public static DataSet GetVolunteerListBySSN(string ssn, int stationId, string ExcludedVolunteerId)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                        + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ')' DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."   + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + StationProfileMsSqlSrv.tableName      + " SP " +
				" INNER JOIN " + sqlDrv.tableName                + " VOL  ON SP."   + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName   + " INST ON INST." + InstitutionMsSqlSrv.idField             + " = '" + stationId + "' " +
				" WHERE SP."   + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "' " +
				" AND VOL." + sqlDrv.socialSecurityNumberField + " = '" + ssn + "' AND VOL.Id NOT IN ('" + ExcludedVolunteerId + "')";

			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers SSN
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="ssn" type="System.String"> Volunteer Social Security Number</param>
		/// <param name="appCon" type="ApplicationConnection">Current ApplicationConnection</param>
		/// <returns type="DataSet">Returns list of volunteers that match SSN.</returns>
		public static DataSet GetVolunteerListBySSN(string ssn)
		{
			string sCommand = "SELECT " +
				"VOL."  + sqlDrv.idField                        + " Id, " +
				"VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				"VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ') ' + INST.NameOfInstitution DisplayNameWithSSN, " +
				"VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				"INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				"SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				"SP."   + StationProfileMsSqlSrv.stationIdField + " StationId, " +
				"Convert(varchar, SP." + StationProfileMsSqlSrv.volunteerIdField + ") + '&' + Convert(varchar, SP." + StationProfileMsSqlSrv.stationIdField + ") IdAndStationId " +
				"FROM " + sqlDrv.tableName + " VOL " +
				"LEFT OUTER JOIN " + StationProfileMsSqlSrv.tableName + " SP ON SP." + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				"LEFT OUTER JOIN " + InstitutionMsSqlSrv.tableName  + " INST ON INST." + InstitutionMsSqlSrv.idField  + " = SP." + StationProfileMsSqlSrv.stationIdField + " " +
				"WHERE VOL." + sqlDrv.socialSecurityNumberField + " = '" + ssn + "'";

			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		/// <summary>
		/// Get List of Volunteers SSN
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="ssn" type="System.String"/>
		/// <param name="appCon" type="ApplicationConnection"/>
		/// <returns type="DataSet"/>
		public static DataSet GetVolunteerListBySSN(string ssn, string ExcludedVolunteerId)
		{
			string sCommand = "SELECT " +
				" VOL."  + sqlDrv.idField                        + " Id, " +
				" VOL."  + sqlDrv.fullNameForReportsField        + " DisplayName, " +
				" VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ') ' + INST.NameOfInstitution DisplayNameWithSSN, " +
				" VOL."  + sqlDrv.socialSecurityNumberField      + " SocialSecurityNumber, " +
				" INST." + InstitutionMsSqlSrv.nameOfInstitutionField         + " StationName, " +
				" SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				" SP."   + StationProfileMsSqlSrv.stationIdField + " StationId " +
				" FROM " + sqlDrv.tableName + " VOL " +
				" LEFT OUTER JOIN " + StationProfileMsSqlSrv.tableName + " SP ON SP." + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" LEFT OUTER JOIN " + InstitutionMsSqlSrv.tableName  + " INST ON INST." + InstitutionMsSqlSrv.idField  + " = SP." + StationProfileMsSqlSrv.stationIdField + " " +
				" WHERE VOL." + sqlDrv.socialSecurityNumberField + " = '" + ssn + "' AND VOL.Id NOT IN ('" + ExcludedVolunteerId + "')";

			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerList");
		}

		public static NameObjectCollection GetVolunteerDRMealAuth(int InstitutionId, int VolunteerId)
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand="VtkVolunteerMealQuery " + InstitutionId.ToString() + ", " + VolunteerId;


///			return ApplicationConnection.ExecuteQuery("VtkVolunteerMealQuery " + InstitutionId.ToString() + ", " + VolunteerId, "MealAuthorization", out Success);
			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}

		public static DataSet GetVolunteerMealAuth(int InstitutionId, int VolunteerId)
		{
			int Success = 0;
			return ApplicationConnection.ExecuteQuery("VtkVolunteerMealQuery " + InstitutionId.ToString() + ", " + VolunteerId, "MealAuthorization", out Success);
		}
		/// <summary>
		/// Performs basic database-centric and any special validation checks for D0 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerBase.ValidateD0.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of D0</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateD0(Int32 value)
		{
			ReturnStatus ret = VolunteerBase.ValidateD0(value);
			return ret;
		}
		 
		#endif
		#endregion

		#region Section: Paged DataSets		
		#if msSql

		/// <summary>
		/// Retrieves all volunteers for a specific station with last name starting with designated characters.
		/// This method is a 'chunker' method.
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="sc">SelectCriteria</param>
		/// <param name="stationId">Int32</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns list of volunteers that match SelectCriteria specification and station Id.
		/// <ul>
		/// <li>DataSet TableName:</li> <ul><li><b>VolunteerList</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>DisplayName</b>FullNameForReports  [string]</li>
		///  <li><b>SocialSecurityNumber</b> [string (10)]</li>
		///  <li><b>TerminationDate</b> [DateTime]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>FullNameForReports</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetVolunteerList(SelectCriteria sc, int stationId, ApplicationConnection appCon)
		{
			sc.TableName = "VolunteerList";
			string sCommand  = 
				"SELECT VOL."   + VolunteerMsSqlSrv.idField       + ", " +
				"VOL." + VolunteerMsSqlSrv.fullNameForReportsField + ", " +
				"SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate " +
				"FROM  "        + VolunteerMsSqlSrv.tableName      + " VOL " +
				"INNER JOIN "   + StationProfileMsSqlSrv.tableName + " SP ON VOL." + VolunteerMsSqlSrv.idField + " = SP." + StationProfileMsSqlSrv.volunteerIdField + " " +
				"WHERE (VOL."   + VolunteerMsSqlSrv.lastNameField + " LIKE '" + MsSqlTools.PrepareString(sc.StartsWith)       + "%') " + 
				"AND   (VOL."   + VolunteerMsSqlSrv.lastNameField + " > '"    + MsSqlTools.PrepareString(sc.StartNextFetchAt) + "') " +
				"AND   (SP."    + StationProfileMsSqlSrv.stationIdField + " = '" + stationId + "') " +
				"ORDER BY VOL." + VolunteerMsSqlSrv.fullNameForReportsField;
			
			return GetQuickListDataSet(sCommand, sc, appCon);
		}

		/// <summary>
		/// Retrieves all volunteers regardless of station with last name starting with designated characters.
		/// This method is a 'chunker' method.  
		/// Note:  This does not return the TerminationDate as does the 
		///        Overload where stationId is input in order to prevent duplicate names appearing.
		/// DataSet TableName: 'VolunteerList'
		/// </summary>
		/// <param name="sc">SelectCriteria</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns list of volunteers that match SelectCriteria specification.
		/// <ul>
		/// <li>DataSet TableName:</li> <ul><li><b>Volunteer</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>DisplayName</b>FullNameForReports  [string]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>FullNameForReports</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetVolunteerList(SelectCriteria sc, ApplicationConnection appCon)
		{
			sc.TableName = "VolunteerList";
			string sCommand  = 
				"SELECT VOL."    + VolunteerMsSqlSrv.idField       + ", " +
				"VOL." + VolunteerMsSqlSrv.fullNameForReportsField + ", " +
				"SP."  + StationProfileMsSqlSrv.terminationDateField + " TerminationDate, " +
				"VOL.FullNameForReports + ' (' + VOL.SocialSecurityNumber + ') ' + INST.NameOfInstitution DisplayNameWithSSN, " +
				"Convert(varchar, SP." + StationProfileMsSqlSrv.volunteerIdField + ") + '&' + Convert(varchar, SP." + StationProfileMsSqlSrv.stationIdField + ") IdAndStationId " +
				"FROM  "     + VolunteerMsSqlSrv.tableName     + " VOL " +
				" INNER JOIN " + StationProfileMsSqlSrv.tableName + " SP ON SP." + StationProfileMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + InstitutionMsSqlSrv.tableName    + " INST ON INST." + InstitutionMsSqlSrv.idField  + " = SP." + StationProfileMsSqlSrv.stationIdField + " " +
				"WHERE (VOL."    + VolunteerMsSqlSrv.lastNameField + " LIKE '" + MsSqlTools.PrepareString(sc.StartsWith)       + "%') " + 
				"AND (VOL."      + VolunteerMsSqlSrv.lastNameField + " > '"    + MsSqlTools.PrepareString(sc.StartNextFetchAt) + "') " +
				"ORDER BY VOL."  + VolunteerMsSqlSrv.fullNameForReportsField;
			
			return Volunteer.GetQuickListDataSet(sCommand, sc, appCon);
		}

		/// <summary>
		/// 
		/// </summary>
		/// <Params>
		/// <param name="select" type="System.String">SQL SELECT statement</param>
		/// <param name="sc" type="SelectCriteria">SelectCriteria</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection">Current ApplicationConnection</param>
		/// </Params>
		/// <returns type="DataSet"></returns>
		private static DataSet GetQuickListDataSet(string select, SelectCriteria sc, ApplicationConnection appCon)  
		{
			DataTable dt = new DataTable(sc.TableName);
			DataColumn dc;

			dc = new DataColumn("ID",System.Type.GetType("System.Int32"));
			dc.AllowDBNull = true;
			dt.Columns.Add(dc);

			dc = new DataColumn("DisplayName",System.Type.GetType("System.String"));
			dc.AllowDBNull = true;
			dt.Columns.Add(dc);
			
			if (select.IndexOf("TerminationDate")>0)
			{
				dc = new DataColumn("TerminationDate",System.Type.GetType("System.DateTime"));
				dc.AllowDBNull = true;
				dt.Columns.Add(dc);
			}

			DataSet ds = new DataSet();
			ds.Tables.Add(dt);

			DataRow dr;

			sc.Count = 0;
			sc.AtEnd = true;
			SqlCommand sqlCmd = new SqlCommand();
			sqlCmd.CommandText = select;
			sqlCmd.Connection = new SqlConnection(appCon.ConnectString);
			sqlCmd.Connection.Open();
			SqlDataReader sqlReader = sqlCmd.ExecuteReader();

			//DataTable dtz = sqlReader.GetSchemaTable();
			while(sqlReader.Read())
			{
				if (sc.Count == sc.MaxRecords) 
				{
					sc.AtEnd = false;
					break;
				}
				++sc.Count;

				dr = dt.NewRow(); 
				if (!sqlReader.IsDBNull(0)) dr["Id"] = sqlReader.GetInt32(0); 
				if (!sqlReader.IsDBNull(1)) dr["DisplayName"] = sqlReader.GetString(1);
				//if (dtz.Columns.Contains("TerminationDate"))
				if (select.IndexOf("TerminationDate")>0)
				{
					if (!sqlReader.IsDBNull(2)) dr["TerminationDate"] = sqlReader.GetDateTime(2);
				}
				dt.Rows.Add(dr);

				sc.StartNextFetchAt = sqlReader.GetString(1);
			}

			sqlReader.Close();
			sqlCmd.Connection.Close();
			return ds;
		}
		#endif
		#endregion

		#region Section: Utilities
		public static int MergeVolunteers(int SelectedVolunteer, int DepricatedVolunteer)
		{
			return ApplicationConnection.ExecuteNonQuery("ResetVolunteerFK " + SelectedVolunteer.ToString() + ", " + DepricatedVolunteer.ToString());
		}
		/// <summary>
		///  Determines if a meal ticket should be given to a volunteer at a specific time
		/// </summary>
		/// <param name="stationId"> Institution.ID [int]</param>
		/// <param name="volId"> Volunteer.Id [int]</param>
		/// <param name="time">[DateTime] (need both day of week and time of day)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns a DataSet with one table, two columns, 1 row with result.
		/// <ul>
		/// <li>DataSet Table Name: <ul><li><b>IsMealTicketAppropriate</b></li></ul></li>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>IsMealTicketAppropriate</b> [bool]</li>
		/// <li><b>Price</b> [decimal]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By: None Specified</li>
		///	</ul>
		///</returns>
		public static bool IsMealTicketAppropriate(int stationId, int volId, DateTime time, int hoursForVol,
		out decimal price, out string volunteerName, out int numberOfMealsProvided, ApplicationConnection appCon, out string debug)
		{
			//initialize variables
			debug = "";
			numberOfMealsProvided = 0;
			int mealsEligableToRecieve = 0;
			price = 0;
			volunteerName = "";

			try
			{
				//Find out if the Volunteer has the right to get meals.
				NameObjectCollection volRec = new NameObjectCollection();
				NameObjectCollection volList = Volunteer.GetVolunteerDRMealAuth(stationId, volId);

				if (volList.Count > 0)
				{
					volRec = (NameObjectCollection)volList.Get(0);
					if (volRec.Count > 0)
					{
						volunteerName = (string)volRec.Get("Column2");
						mealsEligableToRecieve = (int)volRec.Get("Column1");
					}
				}
					
				volRec.Dispose();
				volList.Dispose();
				///DataSet vds = Volunteer.GetVolunteerMealAuth(stationId, volId);
				//debug += "1VolunteerId: " + volId.ToString() + "<BR>";

///				volunteerName = (string)vds.Tables["MealAuthorization"].Rows[0]["Name"];
				//debug += "2 of 11 --> Volunteer Name: " + volunteerName + "<BR>";
				//debug += "3 of 11 --> Bool Elegible For Meals: " + Convert.ToBoolean(vds.Tables["MealAuthorization"].Rows[0]["EligibleForMeals"]).ToString() + "<BR>";
			

///				if(Convert.ToBoolean(vds.Tables["MealAuthorization"].Rows[0]["EligibleForMeals"]))
				if(Convert.ToBoolean(mealsEligableToRecieve))
				{
///					mealsEligableToRecieve = Convert.ToInt32(vds.Tables["MealAuthorization"].Rows[0]["EligibleForMeals"]);
					//debug += "4 of 11 --> Elegible For Meals: " + mealsEligableToRecieve.ToString() + "<BR>";
					//Dispose of the Volunteers record since we don't need it anymore.
///					vds.Dispose();

					//Get Station Parameters for Meal Tickets
					NameObjectCollection spRec = new NameObjectCollection();
					NameObjectCollection spList = StationParameters.GetInstitutionDRMealTicketParams(stationId);;

///					DataSet ds = StationParameters.GetInstitutionMealTicketParams(stationId);

					string sNumberOfMeals="Column1", sMealAuthorization = "Column2";
					string sIsSaturdayMeal="Column3",	sIsSundayMeal="Column4";
					string sIsHolidayMeal="Column5",	sMealPrice="Column6";
					string sDurationForMeal1="Column7",sCutOffTimeForMeal1="Column8";
					string sDurationForMeal2="Column9",sCutOffTimeForMeal2="Column10";

					//find station parameter row
///					if (ds.Tables["MealParams"].Rows.Count > 0)
					if (spList.Count > 0)
					{
						spRec = (NameObjectCollection)spList.Get(0);

						//Get the MealParams Table from the DataSet
///						DataRow dr = ds.Tables["MealParams"].Rows[0];

						//CutOffTimeForMeal1
						//debug += "5 of 11 --> Number Of Meals: " + dr["NumberOfMeals"] + "<BR>";
						if((int)spRec.Get(sNumberOfMeals) > 0)
						{
							//If the price is empty then return false otherwise set the price
							if (spRec.Get(sMealPrice).ToString() == String.Empty)
							{
								return false;
							}
							else 
							{
								price = (decimal)spRec.Get(sMealPrice);
							}
							//debug += "6 of 11 --> Price: " + price + "<BR>";

							//check days of week for applicability
							string dayOfWeek = time.DayOfWeek.ToString();
							//debug += "7 of 11 --> Day Of Week: " + dayOfWeek + "<BR>";

							if (dayOfWeek == "Saturday" && !((bool)spRec.Get(sIsSaturdayMeal)))
							{
								return false;
							}

							if (dayOfWeek == "Sunday"   && !((bool)spRec.Get(sIsSundayMeal)))
							{
								return false;
							}

							if (Holiday.IsHoliday(time) && !((bool)spRec.Get(sIsHolidayMeal)))
							{
								return false;
							}
						

							//Grab the TimeOfDay from the clients time
							TimeSpan ti =time.TimeOfDay;
							int hrs = ti.Hours;
							int min = ti.Minutes;
							//debug += "8 of 11 --> Time Of Day: " + ti.ToString() + "<BR>";
							//debug += "9 of 11 --> Hours: " + hrs.ToString() + "<BR>";
							//debug += "10 of 11 --> Minutes: " + min.ToString() + "<BR>";

							//string cutOff;
							//int cutOffTime, currTime, hoursForElegability, noOfMeals;

							//string cutOff;
							int currTime, noOfMeals;

							noOfMeals = Convert.ToInt32(spRec.Get(sNumberOfMeals));
							//debug += "11 of 11 --> Number Of Meals: " + dr["NumberOfMeals"] + "<BR>";
							//debug += "12 of 11 --> Number Of Meals Volunteer: " + mealsEligableToRecieve.ToString() + "<BR>";


							//convert the current time to military time
							currTime = (hrs * 100) + min;

							if (noOfMeals == 2 && mealsEligableToRecieve == 2)
							{
								//Code 2 meals logic here
								if(IsEligibleForMeal(currTime, hoursForVol, Convert.ToInt32(spRec.Get(sCutOffTimeForMeal2)), Convert.ToInt32(spRec.Get(sDurationForMeal1))))
									numberOfMealsProvided++;
								if(IsEligibleForMeal(currTime, hoursForVol, Convert.ToInt32(spRec.Get(sCutOffTimeForMeal1)), Convert.ToInt32(spRec.Get(sDurationForMeal2))))
									numberOfMealsProvided++;
								//debug += "13 of 11 --> Give Number Of Meals : " + numberOfMealsProvided.ToString() + "<BR>";
							}
							else
							{
								if(IsEligibleForMeal(currTime, hoursForVol, Convert.ToInt32(spRec.Get(sCutOffTimeForMeal1)), Convert.ToInt32(spRec.Get(sDurationForMeal1))))
									numberOfMealsProvided++;
								//debug += "14 of 11 --> Give Number Of Meals : " + numberOfMealsProvided.ToString() + "<BR>";
							}
						}
						spRec.Dispose();
						spList.Dispose();

						if(numberOfMealsProvided > 0)
							return true;
						else
							return false;
					}
					else
					{
						return false;
					}
				}
				else
				{
					return false;
				}
			}
			catch
			{
				return false;
			}
		}

		private static bool IsEligibleForMeal(int actualTime, int actualHours, int cutoffTime, int requiredHours)
		{
			if(actualTime > cutoffTime) 
			{
				return false;
			}
			if(actualHours < requiredHours) 
			{
				return false;
			}
			return true;
		}

		private static DataSet MoveToDataSet(bool isApp, decimal price)
		{
			DataSet ds = new DataSet("IsMealTicketAppropriate");

			DataTable dt = new DataTable("IsMealTicketAppropriate");

			DataColumn col1 = new DataColumn("IsAppropriate", System.Type.GetType("System.Boolean"));
			dt.Columns.Add(col1);
			DataColumn col2 = new DataColumn("Price", System.Type.GetType("System.Decimal"));
			dt.Columns.Add(col2);

			DataRow dr;
			dr = dt.NewRow(); dr["IsAppropriate"] = isApp; dr["Price"] = price; dt.Rows.Add(dr);
			ds.Tables.Add(dt);
			return ds;
		}
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
