﻿
/*

			Class:              VolunteerAdjustments

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
				
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;

#if msSql
using sqlDrv = Vha.Vtk.DataClasses.VolunteerAdjustmentsMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerAdjustments
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class VolunteerAdjustments : VolunteerAdjustmentsBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		/// <summary>
		/// Main Constructor
		/// </summary>
		public VolunteerAdjustments() : base()
		{

		}
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id"> Primary Key value for VtkVolunteerAdjustments</param>
		public VolunteerAdjustments(int id) : base(id)
		{
			
		}
				
		/// <summary>
		/// Creates an instance of VolunteerAdjustments that will be used to add a record to the VtkVolunteerAdjustments database table.
		/// Must specify the stationProfileId that the record will be created for
		/// </summary>
		/// <param name="stationProfileId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="VolunteerAdjustments" /></returns>
		public static VolunteerAdjustments AddRecord(int profileId)
		{
			VolunteerAdjustments vaObj = new VolunteerAdjustments();
			vaObj.FillDataNew();
			vaObj.ProfileId = profileId;
			return vaObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();

			if (returnStatus.Status == si.Pass) returnStatus =  ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus =  ValidateProfileId(ProfileId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus =  ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAdjustmentDate(AdjustmentDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAdjustmentHours(AdjustmentHours);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAdjustmentDescription(AdjustmentDescription);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateStationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateStationId(value, appCon);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for ProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ProfileId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateProfileId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateVolunteerId(value, appCon);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for AdjustmentDate property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateAdjustmentDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AdjustmentDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAdjustmentDate(DateTime value)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateAdjustmentDate(value);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for AdjustmentHours property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateAdjustmentHours.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AdjustmentHours</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAdjustmentHours(Int32 value)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateAdjustmentHours(value);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for AdjustmentDescription property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerAdjustmentsBase.ValidateAdjustmentDescription.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AdjustmentDescription</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAdjustmentDescription(string value)
		{
			ReturnStatus ret = VolunteerAdjustmentsBase.ValidateAdjustmentDescription(value);
			return ret;
		}

		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		
		#if msSql
		
		/// <summary>
		/// returns all Parking Stickers for a StationProfile
		/// DataSet Table Name: VolunteerAdjustmentsList
		/// </summary>
		/// <param name="stationProfileId">Station Profile ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <list type="bullet">
		/// <item><description>DataSet Table Name:  <list type="bullet"><item><description><b> VolunteerAdjustmentsList</b></description></item></list></description></item>  
		/// <br></br>
		/// <item><description>Data Columns Returned:
		/// <list type="bullet">
		/// <item><description><b>ID</b> [int]</description></item>
		/// <item><description><b>StationProfileId</b> [int]</description></item>
		/// <item><description><b>StateId</b> [int]</description></item>
		/// <item><description><b>StickerNumber</b> [string (13)]</description></item>
		/// <item><description><b>LicensePlate</b> [string (12)]</description></item>
		///	</list>
		///	</description></item>
		///	<br></br>
		///	<item><description>Sorted By: None Specified</description></item>
		///	</list>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int profileId, ApplicationConnection appCon)
		{
			string sCommand = "Select "				+
				sqlDrv.idField						+ " ID, " +
				sqlDrv.stationIdField				+ " StationId, " +
				sqlDrv.profilesIdField				+ " ProfileId, " +
				sqlDrv.volunteerIdField				+ " VolunteerId, " +
				sqlDrv.adjustmentDateField			+ " AdjustmentDate, " +
				sqlDrv.adjustmentHoursField			+ " AdjustmentHours, " +
				sqlDrv.adjustmentDescriptionField	+ " AdjustmentDescription " +
				" FROM " + sqlDrv.tableName  +
				" WHERE " + sqlDrv.profilesIdField + " = '" + profileId + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"VolunteerAdjustmentsList");
			da.Dispose();
			return ds;
		}
		
		/// <summary>
		/// Returns count of entries for stationId / volunteerId pair in VtkVolunteerHours
		/// </summary>
		/// <param name="stationId">Primary key for station</param>
		/// <param name="volunteerId">Primary key for volunteer</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <br>Count of number of records in VtkVolunteerHours table for stationId/volunteerId pair</br> 
		/// </returns>
		public static int GetSumOfAdjustmentHours(int profileId, ApplicationConnection appCon)
		{
			string sCommand = 
				"SELECT Sum(AdjustmentHours) AdjHours" +
				" FROM "  + sqlDrv.tableName +
				" GROUP BY " + sqlDrv.profilesIdField +
				" HAVING " + sqlDrv.profilesIdField + " = '" + profileId + "'";

			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"AdjustmentId");
			da.Dispose();

			/*string sCommandSum = 
				"SELECT Sum(AdjustmentHours)" +
				" FROM "  + sqlDrv.tableName +
				" GROUP BY " + sqlDrv.profilesIdField +
				" HAVING " + sqlDrv.profilesIdField + " = '" + profileId + "'"; */

			//SqlConnection conn = new SqlConnection(appCon.ConnectString);
			//SqlCommand cmdSum = new SqlCommand(sCommandSum, conn);
			int SumofAdjustments = 0;

			if (ds.Tables["AdjustmentId"].Rows.Count == 1)
			{

				SumofAdjustments = (int)ds.Tables["AdjustmentId"].Rows[0]["AdjHours"];
				//SqlConnection conn = new SqlConnection(appCon.ConnectString);
				//cmdSum.Connection.Open();

				//(int)cmdSum.ExecuteScalar();
			}
			//cmdSum.Connection.Close();
			//cmdSum.Dispose();
			//conn.Dispose();

			return SumofAdjustments;
		}

		#endif
		
		#endregion
		
		#region Section: Utilities

		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}

		#endregion
		
	}
}
