﻿
/*

			Class:              VolunteerHour

			Date Produced:      11/19/2001 10:26:10 AM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        11/16/2001 11:48:58 AM
			Revision:           319

			SQL Server Version: 08.00.0194
			Server:             zzzzzzmul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.VolunteerHoursMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerHours
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class VolunteerHours : VolunteerHoursBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <Params>
		/// <param name="VolunteerId">Int32</param>
		/// <param name="StationId">Int32</param>
		/// <param name="OrganizationId">Int32</param>
		/// <param name="ScheduleId">Int32</param>
		/// <param name="BenefitingServiceId">Int32</param>
		/// <param name="DateWorked">DateTime: Date volunteer worked</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// </Params>Params>
		public VolunteerHours(int VolunteerId, int StationId, int OrganizationId, int ScheduleId, int BenefitingServiceId, DateTime DateWorked, ApplicationConnection appCon) : base(VolunteerId, StationId, OrganizationId, ScheduleId, BenefitingServiceId, DateWorked, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private VolunteerHours(ApplicationConnection appCon) : base(appCon)
		{
		}
				
		/// <summary>
		/// Add a new VolunteerHours record.
		/// </summary>
		/// <Params>
		/// <param name="VolunteerId">Int32</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// </Params>Params>
		/// <returns><see cref="VolunteerHours" /></returns>
		public static VolunteerHours AddRecord(	int VolunteerId, 
												ApplicationConnection appCon)
		{
			VolunteerHours vhrsObj = new VolunteerHours(appCon);
			vhrsObj.FillDataNew();
			vhrsObj.VolunteerId  = VolunteerId;
			return vhrsObj;
		}

		/// <summary>
		/// Retrieves or creates a VolunteerHours instance for a volunteer for a work date based
		/// on a data row from the 'CombinationAssignments.GetQuickList' method.
		/// 
		/// Note: If new record is created then this method will automatically set all
		///       cooresponding combination code properties from data in dataset plus the 'dateWorked'
		///       parameter.
		/// </summary>
		/// <param name="dr">DataRow: Row from CombinationAssignments.GetQuickList</param>
		/// <param name="dateWorked">DateTime: Date volunteer worked</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="VolunteerHours" /></returns>
		public static VolunteerHours GetVolunteerHoursInstance(DataRow dr, DateTime dateWorked, ApplicationConnection appCon)
		{
			return VolunteerHours.GetVolunteerHoursInstance(
				// Note: needed to convert because 'CombinationAssignments.GetQuickList' method
				//  adds column strings to saved JOINs. 
				Convert.ToInt32(dr["VolunteerId"].ToString()),
				Convert.ToInt32(dr["StationId"].ToString()),
				(int)dr["OrganizationId"],
				(int)dr["ScheduleId"],
				(int)dr["BenefitingServiceId"],
				dateWorked,
				appCon);
		}

		/// <summary>
		/// Retrieves or creates a VolunteerHours instance for a volunteer for a work date based
		/// on a data passed in the parameters.
		/// 
		/// Note: If new record is created then this method will automatically set all
		///       cooresponding combination code properties from data in passed in parameters.
		/// </summary>
		/// <param name="volunteerId">Int32</param>
		/// <param name="stationId">Int32</param>
		/// <param name="organizationId">Int32</param>
		/// <param name="scheduleId">Int32</param>
		/// <param name="benefitingServiceId">Int32</param>
		/// <param name="dateWorked">DateTime: Date volunteer worked</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="VolunteerHours" /></returns>
		public static VolunteerHours GetVolunteerHoursInstance(
			int volunteerId,
			int stationId,
			int organizationId,
			int scheduleId,
			int benefitingServiceId,
			DateTime dateWorked,
			ApplicationConnection appCon)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			string sCommand = "EXEC spS_GetVolunteerHoursInstance " +
							   volunteerId.ToString() + ", " +
							   stationId.ToString() + ", " +
							   organizationId.ToString() + ", " +
							   scheduleId.ToString() + ", " +
							   benefitingServiceId.ToString() + ", '" +
							   dateWorked.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "'";

			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"VolunteerHours");
			da.Dispose();

			VolunteerHours volHrs;
			if (ds.Tables["VolunteerHours"].Rows.Count == 1)
			{
				int iVID;
				int iSID;
				int iOID;
				int iScID;
				int iBsID;
				DateTime dDWkd;

				iVID = Convert.ToInt32(ds.Tables["VolunteerHours"].Rows[0]["VolunteerFK"]);
				iSID = Convert.ToInt32(ds.Tables["VolunteerHours"].Rows[0]["StationFK"]);
				iOID = Convert.ToInt32(ds.Tables["VolunteerHours"].Rows[0]["OrganizationFK"]); 
				iScID = Convert.ToInt32(ds.Tables["VolunteerHours"].Rows[0]["ScheduleFK"]); 
				iBsID = Convert.ToInt32(ds.Tables["VolunteerHours"].Rows[0]["BenefitingServiceFK"]); 
				dDWkd = (DateTime)ds.Tables["VolunteerHours"].Rows[0]["DateWorked"];

				volHrs = new VolunteerHours(iVID, iSID, iOID, iScID, iBsID, dDWkd, appCon);
			}
			else if (ds.Tables["VolunteerHours"].Rows.Count == 0)
			{
				volHrs = VolunteerHours.AddRecord(Convert.ToInt32(volunteerId), appCon);
				volHrs.VolunteerId         = volunteerId;
				volHrs.StationId           = stationId;
				volHrs.OrganizationId      = organizationId;
				volHrs.ScheduleId          = scheduleId;
				volHrs.BenefitingServiceId = benefitingServiceId;
				volHrs.DateWorked          = dateWorked;
			}
			else
			{
				string msg;
				msg =
					"More than one VolunteerHours entry already exists: \r\n" +
					" VolunteerId: "         + volunteerId.ToString() + "\r\n" +
					" StationId: "           + stationId.ToString() + "\r\n" +
					" OrganizationId: "      + organizationId.ToString() + "\r\n" +
					" ScheduleId: "          + scheduleId.ToString() + "\r\n" +
					" BenefitingServiceId: " + benefitingServiceId.ToString() + "\r\n" +
					" DateWorked: "          + dateWorked.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "\r\n";

				throw new Exception(msg);
			}
			return volHrs;
		}


		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);		
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationId(OrganizationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateScheduleId(ScheduleId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateBenefitingServiceId(BenefitingServiceId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateWorked(DateWorked);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateHoursWorked(HoursWorked);
			return returnStatus;
		}
		
		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Ensures Organizations are active.</description></item>
		/// <item><description>Ensures Local Organizations are local to the StationId.</description></item>
		/// <item><description>Ensures Local Services are local to the StationId.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "VolunteerHour";
			ret.PropertyName = "[Relations Check]";

			// inactive organization check check
			// TODO: Re-evaluate this check in Phase II since there is currently no way to determine if organization was active on work date. 
			Organization org = new Organization(this.organizationId, appCon);
			if (org.IsInactive)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Only active organizations are allowed. (Organization: " + org.OrganizationName + " (ID: " + this.organizationId.ToString() + ") is inactive)";
				return ret;
			}

			// local code check
			if ((org.Scope == "L") && (org.StationId != this.StationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local organization code entered.\r\n (Invalid Code / StationId: " + org.Code + " / " + this.StationId + ")";
				return ret;
			}

			// local code check
			Service srv  = new Service(this.benefitingServiceId, appCon);
			if ((srv.Scope == "L") && (srv.StationId != this.StationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local service code entered.\r\n (Invalid Code / StationId: " + srv.Code + " / " + this.StationId + ")";
				return ret;
			}

			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateVolunteerId(value, appCon);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateStationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance value of StationId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateStationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateOrganizationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance value of OrganizationId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateOrganizationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ScheduleId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateScheduleId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance value of ScheduleId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateScheduleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateScheduleId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for BenefitingServiceId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateBenefitingServiceId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance value of ServiceId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateBenefitingServiceId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateBenefitingServiceId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateWorked property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateDateWorked.</description></item>
		/// <item><description>Validates that DateWorked is not greater than current date.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance value of DateWorked</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateDateWorked(DateTime value)
		{
			// TODO: Add check of VtkRollupLog MAX(CloseMonth)
			ReturnStatus ret = VolunteerHoursBase.ValidateDateWorked(value);
			// DateWorked can not be greater than today
			if ((ret.Status == si.Pass) && (value.Date > DateTime.Today))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'DateWorked' can not be greater than today's date.";
			}
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for HoursWorked property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling VolunteerHoursBase.ValidateHoursWorked.</description></item>
		/// <item><description>Validates that HoursWorked is not greater than 12.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of HoursWorked</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateHoursWorked(Int32 value)
		{
			ReturnStatus ret = VolunteerHoursBase.ValidateHoursWorked(value);
		 
			// required field check
			if ((ret.Status == si.Pass) && (value > 12))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'HoursWorked cannot be greater than 12. (Entered Value: " + value + ")";
			}
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		/// <summary>
		/// Save current instance
		/// </summary>
		/// <returns></returns>
		public override ReturnStatus Save()
		{
			ReturnStatus ret = SaveCheck();
			if (ret.Status != si.Pass) throw new VhaValidationException(ret.ErrorText, ret.ClassName, returnStatus.PropertyName);

			return base.Save();
		}
		
		/// <summary>
		/// Overall check before saving. (Currently, checks to verify record is not 'Closed'.
		/// </summary>
		/// <returns></returns>
		public ReturnStatus SaveCheck()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "RecordStatus";
			
			// can't save if record status is 'C'losed
			if (RecordStatus == "C")
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Updates and deletes are not allowed for an VolunteerHours entry with a 'Record Status' of 'Closed'.";
			}	
		
			if (ret.Status != si.Pass) return ret;
			
			if (GetCombinationCodePerDayCount(appCon) > 1)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Only one entry for a combinationCode per day is Allowed";
			}
			return ret;
		}

		#if msSql
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns></returns>
		private int GetCombinationCodePerDayCount(ApplicationConnection appCon)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			string sCommand = 
				"EXEC spS_GetCombinationCodePerDayCount " +
				this.volunteerId + ", " +
				this.StationId + ", " +
				this.organizationId + ", " +
				this.benefitingServiceId + ", " +
				this.scheduleId + ", '" +
				this.dateWorked.ToString("MM/dd/yyyy") + "'";
		
			SqlConnection conn = new SqlConnection(appCon.ConnectString);
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			int count = (int)cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();
			return count;
		}

		#endif
			
		#endregion
		
		#region Section: Quick Lists
				
		#if msSql
		
		/// <summary>
		/// Returns the VolunteerHour record for the specified Id
		/// DataSet Table Name: 'VolunteerHourList'
		/// </summary>
		/// <param name="volId"></param>
		/// <param name="stnId"></param>
		/// <param name="orgId"></param>
		/// <param name="schId"></param>
		/// <param name="svcId"></param>
		/// <param name="dateWorked"></param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <returns>
		/// Returns the VolunteerHour record for the specified Id
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>RecordStatus</b> [String (1)]</li>
		/// <li><b>ScheduleId</b> [int]</li>
		/// <li><b>StationId</b> [int]</li>
		/// <li><b>VolunteerId</b> [int]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetQuickList(int volId, int stnId, int orgId, int schId, int svcId, DateTime dateWorked,  bool includeClosedRecords)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			string sCommand = "EXEC spS_GetQuickList "  +
				volId.ToString() + ", " +
				stnId.ToString() + ", " +
				orgId.ToString() + ", " +
				schId.ToString() + ", " +
				svcId.ToString() + ", '" +
				dateWorked.ToShortDateString() + "', '" +
				includeClosedRecords.ToString() + "'";

			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerHourList");
		}
		
		/// <summary>
		/// Returns the VolunteerHour record for the specified Id that do not have a 'C'losed RecordStatus..
		/// DataSet Table Name: 'VolunteerHourList'
		/// </summary>
		/// <param name="volId"></param>
		/// <param name="stnId"></param>
		/// <param name="orgId"></param>
		/// <param name="schId"></param>
		/// <param name="svcId"></param>
		/// <param name="dateWorked"></param>
		/// <returns>
		/// Returns the VolunteerHour record for the specified Id
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>RecordStatus</b> [String (1)]</li>
		/// <li><b>ScheduleId</b> [int]</li>
		/// <li><b>StationId</b> [int]</li>
		/// <li><b>VolunteerId</b> [int]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetQuickList(int volId, int stnId, int orgId, int schId, int svcId, DateTime dateWorked)
		{
			return GetQuickList(volId, stnId, orgId, schId, svcId, dateWorked, false);
		}

		/// <summary>
		/// Returns a DataSet containing all VolunteerHours records for a specified
		/// Volunteer, Station and month/year that do not have a RecordStatus = 'C'losed.
		/// DataSet TableName: 'VolunteerHourList'
		/// </summary>
		/// <param name="volId">VolunteerId</param>
		/// <param name="stationId">StationId</param>
		/// <param name="month">Month</param>
		/// <param name="year">Year</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Volunteer, Station, Month, and Year
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>DateWorked</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetVolunteersMonthlyQuickList(int volId, int stationId, int month, int year)
		{
			return GetVolunteersMonthlyQuickList(volId, stationId, month, year, false);
		}


		/// <summary>
		/// Returns a DataSet containing all VolunteerHours records for a specified
		/// Volunteer, Station and month/year.
		/// DataSet TableName: 'VolunteerHourList'
		/// </summary>
		/// <param name="volId">VolunteerId</param>
		/// <param name="stationId">StationId</param>
		/// <param name="month">Month</param>
		/// <param name="year">Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Volunteer, Station, Month, and Year
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>DateWorked</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetVolunteersMonthlyQuickList(int volId, int stationId, int month, int year, bool includeClosedRecords)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd   = dateBegin.AddMonths(1).AddDays(-1);

			string sCommand =	"spS_GetVolunteersMonthlyQuickList " + volId.ToString() + ", " + 
								stationId.ToString() + ", '" +
								dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "', '" +
								dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "', '" +
								includeClosedRecords.ToString() + "'";

			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerHourListMonthly");
		}


		/// <summary>
		/// Returns a NameObjectCollection containing all VolunteerHours records for a specified
		/// Volunteer, Station and month/year.
		/// </summary>
		/// <param name="volId">VolunteerId</param>
		/// <param name="stationId">StationId</param>
		/// <param name="month">Month</param>
		/// <param name="year">Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Volunteer, Station, Month, and Year
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>DateWorked</b></li></ul>
		///	</ul>
		/// </returns>
		public static NameObjectCollection GetVolunteersDRMonthlyQuickList(int volId, int stationId, int month, int year, bool includeClosedRecords)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd   = dateBegin.AddMonths(1).AddDays(-1);

			SqlCommand sqlCommand = new SqlCommand();                      

			string sCommand =	"spS_GetVolunteersDRMonthlyQuickList " + volId.ToString() + ", " + 
				stationId.ToString() + ", '" +
				dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "', '" +
				dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "', '" +
				includeClosedRecords.ToString() + "'";

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}

		/// <summary>
		/// Returns a DataSet containing all VolunteerHours records for a specified
		///  Station and dateworked that do not have a 'C'losed RecordStatus.  
		/// DataSet TableName: 'VolunteerHourList'
		/// </summary>
		/// <param name="stationId">StationId</param>
		/// <param name="workDay">DateTime workDay</param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Station and DateWorked
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetQuickListForStationForDate(int stationId, DateTime workDay)
		{
			return GetQuickListForStationForDate(stationId, workDay, false);
		}


		/// <summary>
		/// Returns a DataSet containing all VolunteerHours records for a specified
		///  Station and dateworked.  
		/// DataSet TableName: 'VolunteerHourList'
		/// </summary>
		/// <param name="stationId">StationId</param>
		/// <param name="workDay">DateTime workDay</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Station and DateWorked
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> VolunteerHourList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetQuickListForStationForDate(int stationId, DateTime workDay, bool includeClosedRecords)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			string sCommand =	"spS_GetQuickListForStationForDate " + 
				stationId.ToString() + ", '" +
				workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "', '" +
				includeClosedRecords.ToString() + "'";
			
			return ApplicationConnection.ExecuteQuery(sCommand, "VolunteerHourListDaily");
		}

		/// <summary>
		/// Returns a NameObjectCollection containing all VolunteerHours records for a specified
		///  Station and dateworked.  
		/// </summary>
		/// <param name="stationId">StationId</param>
		/// <param name="workDay">DateTime workDay</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Station and DateWorked
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static NameObjectCollection GetQuickDRSortListForStationForDate(int stationId, DateTime workDay, string sFilter, string sOrderBy, string sOption)
		{
			SqlCommand sqlCommand = new SqlCommand();

			string sCommand = "Select VH.id ID ";   

			switch(sOption)
			{
				case "HoursWorked":
					sCommand = sCommand + 
							", VH." + sqlDrv.hoursWorkedField  + " HoursWorked " +
							" FROM " + sqlDrv.tableName + " VH " +
							" WHERE VH."  + sqlDrv.stationIdField + " = '" + stationId + "' " +
							" AND VH." + sqlDrv.dateWorkedField + " = '" + workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";
					sCommand = sCommand + " AND (VH." + sqlDrv.recordStatusField + " <> 'C') ";
					break;
				case "OrganizationName":
					sCommand = sCommand + 
						", ORG." + OrganizationMsSqlSrv.organizationNameField + " OrganizationName " +
						" FROM " + sqlDrv.tableName + " VH " +
						" INNER JOIN " + OrganizationMsSqlSrv.tableName + " ORG  ON ORG." + OrganizationMsSqlSrv.idField + " = VH." + sqlDrv.organizationIdField +
						" WHERE VH."  + sqlDrv.stationIdField + " = '" + stationId + "' " +
						" AND VH." + sqlDrv.dateWorkedField + " = '" + workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";
					sCommand = sCommand + " AND (VH." + sqlDrv.recordStatusField + " <> 'C') ";
					break;
				case "ServiceName":
					sCommand = sCommand + 
						", SRV." + ServiceMsSqlSrv.serviceNameField + " ServiceName " +
						" FROM " + sqlDrv.tableName + " VH " +
						" INNER JOIN " + ServiceMsSqlSrv.tableName + " SRV  ON SRV." + ServiceMsSqlSrv.idField + " = VH." + sqlDrv.benefitingServiceIdField +
						" WHERE VH."  + sqlDrv.stationIdField + " = '" + stationId + "' " +
						" AND VH." + sqlDrv.dateWorkedField + " = '" + workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";
					sCommand = sCommand + " AND (VH." + sqlDrv.recordStatusField + " <> 'C') ";
					break;
				case "VolunteerDisplayName":					
					sCommand = sCommand + 
						", VRS." + VolunteerMsSqlSrv.fullNameForReportsField + " VolunteerDisplayName " +
						" FROM " + sqlDrv.tableName + " VH " +
						" INNER JOIN " + VolunteerMsSqlSrv.tableName + " VRS ON VRS." + VolunteerMsSqlSrv.idField + " = VH." + sqlDrv.volunteerIdField +
						" WHERE VH."  + sqlDrv.stationIdField + " = '" + stationId + "' " +
						" AND VH." + sqlDrv.dateWorkedField + " = '" + workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";
					sCommand = sCommand + " AND (VH." + sqlDrv.recordStatusField + " <> 'C') ";
					break;
			}


			if (sFilter != string.Empty)
				sCommand = sCommand + " AND " + sFilter ;

			if (sOrderBy != string.Empty)
				sCommand = sCommand + sOrderBy;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}


		/// <summary>
		/// Returns a NameObjectCollection containing all VolunteerHours records for a specified
		///  Station and dateworked.  
		/// </summary>
		/// <param name="stationId">StationId</param>
		/// <param name="workDay">DateTime workDay</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns the VolunteerHour records for the specified Station and DateWorked
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>BenefitingServiceId</b> [int]</li>
		/// <li><b>DateWorked</b> [DateTime]</li>
		/// <li><b>HoursWorked</b> [int]</li>
		/// <li><b>OrganizationId</b> [int]</li>
		/// <li><b>OrganizationName</b> [String]</li>
		/// <li><b>ServiceName</b> [string]</li>
		/// <li><b>RecordStatus</b> [string (1)]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Nothing Specified</b></li></ul>
		///	</ul>
		/// </returns>
		public static NameObjectCollection GetQuickDRListForStationForDate(int stationId, DateTime workDay, bool includeClosedRecords, string sFilter, string sOrderBy)
		{
			SqlCommand sqlCommand = new SqlCommand();

			string sCommand = "Select TOP 10 VH.id ID, "   +
				" VH." + sqlDrv.dateWorkedField              + " DateWorked, " +
				" VH." + sqlDrv.hoursWorkedField             + " HoursWorked, " +
				" VH." + sqlDrv.organizationIdField          + " OrganizationId, " +
				" VH." + sqlDrv.benefitingServiceIdField     + " BenefitingServiceId, " +
				" VH." + sqlDrv.recordStatusField            + " RecordStatus, " +
				" ORG." + OrganizationMsSqlSrv.organizationNameField + " OrganizationName, " +
				" SRV." + ServiceMsSqlSrv.serviceNameField           + " ServiceName, " +
				" VRS." + VolunteerMsSqlSrv.fullNameForReportsField + " VolunteerDisplayName, " +
				" VRS." + VolunteerMsSqlSrv.idField + " VolunteerId " +
				" FROM " + sqlDrv.tableName + " VH " +
				" INNER JOIN " + VolunteerMsSqlSrv.tableName + " VRS ON VRS." + VolunteerMsSqlSrv.idField + " = VH." + sqlDrv.volunteerIdField +
				" INNER JOIN " + OrganizationMsSqlSrv.tableName + " ORG  ON ORG." + OrganizationMsSqlSrv.idField + " = VH." + sqlDrv.organizationIdField +
				" INNER JOIN " + ServiceMsSqlSrv.tableName + " SRV  ON SRV." + ServiceMsSqlSrv.idField + " = VH." + sqlDrv.benefitingServiceIdField +
				" WHERE VH."  + sqlDrv.stationIdField + " = '" + stationId + "' " +
				" AND VH." + sqlDrv.dateWorkedField + " = '" + workDay.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";
			if (!includeClosedRecords) 
				sCommand = sCommand + " AND (VH." + sqlDrv.recordStatusField + " <> 'C') ";
			if (sFilter != string.Empty)
				sCommand = sCommand + " AND " + sFilter ;

			if (sOrderBy != string.Empty)
				sCommand = sCommand + sOrderBy;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}

		public static DataSet GetQuickListForGamesByDate(DateTime WorkDay,string GameTypeCode)
		{
			return ApplicationConnection.ExecuteQuery("spS_VolunteerHours_GetQuickListForGamesByDate '" + WorkDay.ToShortDateString() + "', '" + GameTypeCode + "'", "GetQuickListForGamesByDate");
		}

		public static DataSet GetQuickListForGamesByVolunteer(int VolunteerId, DateTime BeginDate, DateTime EndDate, string GameTypeCode)
		{
			return ApplicationConnection.ExecuteQuery("spS_VolunteerHours_GetQuickListForGamesByVolunteer " + VolunteerId.ToString() + ", '" + BeginDate.ToShortDateString() + "', '" + EndDate.ToShortDateString() + "', '" + GameTypeCode + "'", "GetQuickListForGamesByVolunteer");
		}

		// this will make the call to the sproc to return data for the CO VS01 dataview (report)
		public static DataSet GetQuickListDataForVS01Report(int FiscalYear, int Months)
		{
			StringBuilder sCommand = new StringBuilder("spQN_VtkServicesRSOccHours_VS01_excel_report " + FiscalYear.ToString() + ", " + Months.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQueryTimeout(sCommand.ToString(), "GetQuickListDataForVS01Report");			
		}

		// this will make the call to the sproc to return data for the CO Volunteers By Organization dataview (report)
		public static DataSet GetQuickListDataForVolByOrgReport(string orglist, System.DateTime begindate, System.DateTime enddate)
		{
			StringBuilder sCommand = new StringBuilder("spQN_VtkVolunteersByOrganization '^', '" + orglist + "', '" + begindate.ToShortDateString() + "', '" + enddate.ToShortDateString() + "'");
			
			int Success = 0;
			return ApplicationConnection.ExecuteQueryTimeout(sCommand.ToString(), "GetQuickListDataForVolByOrgReport");			
		}


		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
