﻿
/*

			Class:              MealsProvided

			Date Produced:      7/2/2002 11:57:18 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        6/18/2002 11:43:05 AM
			Revision:           655

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\Vha.Vtk.MealTickets

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.905.24702

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Kernel.Data;
using Vha.Vss.Utility;

//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.MealsProvidedMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.MealTickets
{
	/// <summary>
	///  Public Class mapped to VtkMealsProvided
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class MealsProvided : MealsProvidedBase
	{
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkMealsProvided entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public MealsProvided(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private MealsProvided(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of MealsProvided thate will be used to add a record to the VtkMealsProvided database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="MealsProvided"/></returns>
		public static MealsProvided AddRecord(ApplicationConnection appCon)
		{
			MealsProvided mtObj = new MealsProvided(appCon);
			mtObj.FillDataNew();
			return mtObj;
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateOfMeal(DateOfMeal);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNumberOfMeals(NumberOfMeals);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsUnscheduled(IsUnscheduled);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNameOfUnscheduled(NameOfUnscheduled);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateHowAdded(HowAdded);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsReprinted(IsReprinted);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTimeLastPrinted(TimeLastPrinted);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsRemovedFromList(IsRemovedFromList);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateOfMeal property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateDateOfMeal.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DateOfMeal</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDateOfMeal(DateTime value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateDateOfMeal(value);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateInstitutionId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateVolunteerId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NumberOfMeals property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateNumberOfMeals.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NumberOfMeals</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNumberOfMeals(Int32 value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateNumberOfMeals(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsUnscheduled property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateIsUnscheduled.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsUnscheduled</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsUnscheduled(bool value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateIsUnscheduled(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NameOfUnscheduled property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateNameOfUnscheduled.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NameOfUnscheduled</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNameOfUnscheduled(string value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateNameOfUnscheduled(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for HowAdded property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateHowAdded.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of HowAdded</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateHowAdded(string value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateHowAdded(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsReprinted property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateIsReprinted.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsReprinted</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsReprinted(bool value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateIsReprinted(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for TimeLastPrinted property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateTimeLastPrinted.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TimeLastPrinted</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateTimeLastPrinted(DateTime value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateTimeLastPrinted(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsRemovedFromList property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling MealsProvidedBase.ValidateIsRemovedFromList.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsRemovedFromList</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsRemovedFromList(bool value)
		{
			ReturnStatus ret = MealsProvidedBase.ValidateIsRemovedFromList(value);
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'MealsProvided'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkMealsProvided table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkMealsProvided entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>MealsProvided</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>DateOfMeal</b>  [DateTime]</li>
		///  <li><b>InstitutionId</b>  [Int32]</li>
		///  <li><b>VolunteerId</b>  [Int32]</li>
		///  <li><b>NumberOfMeals</b>  [Int32]</li>
		///  <li><b>IsUnscheduled</b>  [bool]</li>
		///  <li><b>NameOfUnscheduled</b>  [string]</li>
		///  <li><b>HowAdded</b>  [string]</li>
		///  <li><b>IsReprinted</b>  [bool]</li>
		///  <li><b>TimeLastPrinted</b>  [DateTime]</li>
		///  <li><b>IsRemovedFromList</b>  [bool]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList(int idValue, ApplicationConnection appCon)
		{
			string sCommand = 
				"Select "
				 + MealsProvidedMsSqlSrv.idField + " As ID"
				 + ", " + MealsProvidedMsSqlSrv.dateOfMealField + " As DateOfMeal"
				 + ", " + MealsProvidedMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + MealsProvidedMsSqlSrv.volunteerIdField + " As VolunteerId"
				 + ", " + MealsProvidedMsSqlSrv.numberOfMealsField + " As NumberOfMeals"
				 + ", " + MealsProvidedMsSqlSrv.isUnscheduledField + " As IsUnscheduled"
				 + ", " + MealsProvidedMsSqlSrv.nameOfUnscheduledField + " As NameOfUnscheduled"
				 + ", " + MealsProvidedMsSqlSrv.howAddedField + " As HowAdded"
				 + ", " + MealsProvidedMsSqlSrv.isReprintedField + " As IsReprinted"
				 + ", " + MealsProvidedMsSqlSrv.timeLastPrintedField + " As TimeLastPrinted"
				 + ", " + MealsProvidedMsSqlSrv.isRemovedFromListField + " As IsRemovedFromList"
				 + ", " + MealsProvidedMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName 
				 + " WHERE Id = '" + idValue + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"MealsProvidedList");
			da.Dispose();
			return ds;
		}
		/// <summary>
		/// 
		/// </summary>
		/// <Params>
		/// <param name="DateOfMeal" type="DateTime"></param>
		/// <param name="InstitutionId" type="System.Int"></param>
		/// <param name="NumberOfMeals" type="System.Int"></param>
		/// </Params>
		/// <returns type="DataSet"/>
		public static DataSet GetMealTicketList(DateTime DateOfMeal, int InstitutionId, int NumberOfMeals, int VolunteerFK)
		{			
			string sCommand = "VtkDailyMealsQuery '" + DateOfMeal.ToString("MM/dd/yyyy") + "', " + InstitutionId.ToString() + ", " + NumberOfMeals.ToString() + ", " + VolunteerFK.ToString();

			//return ApplicationConnection.ExecuteQueryRetry(sCommand, "MealTicketList", 3);

			return ApplicationConnection.ExecuteQuery(sCommand, "MealTicketList");
		}

		/// <summary>
		/// 
		/// </summary>
		/// <Params>
		/// <param name="DateOfMeal" type="DateTime"></param>
		/// <param name="InstitutionId" type="System.Int"></param>
		/// <param name="NumberOfMeals" type="System.Int"></param>
		/// </Params>
		/// <returns type="DataSet"/>
		public static NameObjectCollection GetMealTicketDRList(DateTime DateOfMeal, int InstitutionId, int NumberOfMeals, int VolunteerFK)
		{			
			string sCommand = "VtkDailyMealsQuery '" + DateOfMeal.ToString("MM/dd/yyyy") + "', " + InstitutionId.ToString() + ", " + NumberOfMeals.ToString() + ", " + VolunteerFK.ToString();

//			return ApplicationConnection.ExecuteQueryRetry(sCommand, "MealTicketList", 3);

			SqlCommand sqlCommand = new SqlCommand();

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		#endif
		
		#endregion
		
		#region Section: Utilities
		public static DataSet GetMonthsList()
		{
			int timeSpan;
			DateTime ClosedDate = Vha.Vtk.Kernel.Data.SystemTables.RollupLog.GetClosedMonth();
			DateTime Today = DateTime.Now;
			DataSet ds = new DataSet("ListOfMonths");
			ds.Tables.Add("MonthsList");
			DataTable MonthsTable = ds.Tables["MonthsList"];
			MonthsTable.Columns.Add(new DataColumn("Month", Type.GetType("System.Int32")));
			MonthsTable.Columns.Add(new DataColumn("Year", Type.GetType("System.Int32")));
			MonthsTable.Columns.Add(new DataColumn("Display", Type.GetType("System.String")));

			DataRow MonthsRow;

			//int timeMonthSpan = 0;
			if(ClosedDate.Month > Today.Month)
			{
				timeSpan = Today.Month + (12 - ClosedDate.Month);
			}
			else
				timeSpan = Today.Month - ClosedDate.Month;

			for(int i = (ClosedDate.Month + 1); i <= (timeSpan + ClosedDate.Month); i++)
			{
				MonthsRow = MonthsTable.NewRow();
				if(i > 12)
				{
					MonthsRow["Month"] = i - 12;
					MonthsRow["Year"] = ClosedDate.Year + 1;
					MonthsRow["Display"] = GetMonth(new DateTime((ClosedDate.Year + 1), (i-12), 01).Month) + " " + Convert.ToString(ClosedDate.Year + 1);
					MonthsTable.Rows.Add(MonthsRow);
				}
				else
				{
					MonthsRow["Month"] = i;
					MonthsRow["Year"] = ClosedDate.Year;
					MonthsRow["Display"] = GetMonth(new DateTime(ClosedDate.Year, i, 01).Month) + " " + ClosedDate.Year.ToString();
					MonthsTable.Rows.Add(MonthsRow);
				}
			}
			return ds;
		}
		
		public static string GetMonth(int Month)
		{
			switch(Month)
			{
				case (1):
					return "January";
				case (2):
					return "February";
				case (3):
					return "March";
				case (4):
					return "April";
				case (5):
					return "May";
				case (6):
					return "June";
				case (7):
					return "July";
				case (8):
					return "August";
				case (9):
					return "September";
				case (10):
					return "October";
				case (11):
					return "November";
				case (12):
					return "December";
				default:
					return "UNKNOWN";
			}

		}
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
