using System;
using System.Collections;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Vha.Vtk.WebControlLibrary
{
	/// <summary>
	/// Summary description for Utility.
	/// </summary>
	public class VhaWebUtility
	{
		const string tidString="TransactionID_";

		public VhaWebUtility()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static string GetTransactionId(HttpSessionState mySession)
		{
			// get a unique transaction ID for a web transaction
			int i=1;
			while (true) 
			{
				if (mySession[tidString+i.ToString()]==null)
				{
					mySession.Add(tidString+i.ToString(),
						i.ToString());
					break;
				}
				i++;
			}
			return i.ToString();
		}

		public static void EndTransaction(HttpSessionState mySession, string transactionID) 
		{
			// conclude a web transaction
			if (mySession[tidString+transactionID]!=null) 
			{
				mySession.Remove(tidString+transactionID);
			}
		}

		public static void StateSave(string prefix, System.Web.UI.Page myPage) 
		{
			//TODO: Checkboxlist,...

			foreach (Control c in myPage.Controls) 
			{
				if (c.GetType().ToString()=="System.Web.UI.HtmlControls.HtmlForm") 
				{
					foreach (Control cc in c.Controls) 
					{
						if (cc.EnableViewState) 
						{
							switch(cc.GetType().ToString()) 
							{
								case "System.Web.UI.WebControls.CheckBox":
									myPage.Session.Add(prefix+"_"+cc.ID,((CheckBox)cc).Checked);
									break;
								case "System.Web.UI.WebControls.DropDownList":
									if (((DropDownList)cc).SelectedIndex>-1)
									{
										myPage.Session.Add(prefix+"_"+cc.ID,((DropDownList)cc).SelectedItem.Value);
									}
									break;
								case "System.Web.UI.WebControls.Label":
									myPage.Session.Add(prefix+"_"+cc.ID, ((Label)cc).Text);
									break;
								case "System.Web.UI.WebControls.ListBox":
									if (((ListBox)cc).SelectedIndex>-1)
									{
										if (((ListBox)cc).SelectionMode==ListSelectionMode.Multiple) 
										{
											ArrayList aList = new ArrayList();
											foreach(ListItem li in ((ListBox)cc).Items) 
											{
												if (li.Selected) 
												{
													aList.Add(li.Value);
												}
											}
											myPage.Session.Add(prefix+"_"+cc.ID,aList);
										} 
										else 
										{
											myPage.Session.Add(prefix+"_"+cc.ID,((ListBox)cc).SelectedItem.Value);
										}
									}
									break;
								case "System.Web.UI.WebControls.RadioButtonList":
									if (((RadioButtonList)cc).SelectedIndex>-1)
									{
										myPage.Session.Add(prefix+"_"+cc.ID,((RadioButtonList)cc).SelectedItem.Value);
									}
									break;
								case "System.Web.UI.WebControls.TextBox":
									myPage.Session.Add(prefix+"_"+cc.ID,((TextBox)cc).Text);
									break;
								case "Vha.WebControlLibrary.VhaCompositeDate":
									myPage.Session.Add(prefix+"_"+cc.ID,((VtkCompositeDate)cc).Date);
									break;
								default:
									break;
							}
						}
					}
					break;
				}
			}		
		}

		public static void StateRestore(string prefix, System.Web.UI.Page myPage) 
		{
			foreach (Control c in myPage.Controls) 
			{
				if (c.GetType().ToString()=="System.Web.UI.HtmlControls.HtmlForm") 
				{
					foreach (Control cc in c.Controls) 
					{
						if (cc.EnableViewState) 
						{
							switch(cc.GetType().ToString()) 
							{
								case "System.Web.UI.WebControls.CheckBox":
									if (myPage.Session[prefix+"_"+cc.ID]!=null)
									{
										((CheckBox)cc).Checked=(bool)myPage.Session[prefix+"_"+cc.ID];
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "System.Web.UI.WebControls.DropDownList":
									if (myPage.Session[prefix+"_"+cc.ID]!=null)
									{
										foreach(ListItem li in ((DropDownList)cc).Items) 
										{
											if (li.Value==(string)myPage.Session[prefix+"_"+cc.ID]) 
											{
												li.Selected=true;
												break;
											}
										}
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "System.Web.UI.WebControls.Label":
									if (myPage.Session[prefix+"_"+cc.ID]!=null)
									{	
										((Label)cc).Text=(string)myPage.Session[prefix+"_"+cc.ID];
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "System.Web.UI.WebControls.ListBox":
									if (myPage.Session[prefix+"_"+cc.ID]!=null)
									{
										if (((ListBox)cc).SelectionMode==ListSelectionMode.Multiple) 
										{
											ArrayList aList = (ArrayList)myPage.Session[prefix+"_"+cc.ID];
											foreach(string s in aList) 
											{
												foreach(ListItem li in ((ListBox)cc).Items) 
												{
													if (li.Value==s) 
													{
														li.Selected=true;
														break;
													}
												}
											}

										} else {
											foreach(ListItem li in ((ListBox)cc).Items) 
											{
												if (li.Value==(string)myPage.Session[prefix+"_"+cc.ID]) 
												{
													li.Selected=true;
													break;
												}
											}
										}
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "System.Web.UI.WebControls.RadioButtonList":
									if (myPage.Session[prefix+"_"+cc.ID]!=null) 
									{
										foreach(ListItem li in ((RadioButtonList)cc).Items) 
										{
											if (li.Value==(string)myPage.Session[prefix+"_"+cc.ID]) 
											{
												li.Selected=true;
												break;
											}
										}
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "System.Web.UI.WebControls.TextBox":
									if (myPage.Session[prefix+"_"+cc.ID]!=null)
									{
										((TextBox)cc).Text=(string)myPage.Session[prefix+"_"+cc.ID];
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								case "Vha.WebControlLibrary.VhaCompositeDate":
									if (myPage.Session[prefix+"_"+cc.ID]!=null) 
									{
										((VtkCompositeDate)cc).Date=(DateTime)myPage.Session[prefix+"_"+cc.ID];
										myPage.Session.Remove(prefix+"_"+cc.ID);
									}
									break;
								default:
									break;
							}
						}
					}
					break;
				}
			}		
		}
	}
}
